Package: STATegRa
Type: Package
Title: Classes and methods for multi-omics data integration
Version: 1.48.0
Date: 2018-05-02
Author: STATegra Consortia
Maintainer: David Gomez-Cabrero <david.gomezcabrero@ki.se>, Núria Planell <nuria.planell.picola@navarra.es>
Depends: R (>= 2.10)
Imports: Biobase, gridExtra, ggplot2, methods, stats, grid, MASS,
        calibrate, gplots, edgeR, limma, foreach, affy
Suggests: RUnit, BiocGenerics, knitr (>= 1.6), rmarkdown, BiocStyle (>=
        1.3), roxygen2, doSNOW
VignetteBuilder: knitr
Encoding: UTF-8
biocViews: Software, StatisticalMethod, Clustering, DimensionReduction,
        PrincipalComponent
Description: Classes and tools for multi-omics data integration.
License: GPL-2
LazyLoad: yes
Collate: 'STATegRa_combiningMappings.R' 'STATegRa_fused.R'
        'STATegRa_holistOmics.R' 'STATegRa_omicsCLUST_bioMap.R'
        'STATegRa_omicsCLUST_bioDist.R'
        'STATegRa_omicsCLUST_bioDistW.R' 'STATegRa_omicsNPC.R'
        'STATegRa_omicsNPC_internal.R' 'STATegRa_omicsPCA_caClass.R'
        'STATegRa_omicsPCA_methods.R' 'STATegRa_omicsPCA_plotting.R'
        'STATegRa_package.R'
RoxygenNote: 5.0.1
git_url: https://git.bioconductor.org/packages/STATegRa
git_branch: RELEASE_3_23
git_last_commit: e70783e
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: no
Packaged: 2026-04-29 01:02:22 UTC; biocbuild

####### DATA PREPROCESSING #######

# weightBlocks ------------------------------------------------------------
## Function to weigth the different blocks
## INPUT:
##    xx: (list) List of omics data sets (matrices)
## OUTPUT:
##    (list) List of weigthed omics data sets
setGeneric(
    name="weightBlocks",
    def=function(xx){standardGeneric("weightBlocks")}
)

setMethod(
    f="weightBlocks",
    signature=signature(xx="list"),
    definition=function(xx){
        dataWeight <- lapply(xx,function(X){X/sqrt(ssq(X))})
        return(dataWeight)
    }
)

####### DISCO-SCA APPROACH #######

# scaClass ----------------------------------------------------------------
## Class for Simultaneous Components Analysis Results
## SLOTS:
##     U: (matrix) a matrix whose columns contain the left singular vectors of concatenated data
##     S: (matrix) diagonal matrix  containing the singular values of concatenated data
##     V: (matrix) a matrix whose columns contain the right singular vectors of concatenated data
##     scores: (matrix) scores for SCA decomposition
##     loadings: (matrix) loadings for SCA decomposition
##     ssq: (vector) sum-of-squares of each block
##     VAF: (matrix) VAF for each component in each block and in the contatenated data
setClass(
    Class="scaClass",
    slots=list(U="matrix",
               S="matrix",
               V="matrix",
               scores="matrix",
               loadings="matrix",
               ssqs="numeric",
               VAF="matrix"),
    prototype=list(U=NULL,
                   S=NULL,
                   V=NULL,
                   scores=NULL,
                   loadings=NULL,
                   ssqs=NULL,
                   VAF=NULL)
)

# SCA ------------------------------------------------------------
## Function to calculate the Simultaneous Component Analysis (SCA) and VAF of joined data composed by two blocks
## INPUT:
##     block1: (matrix) data matrix for block1
##     block2: (matrix) data matrix for block2
## OUTPUT:
##     (scaClass) object with the following information
##         U: (matrix) a matrix whose columns contain the left singular vectors of concatenated data
##         S: (matrix) diagonal matrix  containing the singular values of concatenated data
##         V: (matrix) a matrix whose columns contain the right singular vectors of concatenated data
##         scores: (matrix) scores for SCA decomposition
##         loadings: (matrix) loadings for SCA decomposition
##         ssq: (vector) sum-of-squares of each block
##         VAF: (matrix) VAF for each component in each block and in the contatenated data
setGeneric(
    name="SCA",
    def=function(block1,block2){standardGeneric("SCA")}
)

setMethod(
    f="SCA",
    signature=signature(
        block1="matrix",
        block2="matrix"),
    definition=function(block1,block2){
        mat <- rbind(block1,block2)
        svds <- svd(mat)
        scores <- svds$v
        loadings <- svds$u%*%diag(svds$d)
        scares <- list(U=svds$u,S=diag(svds$d),V=svds$v,scores=scores,loadings=loadings)
        ## Sum of squares of each block
        ssq1 <- ssq(block1)
        ssq2 <- ssq(block2)
        ## Calculating VAF
        vaf_block1 <- NULL
        for(i in 1:(ncol(block1)-1)){
            datahat <- scares$S[i,i]*scares$U[1:nrow(block1),i]%*%t(scares$V[,i])
            vaf_block1[i] <- ssq(datahat)/ssq1
        }
        vaf_block2 <- NULL
        for(i in 1:(ncol(block2)-1)){
            datahat <- scares$S[i,i]*scares$U[(nrow(block1)+1):(nrow(block1)+nrow(block2)),i]%*%t(scares$V[,i])
            vaf_block2[i] <- ssq(datahat)/ssq2
        }
        vaf_ow <- (vaf_block1+vaf_block2)/2
        ssqs <- c(ssq1,ssq2)
        names(ssqs) <- c("Block1","Block2")
        VAF <- rbind(vaf_block1,vaf_block2,vaf_ow)
        rownames(VAF) <- c("Block1","Block2","Block1+Block2")
        colnames(VAF) <- paste("C",1:ncol(VAF),sep="")
        ## Assigning names to loadings and scores
        rownames(scores) <- colnames(block1)
        rownames(loadings) <- c(rownames(block1),rownames(block2))
        colnames(scores) <- colnames(loadings) <- paste("Comp.",1:ncol(scores),sep="")
        ## Put info in scaClass
        res <- new("scaClass",U=svds$u,S=diag(svds$d),V=svds$v,scores=scores,loadings=loadings,ssqs=ssqs,VAF=t(VAF))
        return(res)
    }
)

# ssq ---------------------------------------------------------------------
## Function to calculate the sum-of-squares of a given matrix
## INPUT:
##    A: (matrix) input matrix to calculate ssq
## OUTPUT:
##    (numeric) Sum of squares of A matrix
setGeneric(
    name="ssq",
    def=function(A){standardGeneric("ssq")}
)

setMethod(
    f="ssq",
    signature=signature(
        A="matrix"),
    definition=function(A){
        res <- sum(sum(A^2))
        return(res)
    }
)

# PSTRLOSS ----------------------------------------------------------------
# Function to calculate the objective function associated to the pstr2 function
## INPUTS:
##    B: (matrix) rotation matrix
##    mat: (matrix) matrix to rotate
##    Target: (matrix) target to reach
##    W: (matrix) weight matrix (0/1 for resp. unspecified and specified elements of the target)
## OUTPUTS:
##    (numeric) Value of objetive function to minimize [2]
setGeneric(
    name="PSTRLOSS",
    def=function(B,mat,Target,W){standardGeneric("PSTRLOSS")}
)

setMethod(
    f="PSTRLOSS",
    signature=signature(
        B="matrix",
        mat="matrix",
        Target="matrix",
        W="matrix"),
    definition=function(B,mat,Target,W){
        A <- W*(mat%*%B)
        Loss <- ssq(A)
        return(Loss)
    }
)

# PSTR --------------------------------------------------------------------
## Function to calculate an orthogonal rotation matrix (from [2])
## INPUTS:
##    mat: (matrix) matrix to rotate
##    Target: (matrix) target to reach
##    W: (matrix) weight matrix (0/1 for resp. unspecified and specified elements of the target)
##    maxiter: (numeric) maximum number of iterations
##    convergence: (numeric) minimal loss between current and previous iteration
## OUTPUTS:
##    B: (matrix) Orthogonal rotation matrix
##    Loss: (numeric) Value of objetive function to minimize [2]
##    iter: (numeric) Number of necessary iterations for convergence
##    Diff: (numeric) Value of the improvement in the last iteration
setGeneric(
    name="PSTR",
    def=function(mat,Target,W,maxiter,convergence){standardGeneric("PSTR")}
)

setMethod(
    f="PSTR",
    signature=signature(
        mat="matrix",
        Target="matrix",
        W="matrix",
        maxiter="numeric",
        convergence="numeric"),
    definition=function(mat,Target,W,maxiter,convergence){
        ## Random initialization of B
        aux <- svd(matrix(rnorm(ncol(mat)*ncol(mat)),ncol=ncol(mat)))
        Lossc <- PSTRLOSS(aux$u,mat,Target,W)
        Bcurrent <- aux$u
        iter <- 1
        STOP <- 0
        B1 <- t(mat)%*%mat
        alpha <- max(eigen(B1)$values)
        while(STOP==0){
            TargetSter <- mat%*%Bcurrent+W*(Target-mat%*%Bcurrent)
            aux2 <- svd(t(TargetSter)%*%mat)
            B <- aux2$v%*%t(aux2$u)
            if(iter==maxiter){
                STOP <- 1
            }
            Loss <- PSTRLOSS(B,mat,Target,W)
            Diff <- Lossc-Loss
            if (abs(Diff)<convergence){
                STOP <- 1
            }
            iter <- iter+1
            Lossc <- Loss
            Bcurrent <- B
        }
        res <- list(B=B,Loss=Loss,iter=iter,Diff=Diff)
        return(res)
    }
)

# DISCO_SCA ---------------------------------------------------------------
## Function to calculate rotation matrix given the number of exclusive and common components by using the pstr2 function of the official DISCO-SCA page
## INPUT:
##    d1: (numeric) number of Block1 exclusive components
##    d2: (numeric) number of Block2 exclusive components
##    common: (numeric) number of common components between both blocks
##    block1: (matrix) First block of data
##    block2: (matrix) Second block of data
##    maxiter: (numeric) maximum number of iterations (stop criterium)
##    convergence: (numeric) maximum value for convergence (stop criterium)
## OUTPUT:
##    rotMatrix: (matrix) Rotation matrix according the given model
##    loadings1: (matrix) First block loadings
##    loadings2: (matrix) Second block loadings
##    maxdev: (vector) Maximal deviations for each component
##    VAF: (matrix) Proportion of VAF for each component in each block and in the concatenation
##    sca: Results on initial SCA
setGeneric(
    name="DISCO_SCA",
    def=function(d1,d2,common,block1,block2,maxiter=600,convergence=0.0000001){standardGeneric("DISCO_SCA")}
)

setMethod(
    f="DISCO_SCA",
    signature=signature(
        d1="numeric",
        d2="numeric",
        common="numeric",
        block1="matrix",
        block2="matrix"),
    definition=function(d1,d2,common,block1,block2,maxiter,convergence){
        R <- d1+d2+common
        sca_total <- SCA(block1,block2)
        ssq1 <- sca_total@ssqs[1]
        ssq2 <- sca_total@ssqs[2]
        W=rbind(cbind(matrix(0,nrow=nrow(block1),ncol=d1),
                      matrix(1,nrow=nrow(block1),ncol=d2),
                      matrix(0,nrow=nrow(block1),ncol=R-d1-d2)),
                cbind(matrix(1,nrow=nrow(block2),ncol=d1),
                      matrix(0,nrow=nrow(block2),ncol=d2),
                      matrix(0,nrow=nrow(block2),ncol=R-d1-d2)))
        TARGET <- 1-W
        LOSS <- NULL
        BMAT <- NULL
        for(i in 1:2){
            B <- PSTR(mat=sca_total@loadings[,1:R],Target=TARGET,W,maxiter,convergence)$B
            loss <- PSTRLOSS(B,mat=sca_total@loadings[,1:R],Target=TARGET,W)
            LOSS <- cbind(LOSS,loss)
            BMAT <- cbind(BMAT,B)
        }
        k <- which(LOSS==min(LOSS))
        B <- BMAT[,((k[1]-1)*R+1):(k[1]*R)] ## B <- BMAT[((k[1]-1)*R+1):(k[1]*R),]
        Trot <- sca_total@scores[,1:R]%*%B
        Prot <- sca_total@loadings[,1:R]%*%B
        B <- diag(R)
        if(d1>0){
            res1 <- svd(as.matrix(Prot[,1:d1]))
            B[1:d1,1:d1] <- res1$v
        }
        if (d2>0){
            res2 <- svd(as.matrix(Prot[,(d1+1):(d1+d2)]))
            B[(d1+1):(d1+d2),(d1+1):(d1+d2)] <- res2$v
        }
        if (d1+d2<R){
            res3 <- svd(as.matrix(Prot[,(d1+d2+1):R]))
            B[(d1+d2+1):R,(d1+d2+1):R] <- res3$v
        }
        Trot <- Trot[,1:R]%*%B
        Prot <- Prot[,1:R]%*%B
        P1rot <- Prot[1:nrow(block1),]
        P2rot <- Prot[(nrow(block1)+1):(nrow(block1)+nrow(block2)),]
        P1 <- sca_total@loadings[1:nrow(block1),]
        P2 <- sca_total@loadings[(nrow(block1)+1):(nrow(block1)+nrow(block2)),]
        P <- sca_total@loadings
        Ts <- sca_total@scores
        ## Calculate the maximal deviation of distintive and common components
        d1exp <- 0
        d2exp <- 0
        common <- 0
        for(i in 1:R){
            dhat1unr <- sca_total@scores[,i]%*%t(sca_total@loadings[1:nrow(block1),i])
            dhat2unr <- sca_total@scores[,i]%*%t(sca_total@loadings[(nrow(block1)+1):(nrow(block1)+nrow(block2)),i])
            if(i<=R){
                dhat1 <- Trot[,i]%*%t(P1rot[,i])
                dhat2 <- Trot[,i]%*%t(P2rot[,i])
                if(d1>=i){
                    d1exp <- max(d1exp,ssq(dhat1)/ssq1)
                }else if(d1+d2>=i){
                    d2exp <- max(d2exp,ssq(dhat2)/ssq2)
                }
                if(i>d1+d2){
                    common <- max(common,abs((ssq(dhat1)/ssq1)-(ssq(dhat2)/ssq2)))
                }
            }
        }
        maxdev <- c(d1exp,d2exp,common)
        names(maxdev) <- c("Block1","Block2","Common")
        ## Calculate VAF of each component
        if(d1==0 & d2==0){
            if (R==(d1+d2+1)){
                Tc <- as.matrix(Trot[,(d1+d2+1):R]) ## Common scores
                colnames(Tc) <- 1
                P1c <- as.matrix(P1rot[,(d1+d2+1):R]) ## Common loadings Block1
                colnames(P1c) <- 1
                P2c <- as.matrix(P2rot[,(d1+d2+1):R]) ## Common loadings Block2
                colnames(P2c) <- 1
            }else{
                Tc <- Trot[,(d1+d2+1):R] ## Common scores
                colnames(Tc) <- 1:ncol(Tc)
                P1c <- P1rot[,(d1+d2+1):R] ## Common loadings Block1
                colnames(P1c) <- 1:ncol(P1c)
                P2c <- P2rot[,(d1+d2+1):R] ## Common loadings Block2
                colnames(P2c) <- 1:ncol(P2c)
            }
            T1a <- T2a <- P1a <- P2a <- NULL
            ## Common VAF
            ssq_common1 <- ssq_common2 <- NULL
            for(i in 1:(R-d1-d2)){
                ssq_common1 <- c(ssq_common1,ssq(P1c[,i]%*%t(Tc[,i])))
                ssq_common2 <- c(ssq_common2,ssq(P2c[,i]%*%t(Tc[,i])))
            }
            ssq_common <- rbind(ssq_common1,ssq_common2)
            rownames(ssq_common) <- c("Block1","Block2")
            colnames(ssq_common) <- paste("Comp.",1:(R-d1-d2),sep="")
            ssq_block <- NULL
            ssq_cross <- NULL
        } else{
            if (R==(d1+d2+1)){
                Tc <- as.matrix(Trot[,(d1+d2+1):R]) ## Common scores
                colnames(Tc) <- 1
                P1c <- as.matrix(P1rot[,(d1+d2+1):R]) ## Common loadings Block1
                colnames(P1c) <- 1
                P2c <- as.matrix(P2rot[,(d1+d2+1):R]) ## Common loadings Block2
                colnames(P2c) <- 1
            }else{
                Tc <- Trot[,(d1+d2+1):R] ## Common scores
                colnames(Tc) <- 1:ncol(Tc)
                P1c <- P1rot[,(d1+d2+1):R] ## Common loadings Block1
                colnames(P1c) <- 1:ncol(P1c)
                P2c <- P2rot[,(d1+d2+1):R] ## Common loadings Block2
                colnames(P2c) <- 1:ncol(P2c)
            }
            if (d1==1){
                T1a <- as.matrix(Trot[,1:d1]) ## Individual scores Block1
                colnames(T1a) <- 1
                P1a <- as.matrix(P1rot[,1:d1]) ## Individual loadings block1
                colnames(P1a) <- 1
                P2a1 <- as.matrix(P2rot[,1:d1]) ## Cross loadings Block2
                colnames(P2a1) <- 1
            }else{
                T1a <- Trot[,1:d1] ## Individual scores Block1
                colnames(T1a) <- 1:ncol(T1a)
                P1a <- P1rot[,1:d1] ## Individual loadings block1
                colnames(P1a) <- 1:ncol(P1a)
                P2a1 <- P2rot[,1:d1] ## Cross loadings Block2
                colnames(P2a1) <- 1:ncol(P2a1)
            }
            if (d2==1){
                T2a <- as.matrix(Trot[,(d1+1):(d1+d2)]) ## Individual scores Block2
                colnames(T2a) <- 1
                P1a2 <- as.matrix(P1rot[,(d1+1):(d1+d2)]) ## Cross loadings Block1
                colnames(P1a2) <- 1
                P2a <- as.matrix(P2rot[,(d1+1):(d1+d2)]) ## Individual loadings Block2
                colnames(P2a) <- 1
            }else{
                T2a <- Trot[,(d1+1):(d1+d2)] ## Individual scores Block2
                colnames(T2a) <- 1:ncol(T2a)
                P1a2 <- P1rot[,(d1+1):(d1+d2)] ## Cross loadings Block1
                colnames(P1a2) <- 1:ncol(P1a2)
                P2a <- P2rot[,(d1+1):(d1+d2)] ## Individual loadings Block2
                colnames(P2a) <- 1:ncol(P2a)
            }
            ## Common VAF
            ssq_common1 <- ssq_common2 <- NULL
            for(i in 1:(R-d1-d2)){
                ssq_common1 <- c(ssq_common1,ssq(P1c[,i]%*%t(Tc[,i])))
                ssq_common2 <- c(ssq_common2,ssq(P2c[,i]%*%t(Tc[,i])))
            }
            ssq_common <- rbind(ssq_common1,ssq_common2)
            rownames(ssq_common) <- c("Block1","Block2")
            colnames(ssq_common) <- paste("Comp.",1:(R-d1-d2),sep="")
            ## Distinctive VAF
            ssq_block1 <- ssq_block2 <- NULL
            if(d1>0){
                for(i in 1:d1){
                    ssq_block1 <- c(ssq_block1,ssq(P1a[,i]%*%t(T1a[,i])))
                }
            }
            if(d2>0){
                for(i in 1:d2){
                    ssq_block2 <- c(ssq_block2,ssq(P2a[,i]%*%t(T2a[,i])))
                }
            }
            if(d1>d2){
                ssq_block2 <- c(ssq_block2,rep(0,d1-d2))
            } else if (d1<d2){
                ssq_block1 <- c(ssq_block1,rep(0,d2-d1))
            }
            ssq_block <- rbind(ssq_block1,ssq_block2)
            rownames(ssq_block) <- c("Block1","Block2")
            colnames(ssq_block) <- paste("Comp.",1:max(d1,d2),sep="")
            ## Cross VAF
            ssq_cross1 <- ssq_cross2 <- NULL
            if(d2>0){
                for(i in 1:d2){
                    ssq_cross1 <- c(ssq_cross1,ssq(P1a2[,i]%*%t(T2a[,i])))
                }
            }
            if(d1>0){
                for(i in 1:d1){
                    ssq_cross2 <- c(ssq_cross2,ssq(P2a1[,i]%*%t(T1a[,i])))
                }
            }
            if(d1>d2){
                ssq_cross1 <- c(ssq_cross1,rep(0,d1-d2))
            } else if (d1<d2){
                ssq_cross2 <- c(ssq_cross2,rep(0,d2-d1))
            }
            ssq_cross <- rbind(ssq_cross1,ssq_cross2)
            rownames(ssq_cross) <- c("Block1","Block2")
            colnames(ssq_cross) <- paste("Comp.",1:max(d1,d2),sep="")
        }
        ## Creating output
        res <- list(scores=list(common=Tc,dist=list(Block1=T1a,Block2=T2a)),
                    loadings=list(common=list(Block1=P1c,Block2=P2c),dist=list(Block1=P1a,Block2=P2a)),
                    VAF=list(common=ssq_common,dist=list(Block1=ssq_block["Block1",],Block2=ssq_block["Block2",],cross=ssq_cross)),
                    rotMatrix=B,
                    maxdev=maxdev,
                    sca=sca_total)
        return(res)
    }
)

####### JIVE APPROACH #######

# PCA.genes ---------------------------------------------------------------
## INPUT:
##    Data: (matrix) matrix to perform PCA
## OUTPUT:
##    eigen: Eigen values
##    var.exp: Explained variance
##    scores: Matrix of scores
##    loadings: Matrix of loadings
setGeneric(
    name="PCA.genes",
    def=function(Data){standardGeneric("PCA.genes")}
)

setMethod(
    f="PCA.genes",
    signature=signature(
        Data="matrix"),
    definition=function(Data){
        X <- t(Data)
        n <- ncol(X) #number of features
        p <- nrow(X) #number of samples
        offset <- apply(X,2,mean) #feature mean
        #Xoff <- X-(cbind(matrix(1,p,1))%*%rbind(offset))
        
        Xoff <- X-offset #substract mean column
        
        #eigen command sorts the eigenvalues in decreasing orden.
        eigen <- eigen(Xoff%*%t(Xoff)/(p-1))
        var <- cbind(eigen$values/sum(eigen$values),cumsum(eigen$values/sum(eigen$values)))
        colnames(var) <- c("%var","%accumvar")
        loadings2 <- eigen$vectors
        scores2 <- t(Xoff)%*%loadings2
        normas2 <- sqrt(apply(scores2^2,2,sum))
        scores1 <- loadings2%*%diag(normas2)
        loadings1 <- scores2%*%diag(1/normas2)
        rownames(var) <- colnames(loadings1) <- colnames(scores1) <- paste("Comp.",1:ncol(scores1),sep="")
        output <- list(eigen,var,scores1,loadings1)
        names(output) <- c("eigen","var.exp","scores","loadings")
        return(output)
    }
)

# JIVE --------------------------------------------------------------------
## Function to do JIVE analysis of any number of blocks of data
## INPUT:
##    Data: (List) List of data matrices (one for each block and sharing number of columns)
##    r: (numeric) number of common components
##    rIndiv: (vector) Vector with number of individual components of each block (same length than length of Data)
##    ConvergenceThresh: (numeric) Threshold for convergence (accepted LOSS value)
##    maxIter: (numeric) Maximum number of iterations
## OUTPUT:
##    J: (matrix) Joint structure, of dimension (d1+d2+...+dk, n)
##    A: (matrix) Individual structure
setGeneric(
    name="JIVE",
    def=function(Data,r,rIndiv,ConvergenceThresh=10^(-10),maxIter=1000){standardGeneric("JIVE")}
)

setMethod(
    f="JIVE",
    signature=signature(
        Data="list",
        r="numeric",
        rIndiv="numeric"),
    definition=function(Data,r,rIndiv,ConvergenceThresh=10^(-10),maxIter=1000){
      
        ## Number of blocks (datasets)
        nData <- length(Data)
        
        ## Getting dimensions of matrices
        dataSizesOr <- as.data.frame(do.call("rbind",lapply(Data,dim)))
        colnames(dataSizesOr) <- c("rows","columns")
        
        ## Checking if all datasets has the same number o columns (samples)
        n <- unique(dataSizesOr$columns)
        if(length(n)>1){
            stop("Data must have same number of columns(samples)")
        }
        if (nData != length(rIndiv)){
            stop("Number of individual components for each block must be specify")
        }
        
        ## Dimension reducing transformation for high-dimensional data
        origU <- list()
        dataSizes <- dataSizesOr
        for(j in 1:nData){
            if(dataSizes$rows[j]>n){
                aux <- svd(Data[[j]],nu=ncol(Data[[j]])-1,nv=ncol(Data[[j]])-1)
                Data[[j]] <- diag(aux$d[1:(ncol(Data[[j]])-1)])%*%t(aux$v)
                dataSizes$rows[j] <- nrow(Data[[j]])
                origU[[j]] <- aux$u
            }
        }
        Tot <- do.call("rbind",Data)
        A <- matrix(0,nrow=sum(dataSizes$rows),ncol=n)
        X_est <- 0
        for(iter in 1:maxIter){
            if(r>0){
                aux2 <- svd(Tot,nu=r,nv=r)
                J <- aux2$u%*%diag(aux2$d[1:r],nrow=r)%*%t(aux2$v)
            } else{
                aux2 <- svd(Tot,nu=r,nv=r)
                J <- Tot
            }
            for(k in 1:nData){
                if(rIndiv[k]>0){
                    indexes <- max(1,dataSizes$rows[k-1]+1):sum(dataSizes$rows[1:k])
                    U <- Data[[k]]-J[indexes,]
                    aux3 <- svd(U-U%*%aux2$v%*%t(aux2$v),nu=rIndiv[k],nv=rIndiv[k])
                    A[indexes,] <- aux3$u%*%diag(aux3$d[1:rIndiv[k]],nrow=rIndiv[k])%*%t(aux3$v)
                    Tot[indexes,] <- Data[[k]] - A[indexes,]
                }
            }
            if(norm(X_est-J-A,type="F")^2<ConvergenceThresh){
                break;
            }
            X_est <- J+A
            if(iter==maxIter){
                warning("Maximum number of iterations reached before convergence")
            }
        }
        
        ## Transform back to original space
        origJ <- origA <- NULL
        for(m in 1:nData){
            indexes <- max(1,dataSizes$rows[m-1]+1):sum(dataSizes$rows[1:m])
            Joint <- J[indexes,]
            Indiv <- A[indexes,]
            if(length(origU)!=0){ ## A dimension reducing is applied
                Joint <- origU[[m]]%*%Joint
                Indiv <- origU[[m]]%*%Indiv
            }
            origJ <- rbind(origJ,Joint)
            origA <- rbind(origA,Indiv)
        }
        ## PCA of each matrix to extract the components (scores & loadings)
        pcaJ <- PCA.genes(origJ)
        commonVAF <- as.matrix(pcaJ$var.exp[1:r,"%var"])
        rownames(commonVAF) <- 1:nrow(commonVAF)
        colnames(commonVAF) <- "common"
        A1 <- origA[1:dataSizesOr$rows[1],]
        A2 <- origA[(dataSizesOr$rows[1]+1):sum(dataSizesOr$rows),]
        pcaA1 <- PCA.genes(A1)
        pcaA2 <- PCA.genes(A2)
        if(!all(A==0)){
            distVAF1 <- as.matrix(pcaA1$var.exp[1:rIndiv[1],"%var"])
            distVAF2 <- as.matrix(pcaA2$var.exp[1:rIndiv[2],"%var"])
            rownames(distVAF1) <- 1:nrow(distVAF1)
            rownames(distVAF2) <- 1:nrow(distVAF2)
            colnames(distVAF1) <- colnames(distVAF2) <-"distintive"
        }else{
            distVAF <- NULL
        }
        res <- list(J=J,
                    A=A,
                    commonComps=r,
                    distComps=rIndiv,
                    scores=list(common=as.matrix(pcaJ$scores[,1:r]),
                                dist=list(Block1=as.matrix(pcaA1$scores[,1:rIndiv[1]]),Block2=as.matrix(pcaA2$scores[,1:rIndiv[2]]))),
                    loadings=list(common=list(Block1=as.matrix(pcaJ$loadings[1:dataSizesOr$rows[1],1:r]),
                                              Block2=as.matrix(pcaJ$loadings[(dataSizesOr$rows[1]+1):nrow(pcaJ$loadings),1:r])),
                                  dist=list(Block1=as.matrix(pcaA1$loadings[,1:rIndiv[1]]),Block2=as.matrix(pcaA2$loadings[,1:rIndiv[2]]))),
                    VAF=list(common=commonVAF,dist=list(Block1=distVAF1,Block2=distVAF2)))
        return(res)
    }
)

####### O2PLS APPROACH #######

# PSVD --------------------------------------------------------------------
## Calculates rank R approximation of svd of AB' -- SVD of covariance matrix X_1'X_2
## Calculates a base for the predictive space
## INPUT:
##    A: (matrix) First block of data
##    B: (matrix) Second block of data
##    R: (numeric) rank.
## OUTPUT:
##    A: (matrix) Left singular vectors of the decomposition
##    S: (matrix) Diagonal matrix of decomposition eigen values
##    B: (matrix) Rigth singular vector of the decomposition
setGeneric(
    name="PSVD",
    def=function(A,B,R){standardGeneric("PSVD")}
)

setMethod(
    f="PSVD",
    signature=signature(
        A="matrix",
        B="matrix",
        R="numeric"),
    definition=function(A,B,R){
        qrA <- qr(A,0)
        qrB <- qr(B,0)
        svd1 <- svd(qr.R(qrA)%*%t(qr.R(qrB)))
        res <- list(A=qr.Q(qrA)%*%svd1$u,S=diag(svd1$d),B=qr.Q(qrB)%*%svd1$v)
        return(res)
    }
)

# O2PLS -------------------------------------------------------------------
## Function to perform O2PLS analysis
## INPUT:
##    X1: (matrix) First block of data
##    X2: (matrix) Second block of data
##    Rcommon: (numeric) Number of common components
##    Rspecific: (numeric) Number of specific components
## OUTPUT:
##    weights: (list) Weigth matrices
##
##    scores: (matrix) Scores matrix
##    loadings: (matrix) LOadings matrix
##    vaf: (matrix)
setGeneric(
    name="O2PLS",
    def=function(X1,X2,Rcommon,Rspec){standardGeneric("O2PLS")}
)

setMethod(
    f="O2PLS",
    signature=signature(
        X1="matrix",
        X2="matrix",
        Rcommon="numeric",
        Rspec="numeric"),
    definition=function(X1,X2,Rcommon,Rspec){
        ## The code is performed for matrices with samples in rows
        X <- t(X1)
        Y <- t(X2)
        LV <- Rcommon
        LVX <- Rspec[1]
        LVY <- Rspec[2]
        if(LVX==0){
            T_Yosc <- matrix(0,nrow=nrow(Y),ncol=LVX)
            P_Yosc <- matrix(0,nrow=ncol(X),ncol=LVX)
            W_Yosc <- matrix(0,nrow=ncol(X),ncol=LVX)
        }
        if(LVY==0){
            T_Yosc <- matrix(0,nrow=nrow(X),ncol=LVY)
            P_Yosc <- matrix(0,nrow=ncol(Y),ncol=LVY)
            W_Yosc <- matrix(0,nrow=ncol(Y),ncol=LVY)
        }
        X_true <- X
        Y_true <- Y
        svd1 <- svd(t(Y)%*%X,nu=LV,nv=LV)
        T_Yosc <- NULL
        P_Yosc <- NULL
        W_Yosc <- NULL
        ## Remove orthogonal components from X sequentially
        for(lv in 1:LVX){
            TT <- X%*%svd1$v
            E_XY <- X-TT%*%t(svd1$v)
            svd2 <- svd(t(E_XY)%*%TT,nu=1,nv=1)
            t_Yosc <- X%*%svd2$u
            p_Yosc <- (t(X)%*%t_Yosc)/as.numeric((t(t_Yosc)%*%t_Yosc))
            X <- X - t_Yosc%*%t(p_Yosc)
            ## Collect the orthogonal components
            T_Yosc <- cbind(T_Yosc,t_Yosc)
            P_Yosc <- cbind(P_Yosc,p_Yosc)
            W_Yosc <- cbind(W_Yosc,svd2$u)
        }
        ## Update T again (since X is changed)
        TT <- X%*%svd1$v
        U_Xosc <- NULL
        P_Xosc <- NULL
        C_Xosc <- NULL
        ## calculate LVY orthogonal Y components
        for(lv in 1:LVY){
            UU <- Y%*%svd1$u
            F_XY <- Y-UU%*%t(svd1$u)
            svd3 <- svd(t(F_XY)%*%UU,nu=1,nv=1)
            u_Xosc <- Y%*%svd3$u
            p_Xosc <- (t(Y)%*%u_Xosc)/as.numeric((t(u_Xosc)%*%u_Xosc))
            Y <- Y-u_Xosc%*%t(p_Xosc)
            ## Collect the orthogonal components
            U_Xosc <- cbind(U_Xosc,u_Xosc)
            P_Xosc <- cbind(P_Xosc,p_Xosc)
            C_Xosc <- cbind(C_Xosc,svd3$u)
        }
        ## Update U again (since Y is changed)
        UU <- Y%*%svd1$u
        ## Repeat steps 1,2,4 before step 6
        svd4 <- svd(t(Y)%*%X,nu=LV,nv=LV)
        TT <- X%*%svd4$v
        UU <- Y%*%svd4$u
        B_U <- solve(t(UU)%*%UU)%*%t(UU)%*%TT
        B_T <- solve(t(TT)%*%TT)%*%t(TT)%*%UU
        ## Other model components
        EE <- X_true-TT%*%t(svd4$v)-T_Yosc%*%t(P_Yosc)
        FF <- Y_true-UU%*%t(svd4$u)-U_Xosc%*%t(P_Xosc)
        H_TU <- TT-UU%*%B_U
        H_UT <- UU-TT%*%B_T
        Y_hat <- TT%*%B_T%*%t(svd4$u)
        X_hat <- UU%*%B_U%*%t(svd4$v)
        ## Statistics
        ssqX_true <- ssq(X_true)
        ssqY_true <- ssq(Y_true)
        R2X <- 1-(ssq(EE)/ssqX_true)
        R2Y <- 1-(ssq(FF)/ssqY_true)
        R2Xcorr <- ssq(TT%*%t(svd4$v))/ssqX_true
        R2Ycorr <- ssq(UU%*%t(svd4$u))/ssqY_true
        R2X_Y0 <- ssq(T_Yosc%*%t(P_Yosc))/ssqX_true
        R2Y_X0 <- ssq(U_Xosc%*%t(P_Xosc))/ssqY_true
        R2Xhat <- 1-(ssq(UU%*%B_U%*%t(svd4$v)-X_true)/ssqX_true)
        R2Yhat <- 1-(ssq(TT%*%B_T%*%t(svd4$u)-Y_true)/ssqY_true)
        res <- list(scores=list(common=list(Block1=TT,Block2=UU),
                                dist=list(Block1=T_Yosc,Block2=U_Xosc)),
                    loadings=list(common=list(Block1=W_Yosc,Block2=C_Xosc),
                                  dist=list(Block1=P_Yosc,Block2=P_Xosc)))
        return(res)
    }
)

# omicsCompAnalysis -------------------------------------------------------
## INPUT:
##    ######...: Set of expression sets one for each omic dataset ## De momento este no que no se como declararlo
##    Input: (list) List of expression sets one for each omic dataset
##    Names: (vector) Names assigned to each omic dataset
##    method=c("DISCOSCA","JIVE","O2PLS"): (character) Method used for the analysis
##    Rcommon: (numeric) NUmber of common components
##    Rspecific: (vector) Number of specific components, one for each omic dataset
##    convThres: (numeric) Convergence threshold (only used with DISCOSCA and O2PLS)
##    maxIter: (numeric) Maximum number of iterations (only used with DISCOSCA and O2PLS)
##    center=c("PERBLOCKS","ALLBLOCKS"): Has center be applied before analysis?
##    scale=c("PERBLOCKS","ALLBLOCKS"): Has scale be applied before analysis?
##    weight: (logical): Have blocks be weighted?
## OUTPUT:
##    An object of class 'caClass'
#' @export
#' @import Biobase
#' @title Components analysis for multiple objects
#' @aliases omicsCompAnalysis,list,character,character,numeric,numeric-method
#' @description
#' This function performs a components analysis of object wise omics data to understand the mechanisms that underlay all the data blocks under study (common mechanisms) and the mechanisms underlying each of the data block independently (distinctive mechanisms). This analysis include both, the preprocessing of data and the components analysis by using three different methodologies.
#' @usage omicsCompAnalysis(Input, Names, method, Rcommon, Rspecific, 
#'                          convThres=1e-10, maxIter=600, center=FALSE, 
#'                          scale=FALSE, weight=FALSE)
#' 
#' @param Input List of \code{ExpressionSet} objects, one for each block of data.
#' @param Names Character vector giving names for each Input object.
#' @param method Method to use for analysis (either "DISCOSCA", "JIVE", or "O2PLS").
#' @param Rcommon Number of common components between all blocks
#' @param Rspecific Vector giving number of unique components for each input block
#' @param convThres Stop criteria for convergence
#' @param maxIter Maximum number of iterations
#' @param center Character (or FALSE) specifying which (if any) centering will be applied before analysis. Choices are "PERBLOCKS" (each block separately) or "ALLBLOCKS" (all data together).
#' @param scale Character (or FALSE) specifying which (if any) scaling will be applied before analysis. Choices are "PERBLOCKS" (each block separately) or "ALLBLOCKS" (all data together).
#' @param weight Logical indicating whether weighting is to be done.
#' 
#' @return An object of class \code{\link{caClass-class}}.
#' 
#' @author Patricia Sebastian Leon
#' 
#' @examples
#' data("STATegRa_S3")
#' B1 <- createOmicsExpressionSet(Data=Block1.PCA,pData=ed.PCA,
#' pDataDescr=c("classname"))
#' B2 <- createOmicsExpressionSet(Data=Block2.PCA,
#'                                pData=ed.PCA,pDataDescr=c("classname"))
#' # Omics components analysis
#' discoRes <- omicsCompAnalysis(Input=list(B1,B2),Names=c("expr","mirna"),
#'                               method="DISCOSCA",Rcommon=2,Rspecific=c(2,2),
#'                               center=TRUE,scale=TRUE,weight=TRUE)
#' jiveRes <- omicsCompAnalysis(Input=list(B1,B2),Names=c("expr","mirna"),
#'                              method="JIVE",Rcommon=2,Rspecific=c(2,2),
#'                              center=TRUE,scale=TRUE,weight=TRUE)
#' o2plsRes <- omicsCompAnalysis(Input=list(B1,B2),Names=c("expr","mirna"),
#'                               method="O2PLS",Rcommon=2,Rspecific=c(2,2),
#'                               center=TRUE,scale=TRUE,weight=TRUE)
setGeneric(
    name="omicsCompAnalysis",
    def=function(Input,Names,method,Rcommon,Rspecific,convThres=1e-10,maxIter=600,center=FALSE,scale=FALSE,weight=FALSE){
        standardGeneric("omicsCompAnalysis")}
)

setMethod(
    f="omicsCompAnalysis",
    signature=signature(
        Input="list",
        Names="character",
        method="character",
        Rcommon="numeric",
        Rspecific="numeric"),
    definition=function(Input,Names,method,Rcommon,Rspecific,convThres,maxIter,center,scale,weight){
        ## STEP1: Reading and checking provided data
        ## Expression sets
        orData <- Input
        if(!all(do.call("c",lapply(orData,FUN=class))=="ExpressionSet")){
            warning("Please provide a list of expression sets")
            return();
        }
        ## Converting expression sets list in matrices list
        Data <- lapply(orData,exprs)
        ## Number of Expression sets
        nData <- length(Data)
        ## Expression sets names
        if (is.null(Names)){
            Names <- paste("Block",1:nData)
        }
        ## Check is number of columns/samples is the same in all datasets
        if(length(unique(do.call("c",lapply(Data,FUN=ncol))))!=1){
            warning("Number of samples is not the same for all data sets")
            return();
        }
        prepros <- NULL
        ## STEP2: Removing constant rows if any
        Data <- lapply(Data,function(xx){
            index <- which(apply(xx,1,sd)==0)
            if(length(index)>0){
                print(paste("The following features are eliminated because are constant:",length(index),"\n",paste(names(index),collapse=", ")))
                xx <- xx[-index,]
            }
            return(xx)
        })
        ## STEP3: Center & scale datasets if selected
        if(center & scale){
            prepros <- c(prepros,"centered & scaled")
            Data <- lapply(Data,function(x){t(scale(t(x),center=TRUE,scale=TRUE))})
        }else{
            if(center){
                prepros <- c(prepros,"centered")
                Data <- lapply(Data,function(x){t(scale(t(x),center=TRUE,scale=FALSE))})
            }
            ## STEP3: Scale datasets if selected
            if(scale){
                prepros <- c(prepros,"scaled")
                Data <- lapply(Data,function(x){t(scale(t(x),center=FALSE,scale=TRUE))})
            }
        }
        ## STEP4: Weight datasets if selected
        if(weight){
            prepros <- c(prepros,"weighted")
            Data <- weightBlocks(Data)
        }
        if(is.null(prepros)){
            prepros <- "none"
        }
        ## STEP5: Apply selected method to data
        method <- match.arg(method,choices=c("DISCOSCA","JIVE","O2PLS"))
        if(method=="DISCOSCA"){
            auxres <- DISCO_SCA(d1=Rspecific[1],d2=Rspecific[2],common=Rcommon,block1=Data[[1]],block2=Data[[2]],maxiter=maxIter,
                                convergence=convThres)
            res <- new("caClass",
                       InitialData=orData,
                       Names=Names,
                       preprocessing=prepros,
                       preproData=Data,
                       caMethod="DISCO-SCA",
                       commonComps=Rcommon,
                       distComps=Rspecific,
                       scores=auxres$scores,
                       loadings=auxres$loadings,
                       VAF=auxres$VAF,
                       others=list(rotMatrix=auxres$rotMatrix,maxdev=auxres$maxdev,sca=auxres$sca))
        } else if (method=="JIVE"){
            auxres <- JIVE(Data=Data,r=Rcommon,rIndiv=Rspecific,ConvergenceThresh=convThres,maxIter=maxIter)
            res <- new("caClass",
                       InitialData=orData,
                       Names=Names,
                       preprocessing=prepros,
                       preproData=Data,
                       caMethod="JIVE",
                       commonComps=Rcommon,
                       distComps=Rspecific,
                       scores=auxres$scores,
                       loadings=auxres$loadings,
                       VAF=auxres$VAF,
                       others=list(J=auxres$J,A=auxres$A))
        } else if (method=="O2PLS"){
            auxres <- O2PLS(X1=Data[[1]],X2=Data[[2]],Rcommon=Rcommon,Rspec=Rspecific)
            res <- new("caClass",
                       InitialData=orData,
                       Names=Names,
                       preprocessing=prepros,
                       preproData=Data,
                       caMethod="O2PLS",
                       commonComps=Rcommon,
                       distComps=Rspecific,
                       scores=auxres$scores,
                       loadings=auxres$loadings,
                       VAF=list(),
                       others=list())
        }
        return(res)
    }
)

####### MODEL SELECTION #######

# selectCommonComps ------------------------------------------------------------
## INPUT:
## Input: (list) List of expression sets one for each omic dataset
## Rmax: (numeric) Maximum number of common components
## OUTPUT:
## (numeric) Optimal number of common components
## @import ggplot2
## @import MASS
## @export
## @title Select common components in two data blocks
## @aliases selectCommonComps,matrix,matrix,numeric-method
## @description 
## This function applies a Simultaneous Component Analysis (SCA). The idea is that the scores for both blocks should have a similar behaviour if the components are in the common mode. Evaluation is by the ratios between the explained variances (SSQ) of each block and the estimator. The highest component count with 0.8 < ratio < 1.5 is selected.
## @usage selectCommonComps(Input, Rmax)
## @param Input List of omics data; omics data as data matrix (with samples in columns and features in rows)
## @param Rmax Maximum number of common components to find
## @return A list with components:
## \describe{
##      \item{commonComps}{Optimal number of common components}
##      \item{ssqs}{Matrix of SSQ for each block and estimator}
##      \item{pssq}{\code{\link{ggplot}} object showing SSQ for each block and estimator}
##      \item{pratios}{\code{\link{ggplot}} object showing SSQ ratios between each block and estimator}
## }
## @author Patricia Sebastian-Leon
## @examples
## data(STATegRa_S3)
## cc <- selectCommonComps(Input=list(Block1.PCA,Block2.PCA), Rmax=3)
## cc$common
## cc$pssq
## cc$pratios
setGeneric(
    name="selectCommonComps",
    def=function(Input,Rmax){standardGeneric("selectCommonComps")}
)

setMethod(
    f="selectCommonComps",
    signature=signature(
        Input="list",
        Rmax="numeric"),
    definition=function(Input,Rmax){
        #Bind the different data sets
        cb <- do.call(rbind, Input)
        svd1 <- svd(cb,nu=Rmax,nv=Rmax)
        all_ssqs <- NULL
        #Get loadings
        for(k in 1:Rmax){
          if(k==1){
            loadings <- as.matrix(svd1$u[,1:k]*diag(svd1$d)[1:k,1:k])
          }else{
            loadings <- svd1$u[,1:k]%*%diag(svd1$d)[1:k,1:k]
          }
          l <- list() #loadings per block
          scores <- list() #scores per block
          estimCont <- rep(list(list()),length(Input)) # estimate common blocks using their counterpart loadings
          ssqs_estim <- list()
          for(j in 1:length(Input)){
            if(j==1){
              l[[j]] <- as.matrix(loadings[1:nrow(Input[[j]]),])
            }else{
              l[[j]] <- as.matrix(loadings[nrow(Input[[j-1]])+1:nrow(Input[[j]]),])
            }
            ## Calculate scores per block from the loadings
            scores[[j]] <- ginv(t(l[[j]])%*%l[[j]])%*%t(l[[j]])%*%Input[[j]]
          }
          ## Estimate common blocks using their scores or counterpart loadings
          for(i in 1:length(Input)){
            ssqs <- NULL
            for(j in 1:length(Input)){
              estimCont[[i]][[j]] <- l[[i]]%*%scores[[j]]
              ssqs <- c(ssqs,ssq(estimCont[[i]][[j]]))
            }
            ssqs_estim[[i]] <- ssqs
          }
          all_ssqs <- rbind(all_ssqs, unlist(ssqs_estim))
        }
        rownames(all_ssqs) <- 1:Rmax
        colnames(all_ssqs) <- paste("est",rep(1:length(Input),each=length(Input)),1:length(Input),sep="_")
        
        ## Plot ssqs for estimated blocks
        dfssq <- data.frame(ssq=c(all_ssqs),comps=rep(rownames(all_ssqs),ncol(all_ssqs)),block=rep(colnames(all_ssqs),each=nrow(all_ssqs)))
        p <- ggplot(dfssq,aes(x=comps,y=ssq,fill=block))+
            geom_bar(stat="identity",position="dodge")+
            xlab("Number of common components")+
            ylab("ssq of estimated block")
        
        ## Determine acceptable ratios for allowed differences between blocks predictions
        r <- NULL
        rnames <- NULL
        for(i in 1:length(Input)){
          for(j in 1:length(Input))
            if(j!=i){
              r <- cbind(r,all_ssqs[,paste("est",i,i,sep="_")]/all_ssqs[,paste("est",i,j,sep="_")])
              rnames <- c(rnames, paste("ratio Block ",i,"/",j,sep=""))
            }
        }
        colnames(r) <- rnames
        ssqratio <- data.frame(ratio=c(r),comp=rep(rownames(r),ncol(r)),block=rep(colnames(r),each=nrow(r)))
        p2 <- ggplot(ssqratio,aes(x=comp,y=ratio,fill=block))+
            geom_bar(stat="identity",position="dodge")+
            xlab("Number of common components")+
            ylab("Ratio between SSQ/estSSQ")+
            geom_hline(aes(yintercept=0.8),colour="black",linetype="dashed")+
            geom_hline(aes(yintercept=1.2),colour="black",linetype="dashed")
        
        common <- 0
        for(i in 1:Rmax){
          rvalues <- ssqratio$ratio[ssqratio$comp==i]
          if(sum(rvalues > 0.8)==length(rvalues) & sum(rvalues < 1.25)==length(rvalues)){
            common <- c(common,i)
          }
        }
        common <- max(common)
        res <- list(commonComps=common,ssqs=ssqs,pssq=p,pratios=p2)
        return(res)
    }
)

# PCA.selection -----------------------------------------------------------
## INPUT:
## Data: (matrix) matrix with the omic data
## fac.sel: (character) Criterium for selecting number of components c("%accum", "single%", "rel.abs", "fixed.num")
## varthreshold: (numeric) Threshold for the selection of components in "%accum", "single%" criteriums
## nvar: (numeric) Threshold applied when the option "abs.val" is selected
## PCnum: (numeric) Fixed number of components to select with the option"fixed.num"
## OUTPUT: (list)
## - PCAres: (list) Results of the PCA of the data
## - numComps: (numeric) Number of selected components applying the selected criterium
## desdocumentem la funcio. Funcio interna.
## @export
## @title Select an optimal number of components using PCA
## @aliases PCA.selection,matrix,character-method
## @description 
## Selects the optimal number of components from data using PCA. There are four different criteria available: accumulated variance explained, individual explained variance of each component, absolute value of variability or fixed number of components.
## @usage PCA.selection(Data, fac.sel, varthreshold=NULL, nvar=NULL, PCnum=NULL)
## @param Data Data matrix (with samples in columns and features in rows)
## @param fac.sel Selection criteria ("\%accum", "single\%", "rel.abs", "fixed.num")
## @param varthreshold Threshold for "\%accum" or "single\%" criteria
## @param nvar Threshold for "rel.abs"
## @param PCnum Fixed number of components for "fixed.num"
## @return List containing:
## \describe{
##      \item{PCAres}{List containing results of PCA, with fields "eigen", "var.exp", "scores" and "loadings"}
##      \item{numComps}{Number of components selected}
## }
## @author Patricia Sebastian Leon
## @examples 
## data(STATegRa_S3)
## ps <- PCA.selection(Data=Block2.PCA, fac.sel="single%", varthreshold=0.03)
## ps$numComps
setGeneric(
    name="PCA.selection",
    def=function(Data,fac.sel,varthreshold=NULL,nvar=NULL,PCnum=NULL){standardGeneric("PCA.selection")}
)

setMethod(
    f="PCA.selection",
    signature=signature(
        Data="matrix",
        fac.sel="character"),
    definition=function(Data,fac.sel,varthreshold,nvar,PCnum){
        fac.sel <- match.arg(fac.sel, c("%accum", "single%", "rel.abs", "fixed.num"))
        pca.sel <- PCA.genes(Data)
        eigen <- pca.sel$eigen$values
        tot.var <- sum(eigen)
        rank <- length(which(eigen > 1e-16))
        if (fac.sel == "%accum") {
            fac <- max(length(which(pca.sel$var.exp[,2] <= varthreshold)),1)
        } else if (fac.sel == "single%"){
            fac <- length(which(pca.sel$var.exp[,1] >= (varthreshold)))
        } else if (fac.sel == "rel.abs"){
            mean.expl.var <- tot.var/ nrow(Data)
            fac <- length(which(eigen >= (mean.expl.var*nvar)))
        } else if (fac.sel == "fixed.num"){
            fac <- PCnum
        }
        res <- list(PCAres=pca.sel,numComps=fac)
        return(res)
    }
)

# modelSelection ----------------------------------------------------------
## INPUT:
## Input: (list) List of ExpressionSets
## Rmax: (numeric) Number of maximum common components
## (*) fac.sel: (character) Criterium for selecting number of components c("%accum", "single%", "rel.abs", "fixed.num")
## (*) varthreshold: (numeric) Threshold for the selection of components in "%accum", "single%" criteriums
## (*) nvar: (numeric) Threshold applied when the option "rel.abs" is selected
## (*) PCnum: (numeric) Fixed number of components to select with the option"fixed.num"
## (*) cente: "PERBLOCKS": Has center be applied before analysis?
## (*) scale: "PERBLOCKS": Has scale be applied before analysis?
## (*) weight: Logical indicating whether weighting is to be done.
## (*) plot_common: Logical indicating whether to plot explained variance for common components
## (*) plot_dist: Logical indicating whether to plot explained and accumulated variance fo distinctive components for each block 
## OUTPUT: (list)
## - common: Number of optimal common components
## - dist: Number of optimal distictive components for each block
#' @importFrom  gridExtra arrangeGrob grid.arrange
#' @import Biobase
#' @import ggplot2
#' @import MASS
#' @export
#' @title Find optimal common and distinctive components
#' @aliases modelSelection,list,numeric,character-method
#' @description 
#' Estimate the optimal number of common and distinctive components according to given selection criteria.
#' @usage modelSelection(Input,Rmax,fac.sel,varthreshold=NULL,nvar=NULL,PCnum=NULL,center=FALSE,scale=FALSE,weight=FALSE, plot_common=FALSE, plot_dist=FALSE)
#' @param Input List of \code{ExpressionSet} objects, one for each block of data
#' @param Rmax Maximum common components
#' @param fac.sel PCA criteria for selection ("\%accum", "single\%", "rel.abs", "fixed.num")
#' @param varthreshold Cumulative variance criteria for PCA selection. Threshold for "\%accum" or "single\%" criteria.
#' @param nvar Relative variance criteria. Threshold for "rel.abs".
#' @param PCnum Fixed number of components for "fixed.num".
#' @param center Character (or FALSE) specifying which (if any) centering will be applied before analysis. Choices are "PERBLOCKS" (each block separately) or "ALLBLOCKS" (all data together).
#' @param scale Character (or FALSE) specifying which (if any) scaling will be applied before analysis. Choices are "PERBLOCKS" (each block separately) or "ALLBLOCKS" (all data together).
#' @param weight Logical indicating whether weighting is to be done. Choices are "BETWEEN-BLOCKS"
#' @param plot_common Logical indicating whether to plot the explained variances (SSQ) of each block and its estimation and the ratios
#' @param plot_dist Logical indicating whether to plot the explained variances (SSQ) and the accumulated variance for each block
#' @return List containing:
#' \describe{
#'      \item{common}{List with common components results}
#'      \item{commonComps}{Optimal number of common components}
#'      \item{ssqs}{Matrix of SSQ for each block and estimator}
#'      \item{pssq}{\code{\link{ggplot}} object showing SSQ for each block and estimator}
#'      \item{pratios}{\code{\link{ggplot}} object showing SSQ ratios between each block and estimator}
#'      \item{dist}{List containg the results of distinct PCA for each input block; for each block PCAres and numComps is returned within a list}
#'      \item{PCAres}{List containing results of PCA, with fields "eigen", "var.exp", "scores" and "loadings"}
#'      \item{nomComps}{Number of components selected}
#' }
#' @author Patricia Sebastian-Leon
#' @seealso \code{\link{omicsCompAnalysis}}
#' @examples
#' data(STATegRa_S3)
#' B1 <- createOmicsExpressionSet(Data=Block1.PCA,pData=ed.PCA,pDataDescr=c("classname"))
#' B2 <- createOmicsExpressionSet(Data=Block2.PCA,pData=ed.PCA,pDataDescr=c("classname"))
#' ms <- modelSelection(Input=list(B1, B2), Rmax=3, fac.sel="single\%", varthreshold=0.03, center=TRUE, scale=FALSE, weight=TRUE, plot_common=FALSE, plot_dist=FALSE)
#' ms
setGeneric(
    name="modelSelection",
    def=function(Input,Rmax,fac.sel,varthreshold=NULL,nvar=NULL,PCnum=NULL,center=FALSE,scale=FALSE,weight=FALSE, plot_common=FALSE, plot_dist=FALSE){standardGeneric("modelSelection")}
)

setMethod(
    f="modelSelection",
    signature=signature(
        Input="list",
        Rmax="numeric",
        fac.sel="character"),
    definition=function(Input,Rmax,fac.sel,varthreshold,nvar,PCnum,center,scale,weight,plot_common,plot_dist){
      ## STEP1: Reading and checking provided data
      ## Expression sets
      orData <- Input
      if(!all(do.call("c",lapply(orData,FUN=class))=="ExpressionSet")){
        warning("Please provide a list of expression sets")
        return();
      }
      ## Converting expression sets list in matrices list
      Data <- lapply(orData,exprs)
      ## Number of Expression sets
      nData <- length(Data)
      ## Expression sets names
      ##if (is.null(Names)){
      ##  Names <- paste("Block",1:nData)
      ##}
      ## Check if number of columns/samples is the same in all datasets
      if(length(unique(do.call("c",lapply(Data,FUN=ncol))))!=1){
        warning("Number of samples is not the same for all data sets")
        return();
      }
      prepros <- NULL
      ## STEP2: Center & scale datasets if selected
      if(center & scale){
        prepros <- c(prepros,"centered & scaled")
        Data <- lapply(Data,function(x){t(scale(t(x),center=TRUE,scale=TRUE))})
      }else{
        if(center){
          prepros <- c(prepros,"centered")
          Data <- lapply(Data,function(x){t(scale(t(x),center=TRUE,scale=FALSE))})
        }
        ## STEP3: Scale datasets if selected
        if(scale){
          prepros <- c(prepros,"scaled")
          Data <- lapply(Data,function(x){t(scale(t(x),center=FALSE,scale=TRUE))})
        }
      }
      ## STEP4: Weight datasets if selected
      if(weight){
        prepros <- c(prepros,"weighted")
        Data <- weightBlocks(Data)
      }
      if(is.null(prepros)){
        prepros <- "none"
      }
      ## Generalized to more than 2 data sets
      n <- list()
      for(i in 1:length(Data)){
        ## For the moment we did not cross validate de number of individual components!!
        n[[i]] <- PCA.selection(Data[[i]],fac.sel=fac.sel,varthreshold=varthreshold,nvar=nvar,PCnum=PCnum)
      }
      num_comps <- lapply(n,FUN=function(x){return(x$numComps)})
      min_num_comps <- min(unlist(num_comps))
      if (Rmax > min_num_comps){
        Rmax <- min_num_comps
        warning(paste("Rmax cannot be higher than the minimum of components selected for each block. Rmax fixed to:",Rmax))
      }
      #common <- selectCommonComps(X,Y,Rmax)$common  ##When 2 datasets
      common <- selectCommonComps(Data,Rmax)
      ## Calculate number of optimal components
      n[[1]]$numComps  <- n[[1]]$numComps - common$commonComps
      n[[2]]$numComps  <- n[[2]]$numComps - common$commonComps
      res <- list(common=common,dist=n)
      ## Print common and distinctive components + graphics
      if(plot_common){
        grid.arrange(common$pssq, common$pratios, ncol=length(Data))
      }
      if(plot_dist){
        par(ask=TRUE)
        for(i in 1:length(res[['dist']])){
          pcadf <- data.frame(components=factor(rep(1:10,2),levels=1:10),
                             var=unlist(c(res[['dist']][[i]]$PCAres$var.exp[1:10,])),
                             mylabel=rep(colnames(res[['dist']][[i]]$PCAres$var.exp),each=10))
          p <- ggplot(pcadf,aes(x=components,y=var,fill=mylabel))+
          geom_bar(stat="identity",position="dodge")+
          ggtitle(names(Input)[i])+
          geom_hline(yintercept=varthreshold,linetype="dotted")
          print(p)
        }
        par(ask=FALSE)
      }
      cat("Common components\n")
      print(common$commonComps)
      cat("\nDistinctive components\n")
      print(lapply(n,FUN=function(x){return(x$numComps)}))
      ## Print common and distinctive components + graphics
      return(res)
    }
)

rm(list = ls())
require("STATegRa")
# Load the data
data("TCGA_BRCA_Batch_93")
# Setting dataTypes
dataTypes <- c("count", "count", "continuous")
# Setting methods to combine pvalues
combMethods = c("Fisher", "Liptak", "Tippett")
# Setting number of permutations
numPerms = 1000
# Setting number of cores
numCores = 1
# Setting holistOmics to print out the steps that it performs.
verbose = TRUE
# Run holistOmics analysis.
output <- omicsNPC(dataInput = TCGA_BRCA_Data, dataTypes = dataTypes, combMethods = combMethods, numPerms = numPerms, numCores = numCores, verbose = verbose)

####### PLOTS #######

# g_legend ----------------------------------------------------------------
## Extract the legend for a general legend with grid.arrange
## code from https://github.com/hadley/ggplot2/wiki/Share-a-legend-between-two-ggplot2-graphs
## INPUT:
##    a.gplot: (ggplot) A plot
## OUTPUT:
##    Legend of the plot
g_legend<-function(a.gplot){
    tmp <- ggplot_gtable(ggplot_build(a.gplot))
    leg <- which(sapply(tmp$grobs, function(x) x$name) == "guide-box")
    legend <- tmp$grobs[[leg]]
    return(legend)}



# plotVAF (Associated to caClass) ------------------------------------------------------------
## INPUT:
##    object: (scaClass) Object with results of Simultaneous Components Analysis (SCA)
##    mainTitle: (character) Title of the plot
## OUTPUT:
##    (plot): VAF plot, one for each block and one for the joined data
#' @export
#' @import ggplot2
#' @import grid
#' @import Biobase
#' @importFrom gridExtra arrangeGrob grid.arrange
#' @title Plot VAF (Variance Explained For) from Component Analysis
#' @aliases plotVAF,caClass-method
#' @description 
#' This function visualises the VAF results from component analysis. The input is a \code{\link{caClass-class}} object from \code{\link{omicsCompAnalysis}}. VAF cannot be calculated if mode "O2PLS" was used. The plots for modes "DISCOSCA" and "JIVE" are different since DISCO-SCA distinctive components have some VAF in the other block. This VAF can be interpreted as an error in the rotation.
#' @usage plotVAF(object, mainTitle="")
#' @param object \code{\link{caClass-class}} object containing component analysis results
#' @param mainTitle Plot title
#' @return \code{ggplot} object
#' @author Patricia Sebastian-Leon
#' @examples 
#' data("STATegRa_S3")
#' require(ggplot2)
#' B1 <- createOmicsExpressionSet(Data=Block1.PCA,pData=ed.PCA,
#'                                pDataDescr=c("classname"))
#' B2 <- createOmicsExpressionSet(Data=Block2.PCA,
#'                                pData=ed.PCA,pDataDescr=c("classname"))
#' # Omics components analysis
#' discoRes <- omicsCompAnalysis(Input=list(B1,B2),Names=c("expr","mirna"),
#'                               method="DISCOSCA",Rcommon=2,Rspecific=c(2,2),
#'                               center=TRUE,scale=TRUE,weight=TRUE)
#' jiveRes <- omicsCompAnalysis(Input=list(B1,B2),Names=c("expr","mirna"),
#'                              method="JIVE",Rcommon=2,Rspecific=c(2,2),
#'                              center=TRUE,scale=TRUE,weight=TRUE)
#' 
#' # DISCO-SCA plotVAF
#' plotVAF(discoRes)
#' 
#' # JIVE plotVAF
#' plotVAF(jiveRes)
setGeneric(
    name="plotVAF",
    def=function(object,mainTitle=""){standardGeneric("plotVAF")}
)

setMethod(
    f="plotVAF",
    signature=signature(
        object="caClass"),
    definition=function(object,mainTitle){
        if(object@caMethod=="DISCO-SCA"){
            df_common <- data.frame(VAF=c(object@VAF$common),
                                    block=rep(object@Names,object@commonComps),
                                    comp=rep(1:object@commonComps,each=2),
                                    group=rep("common"),2*object@commonComps)
            df_dist <- data.frame(VAF=c(object@VAF$dist$Block1[1:object@distComps[1]],object@VAF$dist$Block2[1:object@distComps[2]],
                                        object@VAF$dist$cross[1,1:object@distComps[2]],object@VAF$dist$cross[2,1:object@distComps[1]]),
                                  comp=c(1:object@distComps[1],1:object@distComps[2],1:object@distComps[2],1:object@distComps[1]),
                                  block=c(rep(object@Names[1],object@distComps[1]),rep(object@Names[2],object@distComps[2]),
                                          rep(object@Names[1],object@distComps[2]),rep(object@Names[2],object@distComps[1])),
                                  group=c(rep(object@Names[1],object@distComps[1]),rep(object@Names[2],object@distComps[2]),
                                          rep(object@Names[2],object@distComps[2]),rep(object@Names[1],object@distComps[1])))
            upperlim <- max(df_common$VAF,df_dist$VAF)
            p_common <- ggplot(df_common,aes(x=factor(comp),y=VAF,fill=factor(block)))+
                geom_bar(stat="identity",position="dodge")+
                facet_wrap(~ group)+
                xlab("Components")+
                ylab("Proportion of VAF")+
                ggtitle("Common components")+
                ylim(c(0,upperlim))+
                theme(legend.title=element_blank(),plot.title=element_text(size=10),legend.position="bottom")
            p_dist <- ggplot(df_dist,aes(x=factor(comp),y=VAF,fill=factor(block)))+
                geom_bar(stat="identity",position="dodge")+
                facet_wrap(~ group)+
                xlab("Components")+
                ylab("")+
                ggtitle("Distinctive components")+
                ylim(c(0,upperlim))+
                theme(legend.title=element_blank(),plot.title=element_text(size=10),legend.position="bottom")
            mylegend <- g_legend(p_common)
            grid.arrange(arrangeGrob(p_common+ theme(legend.position="none"),p_dist+ theme(legend.position="none"),ncol=2,widths=c(1/3,2/3)),
                         mylegend,nrow=2,heights=c(10, 1),main=textGrob(label=mainTitle,gp=gpar(fontsize=20,cex=1)))
        } else if (object@caMethod=="JIVE"){
            df_common <- data.frame(VAF=c(object@VAF$common),
                                    block=rep("common",object@commonComps),
                                    comp=1:object@commonComps,
                                    group=rep("common"),object@commonComps)
            df_dist <- data.frame(VAF=c(c(object@VAF$dist$Block1),c(object@VAF$dist$Block2)),
                                  block=c(rep(object@Names[1],object@distComps[1]),rep(object@Names[2],object@distComps[2])),
                                  comp=c(1:object@distComps[1],1:object@distComps[2]),
                                  group=c(rep(object@Names[1],object@distComps[1]),rep(object@Names[2],object@distComps[2])))
            upperlim <- max(df_common$VAF,df_dist$VAF)
            p_common <- ggplot(df_common,aes(x=factor(comp),y=VAF,fill=factor(block)))+
                geom_bar(stat="identity",position="dodge",fill="#666666")+
                facet_wrap(~ group)+
                xlab("Components")+
                ylab("Proportion of VAF")+
                ggtitle("Common components")+
                ylim(c(0,upperlim))+
                theme(legend.title=element_blank(),plot.title=element_text(size=10),legend.position="bottom")
            p_dist <- ggplot(df_dist,aes(x=factor(comp),y=VAF,fill=factor(block)))+
                geom_bar(stat="identity",position="dodge")+
                facet_wrap(~ group)+
                xlab("Components")+
                ylab("")+
                ggtitle("Distinctive components")+
                ylim(c(0,upperlim))+
                theme(legend.title=element_blank(),plot.title=element_text(size=10),legend.position="bottom")
            grid.arrange(arrangeGrob(p_common+ theme(legend.position="none"),p_dist+ theme(legend.position="none"),ncol=2,widths=c(1/3,2/3)),
                         nrow=2,heights=c(10, 1),main=textGrob(label=mainTitle,gp=gpar(fontsize=20,cex=1)))
        } else if(object@caMethod=="O2PLS"){
            warning("VAF per component cannot be calculated with O2PLS approach because components are not orthogonal")
        }
    }
)



# plotting ----------------------------------------------------------------
setGeneric(
  name="plotting",
  def=function(df,comps,xname,yname,color,what,type,combined,block,shape=NULL,labels=NULL,title,xlabel=NULL,
               ylabel=NULL,background=FALSE,palette=NULL,pointSize=4,labelSize=12,axisSize=8,titleSize=20,sizeValues=c(2,4),shapeValues=c(17,0)){standardGeneric("plotting")}
)


setMethod(
  f="plotting",
  signature=signature(
    df="data.frame",
    comps="numeric",
    xname="character",
    yname="character",
    color="character"),
  definition=function(df,comps,xname,yname,color,what,type,combined,block,shape,labels,title,xlabel,ylabel,background,palette,pointSize,
                      labelSize,axisSize,titleSize,sizeValues,shapeValues){
    
    if (what=="loadings"){
      df <- na.omit(df[,c(xname,yname)])
    }
    
    p <- ggplot(df,aes_string(xname,yname))
    
    if (what!="both"){
      if (!is.null(color) & !is.null(shape)){
        p <- p+geom_point(aes(color=color,shape=shape),size=pointSize)
      }else if (!is.null(color)){
          p <- p+geom_point(aes(color=color),size=pointSize)
      }else if (!is.null(shape)){
        p <- p+geom_point(aes(shape=shape),size=pointSize)
      }else{
        p <- p+geom_point(size=pointSize)
      }
    }else{
      p <- p + geom_point(data=df[df$class=="loadings",], na.rm=TRUE, aes(shape=class, size=class))+
        geom_point(data=df[df$class=="scores",],aes(color=color, shape=class, size=class))+
        scale_size_manual(name="",values=sizeValues)+
        scale_shape_manual(name="",values=shapeValues) 
    }

    if(!is.null(labels)){
      p <- p+geom_text(alpha=.5,size=pointSize,aes_string(label=labels),vjust=-.7)
    }  
    xlim <- ylim <- c(max(df[,xname],df[,yname],na.rm=TRUE),min(df[,xname],df[,yname], na.rm=TRUE))
    p <- p+xlim(xlim)+ylim(ylim)+coord_fixed()
    if (!background){
      p <- p+theme_bw()
    }
    if (is.null(title)){
      if(combined & type=="individual"){
        title <- paste(what,"plot","- combined",type,"components", sep=" ")
      }else if(!combined & type=="individual"){
        title <- paste(what,"plot","-",type,"components \nblock ",block, sep=" ")
      }else{
        title <- paste(what,"plot","-",type,"components", sep=" ")
      }
    }
    if (is.null(xlabel)){
      if(type=="individual"){
        xlabel <- paste("Component",comps[1],"- dist \n",block[1], sep=" ") 
      }else{
        xlabel <-  paste("Component",comps[1],"- common\n",block[1], sep=" ") 
      }
    }
    if (is.null(ylabel)){
      if(type=="common"){
        ylabel <- paste("Component",comps[2],"- common\n",block[2], sep=" ")
      }else{
        ylabel <- paste("Component",comps[2],"- dist \n",block[2], sep=" ")
      }
    }
    if (!is.null(palette)){
      p <- p+scale_colour_manual(values=palette)
    }
    p <- p+ggtitle(title)+xlab(xlabel)+ylab(ylabel)
    p <- p+theme(legend.position="bottom",
                 axis.text = element_text(size = axisSize),
                 axis.title = element_text(size = labelSize),
                 plot.title = element_text(size=titleSize, face="bold"))
    p
  }
)



# plotRes (Associated to caClass) --------------------------------------------
## Parameters:
##   what=c("scores","loadings","both"): plot scores, loadings or both
##   type=c("common","individual","both"): plot common components, individual components or a combination (common and individual)
##   combined=c(T,F): Logical indicating whether to combine components from different blocks
##   comps=c(comp_x,comp_y): components to plot. Indicate x and y, if combined=T, x=component_block1 and y=component_block2
#' @export
#' @import ggplot2
#' @import MASS
#' @importFrom  gridExtra arrangeGrob grid.arrange
#' @import Biobase
#' @title Plot component analysis results
#' @aliases plotRes,caClass,numeric,character,character,logical-method
#' @description 
#' Plot scatterplots of scores or loadings, for common and distinctive parts as well as combined plots.
#' @usage plotRes(object, comps=c(1, 2), what, type, combined, block=NULL, 
#'                color=NULL, shape=NULL, labels=NULL, title=NULL, xlabel=NULL, ylabel=NULL, background=TRUE, 
#'                palette=NULL, pointSize=4, labelSize=NULL, 
#'                axisSize=NULL, titleSize=NULL, sizeValues = c(2,4), shapeValues = c(17, 0))
#' @param object \code{\link{caClass-class}} containing component analysis results
#' @param comps If combined=FALSE, it indicates the x and y components of the type and block chosen. If \code{combined=TRUE}, it indicates the component to plot for the first block of information and the component for the second block of information to plot together. By default the components are set to c(1,2) if \code{combined=FALSE} and to c(1,1) if \code{combined=TRUE}.
#' @param what Either "scores", "loadings" or "both"
#' @param type Either "common", "individual" or "both"
#' @param combined Logical indicating whether to make a simple plot of two components from one block, or components from different blocks
#' @param block Which block to plot, either "1" or "2" or the name of the block.
#' @param color Character specifying a pData column from the original data to use to color points
#' @param shape Character specifying a pData column to select point shape
#' @param labels Character specifying a pData column from which to take point labels
#' @param title Main title
#' @param xlabel x-axis name
#' @param ylabel y-axis name
#' @param background Logical specifying whether to make a grey background
#' @param palette Vector giving the color palette for the plot
#' @param pointSize Size of plot points
#' @param labelSize Size of point labels if not NULL
#' @param axisSize Size of axis text
#' @param titleSize Size of title text
#' @param sizeValues Vector containing sizes for scores and loadings
#' @param shapeValues Vector indicating the shapes for scores and loadings
#' @return \code{ggplot} object
#' @author Patricia Sebastian-Leon
#' @examples
#' data("STATegRa_S3")
#' B1 <- createOmicsExpressionSet(Data=Block1.PCA,pData=ed.PCA,
#'                                pDataDescr=c("classname"))
#' B2 <- createOmicsExpressionSet(Data=Block2.PCA,
#'                                pData=ed.PCA,pDataDescr=c("classname"))
#' # Omics components analysis
#' discoRes <- omicsCompAnalysis(Input=list(B1,B2),Names=c("expr","mirna"),
#'                               method="DISCOSCA",Rcommon=2,Rspecific=c(2,2),
#'                               center=TRUE,scale=TRUE,weight=TRUE)
#' jiveRes <- omicsCompAnalysis(Input=list(B1,B2),Names=c("expr","mirna"),
#'                              method="JIVE",Rcommon=2,Rspecific=c(2,2),
#'                              center=TRUE,scale=TRUE,weight=TRUE)
#' 
#' o2plsRes <- omicsCompAnalysis(Input=list(B1,B2),Names=c("expr","mirna"),
#'                               method="O2PLS",Rcommon=2,Rspecific=c(2,2),
#'                               center=TRUE,scale=TRUE,weight=TRUE)
#' 
#' # Scatterplot of scores variables associated to common components
#' 
#' # DISCO-SCA
#' plotRes(object=discoRes,comps=c(1,2),what="scores",type="common",
#'         combined=FALSE,block=NULL,color="classname",shape=NULL,labels=NULL,
#'         background=TRUE,palette=NULL,pointSize=4,labelSize=NULL,
#'         axisSize=NULL,titleSize=NULL)
#' # JIVE
#' plotRes(object=jiveRes,comps=c(1,2),what="scores",type="common",
#'        combined=FALSE,block=NULL,color="classname",shape=NULL,labels=NULL,
#'         background=TRUE,palette=NULL,pointSize=4,labelSize=NULL,
#'         axisSize=NULL,titleSize=NULL)
#' 
#' # O2PLS
#' # Scatterplot of scores variables associated to common components
#' # Associated to first block
#' p1 <- plotRes(object=o2plsRes,comps=c(1,2),what="scores",type="common",
#'               combined=FALSE,block="expr",color="classname",shape=NULL,
#'               labels=NULL,background=TRUE,palette=NULL,pointSize=4,
#'               labelSize=NULL,axisSize=NULL,titleSize=NULL)
#' # Associated to second block
#' p2 <- plotRes(object=o2plsRes,comps=c(1,2),what="scores",type="common",
#'               combined=FALSE,block="mirna",color="classname",shape=NULL,
#'               labels=NULL,background=TRUE,palette=NULL,pointSize=4,
#'               labelSize=NULL,axisSize=NULL,titleSize=NULL)
#' 
#' # Combined plot of scores variables assocaited to common components
#' plotRes(object=o2plsRes,comps=c(1,1),what="scores",type="common",
#'         combined=TRUE,block=NULL,color="classname",shape=NULL,
#'         labels=NULL,background=TRUE,palette=NULL,pointSize=4,
#'         labelSize=NULL,axisSize=NULL,titleSize=NULL)
#' 
#' # Loadings plot for individual components
#' # Separately for each block
#' p1 <- plotRes(object=discoRes,comps=c(1,2),what="loadings",type="individual",
#'               combined=FALSE,block="expr",color="classname",shape=NULL,
#'               labels=NULL,background=TRUE,palette=NULL,pointSize=4,
#'               labelSize=NULL,axisSize=NULL,titleSize=NULL)
#' p2 <- plotRes(object=discoRes,comps=c(1,2),what="loadings",type="individual",
#'               combined=FALSE,block="mirna",color="classname",shape=NULL,
#'               labels=NULL,background=TRUE,palette=NULL,pointSize=4,
#'               labelSize=NULL,axisSize=NULL,titleSize=NULL)
#' 
#' # Biplot: scores + loadings
#' plotRes(object=discoRes,comps=c(1,2),what="both",type="common",
#'         combined=FALSE,block="expr",color="classname",shape=NULL,
#'         labels=NULL,background=TRUE,palette=NULL,pointSize=4,
#'         labelSize=NULL,axisSize=NULL,titleSize=NULL)


setGeneric(
  name="plotRes",
  def=function(object,comps=c(1,2),what,type,combined,block=NULL,color=NULL,shape=NULL,labels=NULL,title=NULL,xlabel=NULL,ylabel=NULL,background=TRUE,palette=NULL,pointSize=4,
               labelSize=NULL,axisSize=NULL,titleSize=NULL,sizeValues=c(2,4),shapeValues=c(17,0)){
    standardGeneric("plotRes")}
)


setMethod(
  f="plotRes",
  signature=signature(
    object="caClass",
    comps="numeric",
    what="character",
    type="character",
    combined="logical"),
  definition=function(object,comps,what,type,combined,block,color,shape,labels,title,xlabel,ylabel,background,palette,pointSize,
                      labelSize,axisSize,titleSize,sizeValues,shapeValues){
    what <- match.arg(what,choices=c("scores","loadings","both"))
    type <- match.arg(type,choices=c("common","individual","both"))
    
    set.seed(12464863)
    if (combined & object@caMethod%in%c("DISCO-SCA","JIVE") & type=="common" & what=="scores"){
     stop(paste(object@caMethod)," does not distinguish between common scores for each block. 
                    It is not possible to plot a combined plot in this case")
    }
    
    if (combined & object@caMethod=="O2PLS" & type!="both" & !is.null(block)){
      warning("'block' argument depreciated, if combined is TRUE both blocks are going to be used")
      block <- NULL
    }
    
    
    if (combined & object@caMethod%in%c("DISCO-SCA","JIVE") & type=="both" & what=="scores"){
      warning(paste(object@caMethod)," does not distinguish between common scores for each block")
    }
    
    #check and define type
    if (type=="common") type2 <- c("common","common")
    if (type=="individual") type2 <- c("dist","dist")
    if (type=="both") type2 <- c("common","dist")
    
    if (what!="scores" & combined==TRUE){
      warning("loadings are not able to be combined")
      combined <- FALSE
    }
    if (what!="scores" & is.null(block)){
      stop("'block' argument is required for loadings and loadings + score plot")
    }
    
    #check and define block
    if (is.null(block)){
      if (combined){
        block <- c("1","2")
        block_name <- object@Names
      }else if(type=="common" & object@caMethod%in%c("DISCO-SCA","JIVE")){
        block <- c("1","1")
        block_name <- c("","")
      }else{
        stop(block, " block argument must be provided")
      }
    }else{
      if (combined){
        if (type=="individual"){
          warning("'block' argument depreciated, if combined is TRUE both blocks are going to be used")
          block <- c("1","2")
          block_name <- object@Names
        }
        if (type=="both"){
          if (!block%in%object@Names){
            stop("block ", block," does not exist")
          }
          bb1 <- which(object@Names==block)
          bb2 <- which(object@Names!=block)
          block_name <- c(object@Names[bb1], object@Names[bb2])
          block <- c(as.character(bb1),as.character(bb2))
        }
      }else if (!block%in%object@Names){
        stop("block ", block," does not exist")
      }else{
        bb <- which(object@Names==block)
        block_name <- c(block, block)
        block <- c(as.character(bb),as.character(bb))
      }
    }

    #matrix for plot (scores or loadings)
    if (what=="scores"){
      #generate a data frame with all the component data to plot
      if (object@caMethod%in%c("DISCO-SCA","JIVE")){
        df <- as.data.frame(cbind(object@scores$common,object@scores$common,object@scores$dist$Block1,object@scores$dist$Block2))
      }else{
        df <- as.data.frame(cbind(object@scores$common$Block1,object@scores$common$Block2,object@scores$dist$Block1,object@scores$dist$Block2))
      }
    }else if (what=="loadings"){
      nc1 <- matrix(NA,nrow=nrow(object@loadings$common$Block1),ncol=ncol(object@loadings$common$Block2))
      nc2 <- matrix(NA,nrow=nrow(object@loadings$common$Block2),ncol=ncol(object@loadings$common$Block1))
      nd1 <- matrix(NA,nrow=nrow(object@loadings$dist$Block1),ncol=ncol(object@loadings$dist$Block2))
      nd2 <- matrix(NA,nrow=nrow(object@loadings$dist$Block2),ncol=ncol(object@loadings$dist$Block1))
      nc <- nrow(nc1)+nrow(nc2)
      nd <- nrow(nd1)+nrow(nd2)
      nn1 <- matrix(NA,nrow=(nc-nd),ncol=ncol(object@loadings$dist$Block2))
      nn2 <- matrix(NA,nrow=(nc-nd),ncol=ncol(object@loadings$dist$Block1))
      df <- as.data.frame(cbind(rbind(object@loadings$common$Block1,nc2), rbind(object@loadings$common$Block2,nc1), rbind(object@loadings$dist$Block1,nd2,nn2), rbind(object@loadings$dist$Block2,nd1,nn1)))
      rownames(df) <- c(1:nrow(df))
    }else{ #both
      #scores
      if (object@caMethod%in%c("DISCO-SCA","JIVE")){
        dfs <- as.data.frame(cbind(object@scores$common,object@scores$common,object@scores$dist$Block1,object@scores$dist$Block2))
      }else{
        dfs <- as.data.frame(cbind(object@scores$common$Block1,object@scores$common$Block2,object@scores$dist$Block1,object@scores$dist$Block2))
      }
      #loadings
      nc1 <- matrix(NA,nrow=nrow(object@loadings$common$Block1),ncol=ncol(object@loadings$common$Block2))
      nc2 <- matrix(NA,nrow=nrow(object@loadings$common$Block2),ncol=ncol(object@loadings$common$Block1))
      nd1 <- matrix(NA,nrow=nrow(object@loadings$dist$Block1),ncol=ncol(object@loadings$dist$Block2))
      nd2 <- matrix(NA,nrow=nrow(object@loadings$dist$Block2),ncol=ncol(object@loadings$dist$Block1))
      nc <- nrow(nc1)+nrow(nc2)
      nd <- nrow(nd1)+nrow(nd2)
      nn1 <- matrix(NA,nrow=(nc-nd),ncol=ncol(object@loadings$dist$Block2))
      nn2 <- matrix(NA,nrow=(nc-nd),ncol=ncol(object@loadings$dist$Block1))
      dfl <- as.data.frame(cbind(rbind(object@loadings$common$Block1,nc2), rbind(object@loadings$common$Block2,nc1), rbind(object@loadings$dist$Block1,nd2,nn2), rbind(object@loadings$dist$Block2,nd1,nn1)))
      rownames(dfl) <- c(1:nrow(dfl))
      #combined dataframe
      df <- rbind(dfs,dfl)
      df$class <- c(rep("scores",nrow(dfs)),rep("loadings",nrow(dfl)))
    }
    if (what!="both"){
      colnames(df) <- c(paste("common1",1:object@commonComps,sep="_"),
                      paste("common2",1:object@commonComps,sep="_"),
                      paste("dist1",1:object@distComps[1],sep="_"),
                      paste("dist2",1:object@distComps[2],sep="_"))
    }else{
      colnames(df) <- c(paste("common1",1:object@commonComps,sep="_"),
                        paste("common2",1:object@commonComps,sep="_"),
                        paste("dist1",1:object@distComps[1],sep="_"),
                        paste("dist2",1:object@distComps[2],sep="_"),"class")      
    }
      
    #create auxiliar variables in case of just one component in common or distinctive structures
    if (object@commonComps==1){
      df$common1_2 <- runif(nrow(df),min(df$common1_1),max(df$common1_1))
      df$common2_2 <- runif(nrow(df),min(df$common2_1),max(df$common2_1))
      ylabel <- "Auxiliar to plot"
    }
    if (object@distComps[1]==1){  #In Block 1
      df$dist1_2 <- runif(nrow(df),min(df$dist1_1),max(df$dist1_1))
      ylabel <- "Auxiliar to plot"
    }     
    if (object@distComps[2]==1){  #In Block 2
      df$dist2_2 <- runif(nrow(df),min(df$dist2_1),max(df$dist2_1))
      ylabel <- "Auxiliar to plot"
    }     
  
    #graphical parameters
    if (what=="scores"){     
      if (!is.null(color)){
        color <- match.arg(color,choices=colnames(pData(object@InitialData[[1]])))
      }else{
        color <- names(pData(object@InitialData[[1]]))[1]       
      }
      df <- data.frame(df,color=pData(object@InitialData[[1]])[,color])
      if (!is.null(shape)){
        shape <- match.arg(shape,choices=colnames(pData(object@InitialData[[1]])))
        df <- data.frame(df,shape=pData(object@InitialData[[1]])[,shape])
      }
      if (!is.null(labels)){
        labels <- match.arg(labels,choices=colnames(pData(object@InitialData[[1]])))
        df <- data.frame(df,labels=pData(object@InitialData[[1]])[,labels])
      }
    }else if (what=="loadings"){
      df <- data.frame(df,color="color")
      color <- "color"
    }else{ #both
      if (!is.null(color)){
        color <- match.arg(color,choices=colnames(pData(object@InitialData[[1]])))
      }else{
        color <- names(pData(object@InitialData[[1]]))[1]       
      }
      df <- data.frame(df,color=as.factor(c(as.character(pData(object@InitialData[[1]])[,color]),rep("color",nrow(dfl)))))
    }
      
      #plot
      plotting(df,comps,xname=paste(type2[1],block[1],"_",comps[1],sep=""),yname=paste(type2[2],block[2],"_",comps[2],sep=""),color,what,type,combined,block=block_name,shape,labels,title,xlabel,
               ylabel,background,palette,pointSize,labelSize,axisSize,titleSize,sizeValues,shapeValues)  
  }      
)      

###########################################
########### EXAMPLE OF THE OMICSCLUSTERING
###########################################
require(STATegRa)

#############################################
## PART 1: CREATING a bioMap CLASS
#############################################
####### This part creates or reads the map between features.
####### In the present example the map is downloaded from a resource.
#######   then the class is created.

#load("../data/STATegRa_S2.rda")
data(STATegRa_S2)

MAP.SYMBOL<-bioMap(name = "Symbol-miRNA",
                metadata =  list(type_v1="Gene",type_v2="miRNA",
                                 source_database="targetscan.Hs.eg.db",
                                 data_extraction="July2014"),
                map=mapdata)


#############################################
## PART 2: CREATING a bioDist CLASS
#############################################
##### In the second part given a set of main features and surrogate feautres,
#####    the profile of the main features is computed through the surrogate features.

# Load Data
data(STATegRa_S1)
  #load("../data/STATegRa.S1.Rdata")

## Create ExpressionSets
#  source("../R/STATegRa_omicsPCA_classes_and_methods.R")
# Block1 - Expression data
mRNA.ds <- createOmicsExpressionSet(Data=Block1,pData=ed,pDataDescr=c("classname"))
# Block2 - miRNA expression data
miRNA.ds <- createOmicsExpressionSet(Data=Block2,pData=ed,pDataDescr=c("classname"))

# Create Gene-gene distance computed through miRNA data
bioDistmiRNA<-bioDist(referenceFeatures = rownames(Block1),     
             reference = "Var1",
             mapping = MAP.SYMBOL,
             surrogateData = miRNA.ds,  ### miRNA data
             referenceData = mRNA.ds,  ### mRNA data
             maxitems=2,
             selectionRule="sd",
             expfac=NULL,
             aggregation = "sum",
             distance = "spearman",
             noMappingDist = 0,
             filtering = NULL,
             name = "mRNAbymiRNA")

require(Biobase)

# Create Gene-gene distance through mRNA data
bioDistmRNA<-bioDistclass(name = "mRNAbymRNA",
                 distance = cor(t(exprs(mRNA.ds)),method="spearman"),
                 map.name = "id",
                 map.metadata = list(),
                 params = list())

#############################################
## PART 3: CREATING a LISTOF WEIGTHED DISTANCES MATRICES: bioDistWList
#############################################

bioDistList<-list(bioDistmRNA,bioDistmiRNA)
weights<-matrix(0,4,2)
weights[,1]<-c(0,0.33,0.67,1)
weights[,2]<-c(1,0.67,0.33,0)#

bioDistWList<-bioDistW(referenceFeatures = rownames(Block1),
                       bioDistList = bioDistList,
                       weights=weights)
length(bioDistWList)

#############################################
## PART 4: DEFINING THE STRENGTH OF ASSOCIATIONS IN GENERAL
#############################################

bioDistWPlot(referenceFeatures = rownames(Block1) ,
               listDistW = bioDistWList,
               method.cor="spearman")

#############################################
## PART 5: DEFINING THE ASSOCIATIONS FOR A GIVEN GENE
#############################################

## IDH1

IDH1.F<-bioDistFeature(Feature = "IDH1" ,
                       listDistW = bioDistWList,
                       threshold.cor=0.7)
bioDistFeaturePlot(data=IDH1.F)

## PDGFRA

#PDGFRA.F<-bioDistFeature(Feature = "PDGFRA" ,
#                       listDistW = bioDistWList,
#                       threshold.cor=0.7)
#bioDistFeaturePlot(data=PDGFRA.F,name="../vignettes/PDGFRA.png")

## EGFR
#EGFR.F<-bioDistFeature(Feature = "EGFR" ,
#                         listDistW = bioDistWList,
#                         threshold.cor=0.7)
#bioDistFeaturePlot(data=EGFR.F,name="../vignettes/EGFR.png")

## MGMT
#MGMT.F<-bioDistFeature(Feature = "MGMT" ,
#                         listDistW = bioDistWList,
#                         threshold.cor=0.5)
#bioDistFeaturePlot(data=MGMT.F,name="../vignettes/MGMT.png")

####### MAIN FUNCTION #######

# caClass -----------------------------------------------------------------
## SLOTS:
##   InitialData: (list) List of ExpressionSets, one for each set of omics data
##   preprocessing: (vector) Vector indicating which prepropressing (scale/center/weight) is applied to initial data
##   preproData: (list) List of matrices, one for each set of preprocessed omics data
##   caMethod: (character) Method applied for Components Analysis
##   commonComps: (numeric) Number of common components
##   distComps: (vector) Number of distinctive components for each omics data set
##   scores: (list) List of matrices of common and distinctive scores
##   loadings: (list) List of matrices of common and distintive loadings
##   VAF: (list) list of matrices indicating VAF of each component in each block of data and in common
##   others: (list) List of other information that the selected Component Analysis Method should give.

#' @title caClass
#' @aliases caClass-class
#' @description Stores the results of any of the omicsPCA analyses.
#' @author Patricia Sebastian Leon
#' @slot InitialData List of ExpressionSets, one for each set of omics data
#' @slot Names Character vector giving names for the input data
#' @slot preprocessing Character vector describing the preprocessing applied to the data
#' @slot preproData List of matrices containing data after preprocessing
#' @slot caMethod Character giving the component analysis method name
#' @slot commonComps Numeric giving the number of common components
#' @slot distComps Numeric vector giving the number of distinctive components for each block
#' @slot scores List of matrices of common and distinctive scores
#' @slot loadings List of matrices of common and distinctive loadings
#' @slot VAF List of matrices indicating VAF (Variability Explained For) for each component in each block of data
#' @slot others List containing other miscellaneous information specific to different SCA methods
setClass(
    Class="caClass",
    slots=list(
        InitialData="list",
        Names="character",
        preprocessing="character",
        preproData="list",
        caMethod="character",
        commonComps="numeric",
        distComps="vector",
        scores="list",
        loadings="list",
        VAF="list",
        others="list"),
    prototype=list(
        InitialData=NULL,
        Names=NULL,
        preprocessing=c("none"),
        preproData=NULL,
        caMethod="none",
        commonComps=0,
        distComps=c(0,0),
        scores=NULL,
        loadings=NULL,
        VAF=NULL,
        others=NULL)
)

####### caClass MEMBER ACCESS METHODS #######

#' @export
#' @title Retrieve initial data from caClass objects
#' @aliases getInitialData,caClass-method
#' @description 
#' Generic function to retrieve the initial data used for by \code{\link{omicsCompAnalysis}} from a \code{\link{caClass-class}} object
#' @usage getInitialData(x, block=NULL)
#' @param x \code{\link{caClass-class}} object.
#' @param block Character indicating the block of data to be returned. It can be specified by the position of the block ("1" or "2") or the name assigned in the \code{\link{caClass-class}} object. If it is NULL both blocks are displayed.
#' 
#' @return The requested data block or blocks
#' 
#' @author Patricia Sebastian-Leon
#' @seealso \code{\link{omicsCompAnalysis}}, \code{\link{caClass-class}}
#' 
#' @examples
#' data("STATegRa_S3")
#' B1 <- createOmicsExpressionSet(Data=Block1.PCA, pData=ed.PCA,
#'                                pDataDescr=c("classname"))
#' B2 <- createOmicsExpressionSet(Data=Block2.PCA,
#'                                pData=ed.PCA, pDataDescr=c("classname"))
#' # Omics components analysis
#' res <- omicsCompAnalysis(Input=list(B1, B2), Names=c("expr", "mirna"),
#'                          method="DISCOSCA", Rcommon=2, Rspecific=c(2, 2),
#'                          center=TRUE, scale=TRUE, weight=TRUE)
#' getInitialData(res)
#' getInitialData(res, block="expr")
setGeneric(
    name="getInitialData",
    def=function(x, block=NULL) { standardGeneric("getInitialData") }
)

setMethod(
    f="getInitialData",
    signature=signature(x="caClass"),
    definition=function(x, block=NULL){
        if (class(x) != "caClass") {
            stop("x is not a caclass object")
        } else {
            if (is.null(block)) {
                return(x@InitialData)
            } else {
                if (block == "1" | block == x@Names[1]) {
                    return(x@InitialData[[1]])
                } else if (block == "2" | block == x@Names[2]) {
                    return(x@InitialData[[2]])
                } else {
                    warning(paste(block, "is not an allowed option"))
                    return(x@InitialData)
                }
            }
        }
    }
)




#' @export
#' @title Retrieve information about preprocessing
#' @aliases getPreprocessing,caClass-method
#' @description 
#' Generic function to retrieve information about the preprocessing done by \code{\link{omicsCompAnalysis}} on a \code{\link{caClass-class}} object.
#' @usage getPreprocessing(x, process=FALSE, preproData=FALSE, block=NULL)
#' @param x \code{\link{caClass-class}} object.
#' @param process Logical indicating whether to return information about the processing done.
#' @param preproData Logical indicating whether to return the pre-processed data matrices.
#' @param block Character indicating the block of data to be returned. It can be specified by the position of the block ("1" or "2") or the name assigned in the \code{\link{caClass-class}} object. If it is NULL both blocks are displayed.
#' 
#' @return If both \code{process} and \code{preproData} are specified, a list containing (otherwise the individual item):
#' \describe{
#'      \item{process}{Character indicating the processing done}
#'      \item{preproData}{Matrix (or list of matrices, depending on \code{block}) containing pre-processed data}
#'  }
#'  
#' 
#' @author Patricia Sebastian-Leon
#' @seealso \code{\link{omicsCompAnalysis}}, \code{\link{caClass-class}}
#' 
#' @examples
#' data("STATegRa_S3")
#' B1 <- createOmicsExpressionSet(Data=Block1.PCA, pData=ed.PCA,
#'                                pDataDescr=c("classname"))
#' B2 <- createOmicsExpressionSet(Data=Block2.PCA,
#'                                pData=ed.PCA, pDataDescr=c("classname"))
#' # Omics components analysis
#' res <- omicsCompAnalysis(Input=list(B1, B2), Names=c("expr", "mirna"),
#'                          method="DISCOSCA", Rcommon=2, Rspecific=c(2, 2),
#'                          center=TRUE, scale=TRUE, weight=TRUE)
#' getPreprocessing(res, process=TRUE)
#' getPreprocessing(res, preproData=TRUE, block="1")
setGeneric(
    name="getPreprocessing",
    def=function(x, process=FALSE, preproData=FALSE, block=NULL) {
        standardGeneric("getPreprocessing")
    }
)

setMethod(
    f="getPreprocessing",
    signature=signature(x="caClass"),
    definition=function(x, process, preproData, block) {
        if (class(x) != "caClass"){
            stop("x is not a caclass object")
        } else {
            if (process & preproData) {
                if (is.null(block)) {
                    res <- list(process=x@preprocessing,
                                preproData=x@preproData)
                } else {
                    if (block == "1" | block == x@Names[1]) {
                        res <- list(process=x@preprocessing,
                                    preproData=x@preproData[[1]])
                    } else if (block == "2" | block == x@Names[2]){
                        res <- list(process=x@preprocessing,
                                    preproData=x@preproData[[2]])
                    } else {
                        warning(paste(block, "is not an allowed option"))
                        res <- list(process=x@preprocessing,
                                    preproData=x@preproData)
                    }
                }
            } else if (process) {
                res <- x@preprocessing
            } else if (preproData) {
                if (is.null(block)) {
                    res <- x@preproData
                } else {
                    if (block == "1" | block == x@Names[1]) {
                        res <- x@preproData[[1]]
                    } else if (block == "2" | block == x@Names[2]) {
                        res <- x@preproData[[2]]
                    } else {
                        warning(paste(block, "is not an allowed option"))
                        res <- x@preproData
                    }
                }
            } else {
                res <- list(process=x@preprocessing, preproData=x@preproData)
            }
        }
        return(res)
    }
)



#' @export
#' @title Retrieve information about component analysis method
#' @aliases getMethodInfo,caClass-method
#' @description 
#' Generic function to retrieve information about the method used by \code{\link{omicsCompAnalysis}} on a \code{\link{caClass-class}} object.
#' @usage getMethodInfo(x, method=FALSE, comps=NULL, block=NULL)
#' @param x \code{\link{caClass-class}} object.
#' @param method Logical indicating whether to return the method name.
#' @param comps Character indicating which component number to return ("common", "distinctive" or "all")
#' @param block Character indicating the block of data for which the component count will be given. It can be specified by the position of the block ("1" or "2") or the name assigned in the \code{\link{caClass-class}} object. If it is NULL both blocks are displayed.
#' 
#' @return A list containing the requested information.
#'  
#' 
#' @author Patricia Sebastian-Leon
#' @seealso \code{\link{omicsCompAnalysis}}, \code{\link{caClass-class}}
#' 
#' @examples
#' data("STATegRa_S3")
#' B1 <- createOmicsExpressionSet(Data=Block1.PCA, pData=ed.PCA,
#'                                pDataDescr=c("classname"))
#' B2 <- createOmicsExpressionSet(Data=Block2.PCA,
#'                                pData=ed.PCA, pDataDescr=c("classname"))
#' # Omics components analysis
#' res <- omicsCompAnalysis(Input=list(B1, B2), Names=c("expr", "mirna"),
#'                          method="DISCOSCA", Rcommon=2, Rspecific=c(2, 2),
#'                          center=TRUE, scale=TRUE, weight=TRUE)
#' getMethodInfo(res)
#' getMethodInfo(res, method=TRUE)
#' getMethodInfo(res, comps="all", block="expr")
setGeneric(
    name="getMethodInfo",
    def=function(x, method=FALSE, comps=NULL, block=NULL) {
        standardGeneric("getMethodInfo")
    }
)

setMethod(
    f="getMethodInfo",
    signature=signature(x="caClass"),
    definition=function(x, method, comps, block) {
        if (class(x) != "caClass"){
            stop("x is not a caclass object")
        } else {
            if (method & !is.null(comps)) {
                comps <- match.arg(comps, choices=c("common",
                                                    "distinctive",
                                                    "all"))
                if (comps == "common") {
                    res <- list(method=x@caMethod, comps=x@commonComps)
                } else if (comps == "distinctive") {
                    if (is.null(block)) {
                        res <- list(method=x@caMethod, comps=x@distComps)
                    } else {
                        if (block == "1" | block == x@Names[1]) {
                            res <- list(method=x@caMethod, comps=x@distComps[1])
                        } else if (block == "2" | block == x@Names[2]) {
                            res <- list(method=x@caMethod, comps=x@distComps[2])
                        } else {
                            warning(paste(block, "is not an allowed option"))
                            res <- list(method=x@caMethod, comps=x@distComps)
                        }
                    }
                } else if (comps == "all"){
                    if (is.null(block)) {
                        res <- list(method=x@caMethod,
                                    comps=list(common=x@commonComps,
                                               distinctive=x@distComps))
                    } else {
                        if (block == "1" | block == x@Names[1]) {
                            res <- list(method=x@caMethod,
                                        comps=list(common=x@commonComps,
                                                   distinctive=x@distComps[1]))
                        } else if (block == "2" | block == x@Names[2]) {
                            res <- list(method=x@caMethod,
                                        comps=list(common=x@commonComps,
                                                   distinctive=x@distComps[2]))
                        } else{
                            warning(paste(block, "is not an allowed option"))
                            res <- list(method=x@caMethod,
                                        comps=list(common=x@commonComps,
                                                   distinctive=x@distComps))
                        }
                    }
                }
            } else if (method) {
                res <- x@caMethod
            } else if (!is.null(comps)) {
                comps <- match.arg(comps, choices=c("common",
                                                    "distinctive",
                                                    "all"))
                if (comps == "common") {
                    res <- x@commonComps
                } else if (comps == "distinctive") {
                    if (is.null(block)) {
                        res <- x@distComps
                    } else {
                        if (block == "1" | block == x@Names[1]) {
                            res <- x@distComps[1]
                        } else if (block == "2" | block == x@Names[2]) {
                            res <- x@distComps[2]
                        } else {
                            warning(paste(block, "is not an allowed option. The output is the list of both blocks"))
                            res <- x@distComps
                        }
                    }
                } else if (comps == "all") {
                    if (is.null(block)) {
                        res <- list(common=x@commonComps,
                                    distinctive=x@distComps)
                    } else {
                        if (block == "1" | block == x@Names[1]) {
                            res <- list(common=x@commonComps,
                                        distinctive=x@distComps[1])
                        } else if (block == "2" | block == x@Names[2]) {
                            res <- list(common=x@commonComps,
                                        distinctive=x@distComps[2])
                        } else {
                            warning(paste(block, "is not an allowed option. The output is the list of both blocks"))
                            res <- list(common=x@commonComps,
                                        distinctive=x@distComps)
                        }
                    }
                }
            } else {
                res <- list(method=x@caMethod, 
                            comps=list(common=x@commonComps,
                                       distinctive=x@distComps))
            }
        }
        return(res)
    }
)


#' @export
#' @title Retrieve component analysis scores
#' @aliases getScores,caClass-method
#' @description 
#' Generic function to retrieve scores (common and distinctive) found by \code{\link{omicsCompAnalysis}} on a \code{\link{caClass-class}} object.
#' @usage getScores(x, part=NULL, block=NULL)
#' @param x \code{\link{caClass-class}} object.
#' @param part Character indicating whether "common" or "distinctive" scores should be displayed
#' @param block Character indicating the block of data for which the scores will be given. It can be specified by the position of the block ("1" or "2") or the name assigned in the \code{\link{caClass-class}} object. If it is NULL both blocks are displayed.
#' 
#' @return A list containing the requested information.
#'  
#' 
#' @author Patricia Sebastian-Leon
#' @seealso \code{\link{omicsCompAnalysis}}, \code{\link{caClass-class}}
#' 
#' @examples
#' data("STATegRa_S3")
#' B1 <- createOmicsExpressionSet(Data=Block1.PCA, pData=ed.PCA,
#'                                pDataDescr=c("classname"))
#' B2 <- createOmicsExpressionSet(Data=Block2.PCA,
#'                                pData=ed.PCA, pDataDescr=c("classname"))
#' # Omics components analysis
#' res <- omicsCompAnalysis(Input=list(B1, B2), Names=c("expr", "mirna"),
#'                          method="DISCOSCA", Rcommon=2, Rspecific=c(2, 2),
#'                          center=TRUE, scale=TRUE, weight=TRUE)
#' getScores(res)
#' getScores(res, part="common")
#' getScores(res, part="distinctive", block="expr")
setGeneric(
    name="getScores",
    def=function(x, part=NULL, block=NULL) { standardGeneric("getScores") }
)

setMethod(
    f="getScores",
    signature=signature(x="caClass"),
    definition=function(x, part, block) {
        if (class(x) != "caClass") {
            stop("x is not a caclass object")
        } else {
            if (is.null(part)) {
                res <- x@scores
            } else {
                if (x@caMethod == "DISCO-SCA" | x@caMethod == "JIVE") {
                    part <- match.arg(part, choices=c("common", "distinctive"))
                    if (part == "common") {
                        res <- x@scores$common
                        if (!is.null(block)) {
                            warning(paste("Using", x@caMethod,
                                          "scores for common part are referring to both blocks together"))
                        }
                    } else if (part == "distinctive") {
                        if (is.null(block)) {
                            res <- x@scores$dist
                        } else if (block == "1" | block == x@Names[1]) {
                            res <- x@scores$dist[[1]]
                        } else if (block == "2" | block == x@Names[2]) {
                            res <- x@scores[[2]]
                        } else {
                            warning(paste(block, "is not an allowed option."))
                            res <- x@scores
                        }
                    }
                } else if (x@caMethod == "O2PLS") {
                    if (part == "common") {
                        if (is.null(block)) {
                            res <- x@scores$common
                        } else if (block == "1" | block == x@Names[1]) {
                            res <- x@scores$common[[1]]
                        } else if (block == "2" | block == x@Names[2]) {
                            res <- x@scores$common[[2]]
                        } else {
                            warning(paste(block, "is not an allowed option."))
                            res <- x@scores$common
                        }
                    } else if (part=="distinctive") {
                        if (is.null(block)) {
                            res <- x@scores$dist
                        } else if (block == "1" | block == x@Names[1]) {
                            res <- x@scores$dist[[1]]
                        } else if (block == "2" | block == x@Names[2]) {
                            res <- x@scores$dist[[2]]
                        } else {
                            warning(paste(block, "is not an allowed option."))
                            res <- x@scores$dist
                        }
                    }
                }
            }
        }
        return(res)
    }
)


#' @export
#' @title Retrieve component analysis loadings
#' @aliases getLoadings,caClass-method
#' @description 
#' Generic function to retrieve loadings (common and distinctive) found by \code{\link{omicsCompAnalysis}} on a \code{\link{caClass-class}} object.
#' @usage getLoadings(x, part=NULL, block=NULL)
#' @param x \code{\link{caClass-class}} object.
#' @param part Character indicating whether "common" or "distinctive" loadings should be displayed
#' @param block Character indicating the block of data for which the loadings will be given. It can be specified by the position of the block ("1" or "2") or the name assigned in the \code{\link{caClass-class}} object. If it is NULL both blocks are displayed.
#' 
#' @return A list containing the requested information.
#'  
#' @author Patricia Sebastian-Leon
#' @seealso \code{\link{omicsCompAnalysis}}, \code{\link{caClass-class}}
#' 
#' @examples
#' data("STATegRa_S3")
#' B1 <- createOmicsExpressionSet(Data=Block1.PCA, pData=ed.PCA,
#'                                pDataDescr=c("classname"))
#' B2 <- createOmicsExpressionSet(Data=Block2.PCA,
#'                                pData=ed.PCA, pDataDescr=c("classname"))
#' # Omics components analysis
#' res <- omicsCompAnalysis(Input=list(B1, B2), Names=c("expr", "mirna"),
#'                          method="DISCOSCA", Rcommon=2, Rspecific=c(2, 2),
#'                          center=TRUE, scale=TRUE, weight=TRUE)
#' getLoadings(res)
#' getLoadings(res, part="common", block="expr")
#' getLoadings(res, part="distinctive", block="expr")
setGeneric(
    name="getLoadings",
    def=function(x, part=NULL, block=NULL) { standardGeneric("getLoadings") }
)

setMethod(
    f="getLoadings",
    signature=signature(x="caClass"),
    definition=function(x, part, block){
        if (class(x) != "caClass") {
            stop("x is not a caclass object")
        } else {
            if (is.null(part)) {
              res <- x@loadings
            } else {
                part <- match.arg(part, choices=c("common", "distinctive"))
                if (part == "common"){
                    if (is.null(block)) {
                        res <- x@loadings$common
                    } else if (block == "1" | block == x@Names[1]) {
                        res <- x@loadings$common[[1]]
                    } else if (block == "2" | block == x@Names[2]) {
                        res <- x@loadings$common[[2]]
                    } else{
                        warning(paste(block, "is not an allowed option."))
                        res <- x@loadings$common
                    }
                } else if (part == "distinctive") {
                    if (is.null(block)) {
                        res <- x@loadings$dist
                    } else if (block == "1" | block == x@Names[1]) {
                        res <- x@loadings$dist[[1]]
                    } else if (block == "2" | block == x@Names[2]) {
                        res <- x@loadings$dist[[2]]
                    } else {
                        warning(paste(block, "is not an allowed option."))
                        res <- x@loadings$dist
                    }
                }
            }
        }
        return(res)
    }
)


#' @export
#' @title Retrieve information abotut VAF
#' @aliases getVAF,caClass-method
#' @description 
#' Generic function to retrieve VAF found by \code{\link{omicsCompAnalysis}} on a \code{\link{caClass-class}} object.
#' @usage getVAF(x, part=NULL, block=NULL)
#' @param x \code{\link{caClass-class}} object.
#' @param part Character indicating whether "common" or "distinctive" VAF should be displayed
#' @param block Character indicating the block of data for which the VAF will be given. It can be specified by the position of the block ("1" or "2") or the name assigned in the \code{\link{caClass-class}} object. If it is NULL both blocks are displayed.
#' 
#' @return A list containing the requested information.
#'  
#' @author Patricia Sebastian-Leon
#' @seealso \code{\link{omicsCompAnalysis}}, \code{\link{caClass-class}}
#' 
#' @examples
#' data("STATegRa_S3")
#' B1 <- createOmicsExpressionSet(Data=Block1.PCA, pData=ed.PCA,
#'                                pDataDescr=c("classname"))
#' B2 <- createOmicsExpressionSet(Data=Block2.PCA,
#'                                pData=ed.PCA, pDataDescr=c("classname"))
#' # Omics components analysis
#' res <- omicsCompAnalysis(Input=list(B1, B2), Names=c("expr", "mirna"),
#'                          method="DISCOSCA", Rcommon=2, Rspecific=c(2, 2),
#'                          center=TRUE, scale=TRUE, weight=TRUE)
#' getVAF(res)
#' getVAF(res, part="common")
#' getVAF(res, part="distinctive", block="expr")
setGeneric(
    name="getVAF",
    def=function(x, part=NULL, block=NULL) { standardGeneric("getVAF") }
)

setMethod(
    f="getVAF",
    signature=signature(x="caClass"),
    definition=function(x, part, block){
        if (class(x) != "caClass") {
            stop("x is not a caclass object")
        } else {
            if (x@caMethod == "DISCO-SCA") {
                if (is.null(part)) {
                    res <- x@VAF
                } else {
                    part <- match.arg(part, choices=c("common", "distinctive"))
                    if (part == "common") {
                        res <- x@VAF$common
                    } else if(part=="distinctive") {
                        if (is.null(block)) {
                            res <- x@VAF$dist
                        } else if (block == "1" | block == x@Names[1]) {
                            res <- x@VAF$dist$Block1
                        } else if (block == "2" | block == x@Names[2]) {
                            res <- x@VAF$dist$Block2
                        } else if (block=="cross") {
                            res <- x@VAF$dist$cross
                        } else {
                            warning(paste(block, "is not an allowed option."))
                            res <- x@VAF$common
                        }
                    }
                }
            } else if (x@caMethod == "JIVE") {
                if (is.null(part)) {
                    res <- x@VAF
                } else {
                    part <- match.arg(part, choices=c("common", "distinctive"))
                    if (part == "common") {
                        res <- x@VAF$common
                    } else if (part == "distinctive") {
                        if (is.null(block)) {
                            res <- x@VAF$dist
                        } else if (block == "1" | block == x@Names[1]) {
                            res <- x@VAF$dist$Block1
                        } else if (block == "2" | block == x@Names[2]) {
                            res <- x@VAF$dist$Block2
                        } else {
                            warning(paste(block, "is not an allowed option."))
                            res <- x@VAF$dist
                        }
                    }
                }
            } else if (x@caMethod == "O2PLS") {
                warning("VAF per component cannot be calculated with O2PLS approach because components are not orthogonal")
                res <- NULL
            }
        }
        return(res)
    }
)

########  CLASS CONNECTING ELEMENTS
# we need `methods` for all the setClass/setMethod/setGeneric stuff, importing it arbitarily here
#' @import methods
setClass("bioMap",
         slots = c(name = "character",
                   metadata = "list",
                   map= "data.frame")
)
#### Vocabulary:
# name: is the name of the mapping, as a reference
# metadata: is a list of elements including references to the origin of the data
#            meta-data list must include the following variables:
#             type_v1: the type of variable 1
#             type_v2: the type of variable 2
#             source_database: the source data-base it was extracted from.
#             data_extraction: the date the mapping was gathered.
#
# map: is the actual mapping, data frame:
#           column 1: name "Var1" features of the variable 1
#           column 2: name "Var2" features of the variable 2
#           column 3 to x: the following columns are possible to exist, but not necessary:
#               "distance": distance between features
#               "location": exon, intron, etc...
#               "evidence": the origin of the evidence: "experimental", "computational",...
# Note that the vocabulary for data types is: transcript, gene, protein, metabolite, SNP , genomicRegion, etc.

####### INITIALIZE

setMethod(
    f="initialize",
    signature="bioMap",
    definition=function(.Object, name = "",
                        metadata = list(),
                        map = data.frame())
    {
        .Object@name <- name
        .Object@metadata <- metadata
        .Object@map <- map
        return(.Object)
    }
)

#######  ACCESSORS

setGeneric(
    name= "getName",
    def=function(object){standardGeneric("getName")}
)

setMethod(
    f= "getName",
    signature= "bioMap",
    definition=function(object){
        return(object@name)
    }
)

setGeneric(
    name= "getMetadata",
    def=function(object){standardGeneric("getMetadata")}
)

setMethod(
    f= "getMetadata",
    signature= "bioMap",
    definition=function(object){
        return(object@metadata)
    }
)

setGeneric(
    name= "getMap",
    def=function(object){standardGeneric("getMap")}
)

setMethod(
    f= "getMap",
    signature= "bioMap",
    definition=function(object){
        return(object@map)
    }
)

##########################################
##### SET
##########################################

setGeneric(
    "setName<-",function(object,value)
    {
        standardGeneric("setName<-")
    }
)

setReplaceMethod(
    f="setName",
    signature="bioMap",
    definition=function(object,value)
    {
        object@name <- value
        return (object)
    }
)

setGeneric(
    "setMetadata<-",function(object,value)
    {
        standardGeneric("setMetadata<-")
    }
)

setReplaceMethod(
    f="setMetadata",
    signature="bioMap",
    definition=function(object,value)
    {
        object@metadata <-value
        return (object)
    }
)

setGeneric(
    "setMap<-",function(object,value)
    {
        standardGeneric("setMap<-")
    }
)

setReplaceMethod(
    f="setMap",
    signature="bioMap",
    definition=function(object,value)
    {
        object@map <-value
        return (object)
    }
)

###### CONSTRUCTOR

#' @export
#' @title bioMap
#' @description Function to generate a bioMap object.
#' @usage bioMap(name, metadata, map)
#' @param name Name to assign the object
#' @param metadata A list with information of the mapping. Elements expected in the list are: (1) "type_v1" and "type_v2", refer to the nature of the features mapped; a vocabulary we recommend is "gene", "mRNA", "miRNA", "proteins", etc. (2) "source_database", provides information on the source of the mapping; from a specific data-base e.g. "targetscan.Hs.eg.db" to a genomic location mapping. (3) "data_extraction" stores information on the data the mapping was generated or downloaded.
#' @param map A data.frame object storing the mapping. The data.frame may inclue an unlimited number of columns, however the first column must be named "Var1" and refer to the elements of "type_v1" and simmilarly for the second column ("Var2", "type_v2").
#' @return An object of class \code{bioMap}
#' @author David Gomez-Cabrero
#' @examples 
#' data(STATegRa_S2)
#' map.gene.miRNA<-bioMap(name = "Symbol-miRNA",
#'                        metadata = list(type_v1="Gene",type_v2="miRNA",
#'                                        source_database="targetscan.Hs.eg.db",
#'                                        data_extraction="July2014"),
#'                        map=mapdata)
bioMap <- function(name, metadata, map)
{
    new("bioMap", name=name, metadata=metadata, map=map)
}

#' @export
#' @import Biobase
#' @title createOmicsExpressionSet
#' @aliases createOmicsExpressionSet,matrix-method
#'
#' @description
#' This function allow to the user to create a ExpressionSet object from a matrix representing an omics dataset. It allows to include the experimental design and annotation in the ExpressionSet object.
#'
#' @details
#' In Data matrix, samples has to be in columns and variables has to be in rows
#'
#' @param Data Omics data
#' @param pData Data associated with the samples/phenotype
#' @param pDataDescr Description of the phenotypic data
#' @param feaData Data associated with the variables/features annotation
#' @param feaDataDescr Description of the feature annotation
#' @return ExpressionSet with the data provided
#' @author Patricia Sebastian-Leon
#' @keywords datagen
#'
#' @examples
#' data(STATegRa_S3)
#' B1 <- createOmicsExpressionSet(Data=Block1.PCA,pData=ed.PCA,
#'                                pDataDescr=c("classname"))
#' B2 <- createOmicsExpressionSet(Data=Block2.PCA,pData=ed.PCA,
#'                                pDataDescr=c("classname"))
setGeneric(
    name="createOmicsExpressionSet",
    def=function(Data,pData=NULL,pDataDescr=NULL,feaData=NULL,feaDataDescr=NULL){
        standardGeneric("createOmicsExpressionSet")}
)

setMethod(
    f="createOmicsExpressionSet",
    signature=signature(
        Data="matrix"),
    definition=function(Data,pData,pDataDescr,feaData,feaDataDescr){
        ## Data
        exprs <- as.matrix(Data)
        ## Phenotypic data
        
        if(is.null(pData)){
            if (is.null(colnames(exprs))) {
                stop("If the data has no colnames, pData with names must be provided")
            }
            pData <- data.frame(Names=colnames(exprs))
            rownames(pData) <- colnames(exprs)
            pDataDescr <-c("Sample name")
        } else if (is.null(pDataDescr)) {
            pDataDescr <- colnames(pData)
        }
        pData <- as.data.frame(pData)
        if (is.null(rownames(pData)) | !all(rownames(pData)==colnames(exprs))){
            stop("pData rownames and exprs colnames must be the same")
        }
        metadata <- data.frame(labelDescription=pDataDescr)
        rownames(metadata) <- colnames(pData)
        phenoData <- new("AnnotatedDataFrame",data=pData,varMetadata=metadata)
        ## Feature data
        if(is.null(feaData)){
            if (is.null(rownames(exprs))) {
                stop("If the data has no rownames, feaData with names must be provided")
            }
            feaData <- data.frame(Name=rownames(exprs))
            rownames(feaData) <- rownames(exprs)
            feaDataDescr <- c("Feature name")
        } else if (is.null(feaDataDescr)) {
            feaDataDescr <- colnames(feaData)
        }
        fData <- as.data.frame(feaData)
        if (is.null(rownames(fData)) | !all(rownames(fData)==rownames(exprs))){
            stop("annot rownames and exprs rownames must be the same")
        }
        metadata2 <- data.frame(labelDescription=feaDataDescr)
        rownames(metadata2) <- colnames(fData)
        featureData <- new("AnnotatedDataFrame",data=fData,varMetadata=metadata2)
        ## ExpressionSet
        es <- new("ExpressionSet",exprs=exprs,phenoData=phenoData,featureData=featureData)
        return(es)
    }
)


#' @export
#' @importFrom utils browseURL
#' @title STATegRaUsersGuide
#'
#' @description Finds the location of the STATegRa User's Guide and optionally opens it.
#'
#' @param view Whether to open a browser
#' @return The path to the documentation
#' @author David Gomez-Cabrero
#'
#' @examples
#' STATegRaUsersGuide(view=FALSE)
STATegRaUsersGuide <- function(view=TRUE)
    #	Find and optionally view edgeR STATegRa Guide
    #	David Gomez-Cabrero, following Gordon Smyth example on edgeR
    #	23 May 2012.
{
    f <- system.file("doc", "STATegRa.html", package="STATegRa")
    if(view) {
        browseURL(f)
    }
    return(f)
}

###########################################
########### EXAMPLE OF THE OMICSPCA
###########################################
require(STATegRa)

# g_legend (not exported by STATegRa any more)
## code from https://github.com/hadley/ggplot2/wiki/Share-a-legend-between-two-ggplot2-graphs
g_legend<-function(a.gplot){
    tmp <- ggplot_gtable(ggplot_build(a.gplot))
    leg <- which(sapply(tmp$grobs, function(x) x$name) == "guide-box")
    legend <- tmp$grobs[[leg]]
    return(legend)}

#########################
## PART 1. Load data

## Load data
data(STATegRa_S3)

ls()

## Create ExpressionSets
# Block1 - Expression data
B1 <- createOmicsExpressionSet(Data=Block1.PCA,pData=ed.PCA,pDataDescr=c("classname"))
# Block2 - miRNA expression data
B2 <- createOmicsExpressionSet(Data=Block2.PCA,pData=ed.PCA,pDataDescr=c("classname"))

#########################
## PART 2.  Model Selection

require(grid)
require(gridExtra)
require(ggplot2)

## Select the optimal components
ms <- modelSelection(Input=list(B1,B2),Rmax=4,fac.sel="single%",varthreshold=0.03,center=TRUE,scale=TRUE,weight=TRUE)


#########################
## PART 3. Component Analysis

## 3.1 Component analysis of the three methods
discoRes <- omicsCompAnalysis(Input=list(B1,B2),Names=c("expr","mirna"),method="DISCOSCA",Rcommon=2,Rspecific=c(2,2),center=TRUE,
                              scale=TRUE,weight=TRUE)
jiveRes <- omicsCompAnalysis(Input=list(B1,B2),Names=c("expr","mirna"),method="JIVE",Rcommon=2,Rspecific=c(2,2),center=TRUE,
                             scale=TRUE,weight=TRUE)
o2plsRes <- omicsCompAnalysis(Input=list(B1,B2),Names=c("expr","mirna"),method="O2PLS",Rcommon=2,Rspecific=c(2,2),center=TRUE,
                              scale=TRUE,weight=TRUE)

## 3.2 Exploring scores structures

# Exploring DISCO-SCA scores structure
discoRes@scores$common ## Common scores
discoRes@scores$dist[[1]] ## Distinctive scores for Block 1
discoRes@scores$dist[[2]] ## Distinctive scores for Block 2
# Exploring O2PLS scores structure
o2plsRes@scores$common[[1]] ## Common scores for Block 1
o2plsRes@scores$common[[2]] ## Common scores for Block 2
o2plsRes@scores$dist[[1]] ## Distinctive scores for Block 1
o2plsRes@scores$dist[[2]] ## Distinctive scores for Block 2

## 3.3 Plotting VAF

# DISCO-SCA plotVAF
plotVAF(discoRes)

# JIVE plotVAF
plotVAF(jiveRes)


#########################
## PART 4. Plot Results

# Scores for common part. DISCO-SCA
plotRes(object=discoRes,comps=c(1,2),what="scores",type="common",
             combined=FALSE,block=NULL,color="classname",shape=NULL,labels=NULL,
             background=TRUE,palette=NULL,pointSize=4,labelSize=NULL,
             axisSize=NULL,titleSize=NULL)

# Scores for common part. JIVE
plotRes(object=jiveRes,comps=c(1,2),what="scores",type="common",
             combined=FALSE,block=NULL,color="classname",shape=NULL,labels=NULL,
             background=TRUE,palette=NULL,pointSize=4,labelSize=NULL,
             axisSize=NULL,titleSize=NULL)

# Scores for common part. O2PLS.
p1 <- plotRes(object=o2plsRes,comps=c(1,2),what="scores",type="common",
              combined=FALSE,block="expr",color="classname",shape=NULL,
              labels=NULL,background=TRUE,palette=NULL,pointSize=4,
              labelSize=NULL,axisSize=NULL,titleSize=NULL)
p2 <- plotRes(object=o2plsRes,comps=c(1,2),what="scores",type="common",
              combined=FALSE,block="mirna",color="classname",shape=NULL,
              labels=NULL,background=TRUE,palette=NULL,pointSize=4,
              labelSize=NULL,axisSize=NULL,titleSize=NULL)
legend <- g_legend(p1)
grid.arrange(arrangeGrob(p1+theme(legend.position="none"),
                         p2+theme(legend.position="none"),nrow=1),
             legend,heights=c(6/7,1/7))

# Combined plot of scores for common part. O2PLS.
plotRes(object=o2plsRes,comps=c(1,1),what="scores",type="common",
             combined=TRUE,block=NULL,color="classname",shape=NULL,
             labels=NULL,background=TRUE,palette=NULL,pointSize=4,
             labelSize=NULL,axisSize=NULL,titleSize=NULL)


# Scores for distinctive part. DISCO-SCA. (two plots one for each block)
p1 <- plotRes(object=discoRes,comps=c(1,2),what="scores",type="individual",
              combined=FALSE,block="expr",color="classname",shape=NULL,
              labels=NULL,background=TRUE,palette=NULL,pointSize=4,
              labelSize=NULL,axisSize=NULL,titleSize=NULL)
p2 <- plotRes(object=discoRes,comps=c(1,2),what="scores",type="individual",
              combined=FALSE,block="mirna",color="classname",shape=NULL,
              labels=NULL,background=TRUE,palette=NULL,pointSize=4,
              labelSize=NULL,axisSize=NULL,titleSize=NULL)
legend <- g_legend(p1)
grid.arrange(arrangeGrob(p1+theme(legend.position="none"),
                         p2+theme(legend.position="none"),nrow=1),
             legend,heights=c(6/7,1/7))

# Combined plot of scores for distinctive part. DISCO-SCA
plotRes(object=discoRes,comps=c(1,1),what="scores",type="individual",
             combined=TRUE,block=NULL,color="classname",shape=NULL,
             labels=NULL,background=TRUE,palette=NULL,pointSize=4,
             labelSize=NULL,axisSize=NULL,titleSize=NULL)

# Combined plot of scores for common and distinctive part. O2PLS (two plots one for each block)
p1 <- plotRes(object=o2plsRes,comps=c(1,1),what="scores",type="both",
              combined=FALSE,block="expr",color="classname",shape=NULL,
              labels=NULL,background=TRUE,palette=NULL,pointSize=4,
              labelSize=NULL,axisSize=NULL,titleSize=NULL)
p2 <- plotRes(object=o2plsRes,comps=c(1,1),what="scores",type="both",
              combined=FALSE,block="mirna",color="classname",shape=NULL,
              labels=NULL,background=TRUE,palette=NULL,pointSize=4,
              labelSize=NULL,axisSize=NULL,titleSize=NULL)
legend <- g_legend(p1)
grid.arrange(arrangeGrob(p1+theme(legend.position="none"),
                         p2+theme(legend.position="none"),nrow=1),
             legend,heights=c(6/7,1/7))

# Combined plot of scores for common and distinctive part. DISCO  (two plots one for each block)
p1 <- plotRes(object=discoRes,comps=c(1,1),what="scores",type="both",
              combined=FALSE,block="expr",color="classname",shape=NULL,
              labels=NULL,background=TRUE,palette=NULL,pointSize=4,
              labelSize=NULL,axisSize=NULL,titleSize=NULL)
p2 <- plotRes(object=discoRes,comps=c(1,1),what="scores",type="both",
              combined=FALSE,block="mirna",color="classname",shape=NULL,
              labels=NULL,background=TRUE,palette=NULL,pointSize=4,
              labelSize=NULL,axisSize=NULL,titleSize=NULL)
legend <- g_legend(p1)
grid.arrange(arrangeGrob(p1+theme(legend.position="none"),
                         p2+theme(legend.position="none"),nrow=1),
             legend,heights=c(6/7,1/7))

# Loadings for common part. DISCO-SCA. (two plots one for each block)
p1 <- plotRes(object=discoRes,comps=c(1,2),what="loadings",type="common",
              combined=FALSE,block="expr",color="classname",shape=NULL,
              labels=NULL,background=TRUE,palette=NULL,pointSize=4,
              labelSize=NULL,axisSize=NULL,titleSize=NULL)
p2 <- plotRes(object=discoRes,comps=c(1,2),what="loadings",type="common",
              combined=FALSE,block="mirna",color="classname",shape=NULL,
              labels=NULL,background=TRUE,palette=NULL,pointSize=4,
              labelSize=NULL,axisSize=NULL,titleSize=NULL)
grid.arrange(arrangeGrob(p1+theme(legend.position="none"),
                         p2+theme(legend.position="none"),nrow=1),
             heights=c(6/7,1/7))


# Loadings for distinctive part. DISCO-SCA. (two plots one for each block)
p1 <- plotRes(object=discoRes,comps=c(1,2),what="loadings",type="individual",
              combined=FALSE,block="expr",color="classname",shape=NULL,
              labels=NULL,background=TRUE,palette=NULL,pointSize=4,
              labelSize=NULL,axisSize=NULL,titleSize=NULL)
p2 <- plotRes(object=discoRes,comps=c(1,2),what="loadings",type="individual",
              combined=FALSE,block="mirna",color="classname",shape=NULL,
              labels=NULL,background=TRUE,palette=NULL,pointSize=4,
              labelSize=NULL,axisSize=NULL,titleSize=NULL)
grid.arrange(arrangeGrob(p1+theme(legend.position="none"),
                         p2+theme(legend.position="none"),nrow=1),
             heights=c(6/7,1/7))


# Combined plot for loadings from common and distinctive part  (two plots one for each block)
p1 <- plotRes(object=discoRes,comps=c(1,1),what="loadings",type="both",
              combined=FALSE,block="expr",color="classname",shape=NULL,
              labels=NULL,background=TRUE,palette=NULL,pointSize=4,
              labelSize=NULL,axisSize=NULL,titleSize=NULL)
p2 <- plotRes(object=discoRes,comps=c(1,1),what="loadings",type="both",
              combined=FALSE,block="mirna",color="classname",shape=NULL,
              labels=NULL,background=TRUE,palette=NULL,pointSize=4,
              labelSize=NULL,axisSize=NULL,titleSize=NULL)
grid.arrange(arrangeGrob(p1+theme(legend.position="none"),
                         p2+theme(legend.position="none"),nrow=1),
             heights=c(6/7,1/7))



## Plot scores and loadings togheter: Common components DISCO-SCA
p1 <- plotRes(object=discoRes,comps=c(1,2),what="both",type="common",
        combined=FALSE,block="expr",color="classname",shape=NULL,labels=NULL,
        background=TRUE,palette=NULL,pointSize=4,labelSize=NULL,
        axisSize=NULL,titleSize=NULL)
p2 <- plotRes(object=discoRes,comps=c(1,2),what="both",type="common",
              combined=FALSE,block="mirna",color="classname",shape=NULL,labels=NULL,
              background=TRUE,palette=NULL,pointSize=4,labelSize=NULL,
              axisSize=NULL,titleSize=NULL)
grid.arrange(arrangeGrob(p1+theme(legend.position="none"),
                         p2+theme(legend.position="none"),nrow=1),
             heights=c(6/7,1/7))


## Plot scores and loadings togheter:  Common components O2PLS
p1 <- plotRes(object=o2plsRes,comps=c(1,2),what="both",type="common",
              combined=FALSE,block="expr",color="classname",shape=NULL,labels=NULL,
              background=TRUE,palette=NULL,pointSize=4,labelSize=NULL,
              axisSize=NULL,titleSize=NULL)
p2 <- plotRes(object=o2plsRes,comps=c(1,2),what="both",type="common",
              combined=FALSE,block="mirna",color="classname",shape=NULL,labels=NULL,
              background=TRUE,palette=NULL,pointSize=4,labelSize=NULL,
              axisSize=NULL,titleSize=NULL)
grid.arrange(arrangeGrob(p1+theme(legend.position="none"),
                         p2+theme(legend.position="none"),nrow=1),
             heights=c(6/7,1/7))


## Plot scores and loadings togheter: Distintive components DISCO-SCA
p1 <- plotRes(object=discoRes,comps=c(1,2),what="both",type="individual",
              combined=FALSE,block="expr",color="classname",shape=NULL,labels=NULL,
              background=TRUE,palette=NULL,pointSize=4,labelSize=NULL,
              axisSize=NULL,titleSize=NULL)
p2 <- plotRes(object=discoRes,comps=c(1,2),what="both",type="individual",
              combined=FALSE,block="mirna",color="classname",shape=NULL,labels=NULL,
              background=TRUE,palette=NULL,pointSize=4,labelSize=NULL,
              axisSize=NULL,titleSize=NULL)
grid.arrange(arrangeGrob(p1+theme(legend.position="none"),
                         p2+theme(legend.position="none"),nrow=1),
             heights=c(6/7,1/7))

## ----echo=F, message=F, results="asis"----------------------------------------
# this block is invisible
BiocStyle::markdown()
require(STATegRa)
require(Biobase)
require(gridExtra)
require(ggplot2)
g_legend<-function(a.gplot){
    tmp <- ggplot_gtable(ggplot_build(a.gplot))
    leg <- which(sapply(tmp$grobs, function(x) x$name) == "guide-box")
    legend <- tmp$grobs[[leg]]
    return(legend)}

## ----eval=F-------------------------------------------------------------------
# library(STATegRa) # Load STATegRa package

## ----eval=F-------------------------------------------------------------------
# help(package="STATegRa") ## Package help
# ?omicsCompAnalysis ## Specific function help

## -----------------------------------------------------------------------------
data("STATegRa_S3")
ls()

## -----------------------------------------------------------------------------
# Block1 - gene expression data
B1 <- createOmicsExpressionSet(Data=Block1.PCA, pData=ed.PCA,
                               pDataDescr=c("classname"))

# Block2 - miRNA expression data
B2 <- createOmicsExpressionSet(Data=Block2.PCA, pData=ed.PCA, 
                               pDataDescr=c("classname"))

## -----------------------------------------------------------------------------
ms <- modelSelection(Input=list(B1, B2), Rmax=3, fac.sel="single%",
                     varthreshold=0.03, center=TRUE, scale=TRUE, 
                     weight=TRUE, plot_common=FALSE, plot_dist=FALSE)

grid.arrange(ms$common$pssq, ms$common$pratios, ncol=2) #switching plot_common=TRUE gives automaticaly these plots

## -----------------------------------------------------------------------------
discoRes <- omicsCompAnalysis(Input=list(B1, B2), Names=c("expr", "mirna"),
                              method="DISCOSCA", Rcommon=2, Rspecific=c(2, 2),
                              center=TRUE, scale=TRUE, weight=TRUE)
jiveRes <- omicsCompAnalysis(Input=list(B1, B2), Names=c("expr", "mirna"),
                             method="JIVE", Rcommon=2, Rspecific=c(2, 2),
                             center=TRUE, scale=TRUE, weight=TRUE)
o2plsRes <- omicsCompAnalysis(Input=list(B1, B2),Names=c("expr", "mirna"),
                              method="O2PLS", Rcommon=2, Rspecific=c(2, 2),
                              center=TRUE, scale=TRUE, weight=TRUE)

## -----------------------------------------------------------------------------
slotNames(discoRes)

## ----results="hide"-----------------------------------------------------------
# Exploring DISCO-SCA (or JIVE) score structure
getScores(discoRes, part="common")
getScores(discoRes, part="distinctive", block="1")
getScores(discoRes, part="distinctive", block="2")

# Exploring O2PLS score structure
getScores(o2plsRes, part="common", block="expr")
getScores(o2plsRes, part="common", block="mirna")
getScores(o2plsRes, part="distinctive", block="1")
getScores(o2plsRes, part="distinctive", block="2")

## -----------------------------------------------------------------------------
# DISCO-SCA plotVAF
getVAF(discoRes)
plotVAF(discoRes)

# JIVE plotVAF
getVAF(jiveRes)
plotVAF(jiveRes)

## -----------------------------------------------------------------------------
# Scatterplot of scores variables associated to common components

# DISCO-SCA
plotRes(object=discoRes, comps=c(1, 2), what="scores", type="common",
        combined=FALSE, block=NULL, color="classname", shape=NULL, labels=NULL,
        background=TRUE, palette=NULL, pointSize=4, labelSize=NULL,
        axisSize=NULL, titleSize=NULL) 

# JIVE
plotRes(object=jiveRes, comps=c(1, 2), what="scores", type="common",
        combined=FALSE, block=NULL, color="classname", shape=NULL, labels=NULL,
        background=TRUE, palette=NULL, pointSize=4, labelSize=NULL,
        axisSize=NULL, titleSize=NULL) 

## -----------------------------------------------------------------------------
# O2PLS 
# Scatterplot of scores variables associated to common components

# Associated to first block
p1 <- plotRes(object=o2plsRes, comps=c(1, 2), what="scores", type="common",
              combined=FALSE, block="expr", color="classname", shape=NULL,
              labels=NULL, background=TRUE, palette=NULL, pointSize=4,
              labelSize=NULL, axisSize=NULL, titleSize=NULL)
# Associated to second block
p2 <- plotRes(object=o2plsRes, comps=c(1, 2), what="scores", type="common",
              combined=FALSE, block="mirna", color="classname", shape=NULL,
              labels=NULL, background=TRUE, palette=NULL, pointSize=4,
              labelSize=NULL, axisSize=NULL, titleSize=NULL)
# Combine both plots
# g_legend function from
# https://github.com/hadley/ggplot2/wiki/Share-a-legend-between-two-ggplot2-graphs
legend <- g_legend(p1)
grid.arrange(arrangeGrob(p1+theme(legend.position="none"),
                         p2+theme(legend.position="none"), nrow=1),
             legend, heights=c(6/7, 1/7))

# Combined plot of scores variables assocaited to common components
plotRes(object=o2plsRes, comps=c(1, 1), what="scores", type="common",
        combined=TRUE, block=NULL, color="classname", shape=NULL,
        labels=NULL, background=TRUE, palette=NULL, pointSize=4,
        labelSize=NULL, axisSize=NULL, titleSize=NULL) 

## -----------------------------------------------------------------------------
# DISCO-SCA scores scatterplot associated to individual components

# Associated to first block
p1 <- plotRes(object=discoRes, comps=c(1, 2), what="scores", type="individual",
              combined=FALSE, block="expr", color="classname", shape=NULL,
              labels=NULL, background=TRUE, palette=NULL, pointSize=4,
              labelSize=NULL, axisSize=NULL, titleSize=NULL)
# Associated to second block
p2 <- plotRes(object=discoRes, comps=c(1, 2), what="scores", type="individual",
              combined=FALSE, block="mirna", color="classname", shape=NULL,
              labels=NULL, background=TRUE, palette=NULL, pointSize=4,
              labelSize=NULL, axisSize=NULL, titleSize=NULL)
# Combine plots
legend <- g_legend(p1)
grid.arrange(arrangeGrob(p1+theme(legend.position="none"),
                         p2+theme(legend.position="none"), nrow=1),
             legend, heights=c(6/7, 1/7))

# DISCO-SCA scores combined plot for individual components
plotRes(object=discoRes, comps=c(1, 1), what="scores", type="individual",
        combined=TRUE, block=NULL, color="classname", shape=NULL,
        labels=NULL, background=TRUE, palette=NULL, pointSize=4,
        labelSize=NULL, axisSize=NULL, titleSize=NULL)

## -----------------------------------------------------------------------------
# DISCO-SCA plot of scores for common and individual components
p1 <- plotRes(object=discoRes, comps=c(1, 1), what="scores", type="both",
              combined=FALSE, block="expr", color="classname", shape=NULL,
              labels=NULL, background=TRUE, palette=NULL, pointSize=4,
              labelSize=NULL, axisSize=NULL, titleSize=NULL)
p2 <- plotRes(object=discoRes, comps=c(1, 1), what="scores", type="both",
              combined=FALSE, block="mirna", color="classname", shape=NULL,
              labels=NULL, background=TRUE, palette=NULL, pointSize=4,
              labelSize=NULL, axisSize=NULL, titleSize=NULL)
legend <- g_legend(p1)
grid.arrange(arrangeGrob(p1+theme(legend.position="none"),
                         p2+theme(legend.position="none"), nrow=1),
             legend, heights=c(6/7, 1/7))

# O2PLS plot of scores for common and individual components
p1 <- plotRes(object=o2plsRes, comps=c(1, 1), what="scores", type="both",
              combined=FALSE, block="expr", color="classname", shape=NULL,
              labels=NULL, background=TRUE, palette=NULL, pointSize=4,
              labelSize=NULL, axisSize=NULL, titleSize=NULL)
p2 <- plotRes(object=o2plsRes, comps=c(1, 1), what="scores", type="both",
              combined=FALSE, block="mirna", color="classname", shape=NULL,
              labels=NULL, background=TRUE, palette=NULL, pointSize=4,
              labelSize=NULL, axisSize=NULL, titleSize=NULL)
legend <- g_legend(p1)
grid.arrange(arrangeGrob(p1+theme(legend.position="none"),
                         p2+theme(legend.position="none"), nrow=1),
             legend, heights=c(6/7, 1/7))

## -----------------------------------------------------------------------------
# Loadings plot for common components

# Separately for each block
p1 <- plotRes(object=discoRes, comps=c(1, 2), what="loadings", type="common",
              combined=FALSE, block="expr", color="classname", shape=NULL,
              labels=NULL, background=TRUE, palette=NULL, pointSize=4,
              labelSize=NULL, axisSize=NULL, titleSize=NULL)
p2 <- plotRes(object=discoRes, comps=c(1, 2), what="loadings", type="common",
              combined=FALSE, block="mirna", color="classname", shape=NULL,
              labels=NULL, background=TRUE, palette=NULL, pointSize=4,
              labelSize=NULL, axisSize=NULL, titleSize=NULL)
grid.arrange(arrangeGrob(p1+theme(legend.position="none"),
                         p2+theme(legend.position="none"), nrow=1), 
             heights=c(6/7, 1/7))

## -----------------------------------------------------------------------------
# Loadings plot for individual components

# Separately for each block
p1 <- plotRes(object=discoRes, comps=c(1, 2), what="loadings", type="individual",
              combined=FALSE, block="expr", color="classname", shape=NULL,
              labels=NULL, background=TRUE, palette=NULL, pointSize=4,
              labelSize=NULL, axisSize=NULL, titleSize=NULL)
p2 <- plotRes(object=discoRes, comps=c(1, 2), what="loadings", type="individual",
              combined=FALSE, block="mirna", color="classname", shape=NULL,
              labels=NULL, background=TRUE, palette=NULL, pointSize=4,
              labelSize=NULL, axisSize=NULL, titleSize=NULL)
grid.arrange(arrangeGrob(p1+theme(legend.position="none"),
                         p2+theme(legend.position="none"), nrow=1), 
             heights=c(6/7, 1/7))

## -----------------------------------------------------------------------------
p1 <- plotRes(object=discoRes, comps=c(1, 1), what="loadings", type="both",
              combined=FALSE, block="expr", color="classname", shape=NULL,
              labels=NULL, background=TRUE, palette=NULL, pointSize=4,
              labelSize=NULL, axisSize=NULL, titleSize=NULL)
p2 <- plotRes(object=discoRes, comps=c(1, 1), what="loadings", type="both",
              combined=FALSE, block="mirna", color="classname", shape=NULL,
              labels=NULL, background=TRUE, palette=NULL, pointSize=4,
              labelSize=NULL, axisSize=NULL, titleSize=NULL)
grid.arrange(arrangeGrob(p1+theme(legend.position="none"),
                         p2+theme(legend.position="none"), nrow=1), 
             heights=c(6/7, 1/7)) 

## ----warning=FALSE------------------------------------------------------------
# Scores and loading plot for common part. DISCO-SCA
p1 <- plotRes(object=discoRes, comps=c(1, 2), what="both", type="common", 
          combined=FALSE, block="expr", color="classname", shape=NULL,
          labels=NULL, background=TRUE, palette=NULL, pointSize=4,
          labelSize=NULL, axisSize=NULL, titleSize=NULL,
          sizeValues=c(2, 2), shapeValues=c(17, 0))
p2 <- plotRes(object=discoRes, comps=c(1, 2), what="both", type="common", 
          combined=FALSE, block="mirna", color="classname", shape=NULL,
          labels=NULL, background=TRUE, palette=NULL, pointSize=4,
          labelSize=NULL, axisSize=NULL, titleSize=NULL,
          sizeValues=c(2, 2), shapeValues=c(17, 0))
legend <- g_legend(p1)
grid.arrange(arrangeGrob(p1+theme(legend.position="none"),
                         p2+theme(legend.position="none"), nrow=1),
             legend, heights=c(6/7, 1/7))

# Scores and loadings plot for common part. O2PLS 
p1 <- plotRes(object=o2plsRes, comps=c(1, 2), what="both", type="common", 
          combined=FALSE, block="expr", color="classname", shape=NULL,
          labels=NULL, background=TRUE, palette=NULL, pointSize=4,
          labelSize=NULL, axisSize=NULL, titleSize=NULL,
          sizeValues=c(2, 2), shapeValues=c(17, 0))
p2 <- plotRes(object=o2plsRes, comps=c(1, 2), what="both", type="common", 
          combined=FALSE, block="mirna", color="classname", shape=NULL,
          labels=NULL, background=TRUE, palette=NULL, pointSize=4,
          labelSize=NULL, axisSize=NULL, titleSize=NULL,
          sizeValues=c(2, 2), shapeValues=c(17, 0))
legend <- g_legend(p1)
grid.arrange(arrangeGrob(p1+theme(legend.position="none"),
                         p2+theme(legend.position="none"), nrow=1),
             legend, heights=c(6/7, 1/7))

# Scores and loadings plot for distinctive part. O2PLS 
p1 <- plotRes(object=o2plsRes, comps=c(1, 2), what="both", type="individual", 
          combined=FALSE, block="expr", color="classname", shape=NULL,
          labels=NULL, background=TRUE, palette=NULL, pointSize=4,
          labelSize=NULL, axisSize=NULL, titleSize=NULL,
          sizeValues=c(2, 2), shapeValues=c(17, 0))
p2 <- plotRes(object=o2plsRes, comps=c(1, 2), what="both", type="individual", 
          combined=FALSE, block="mirna", color="classname", shape=NULL,
          labels=NULL, background=TRUE, palette=NULL, pointSize=4,
          labelSize=NULL, axisSize=NULL, titleSize=NULL,
          sizeValues=c(2, 2), shapeValues=c(17, 0))
legend <- g_legend(p1)
grid.arrange(arrangeGrob(p1+theme(legend.position="none"),
                         p2+theme(legend.position="none"), nrow=1),
             legend, heights=c(6/7, 1/7))

## ----echo=F, message=F--------------------------------------------------------
# clear the environment before starting the omicsClustering example
rm(list=ls())

## -----------------------------------------------------------------------------
data("STATegRa_S1")
ls()

## -----------------------------------------------------------------------------
# Block1 - Expression data
mRNA.ds <- createOmicsExpressionSet(Data=Block1, pData=ed, pDataDescr=c("classname"))
# Block2 - miRNA expression data
miRNA.ds <- createOmicsExpressionSet(Data=Block2, pData=ed, pDataDescr=c("classname"))

## -----------------------------------------------------------------------------
# Create Gene-gene distance computed through mRNA data
bioDistmRNA <- bioDistclass(name="mRNAbymRNA",
                            distance=cor(t(exprs(mRNA.ds)),
                                         method="spearman"),
                            map.name="id",
                            map.metadata=list(),
                            params=list())

## -----------------------------------------------------------------------------
data(STATegRa_S2)
ls()

## -----------------------------------------------------------------------------
MAP.SYMBOL <- bioMap(name = "Symbol-miRNA",
                     metadata = list(type_v1="Gene", type_v2="miRNA",
                                     source_database="targetscan.Hs.eg.db",
                                     data_extraction="July2014"),
                     map=mapdata)

## -----------------------------------------------------------------------------
bioDistmiRNA <- bioDist(referenceFeatures=rownames(Block1),     
                        reference="Var1",
                        mapping=MAP.SYMBOL,
                        surrogateData=miRNA.ds, 
                        referenceData=mRNA.ds, 
                        maxitems=2,
                        selectionRule="sd",
                        expfac=NULL,
                        aggregation="sum",
                        distance="spearman",
                        noMappingDist=0,
                        filtering=NULL,
                        name="mRNAbymiRNA")

## -----------------------------------------------------------------------------
bioDistList <- list(bioDistmRNA, bioDistmiRNA)

## -----------------------------------------------------------------------------
sample.weights <- matrix(0, 4, 2)
sample.weights[, 1] <- c(0, 0.33, 0.67, 1)
sample.weights[, 2] <- c(1, 0.67, 0.33, 0)
sample.weights

## -----------------------------------------------------------------------------
bioDistWList <- bioDistW(referenceFeatures=rownames(Block1),
                         bioDistList=bioDistList,
                         weights=sample.weights)
length(bioDistWList)

## ----warning=F----------------------------------------------------------------
bioDistWPlot(referenceFeatures=rownames(Block1),
             listDistW=bioDistWList,
             method.cor="spearman")

## -----------------------------------------------------------------------------
IDH1.F <- bioDistFeature(Feature="IDH1",
                         listDistW=bioDistWList,
                         threshold.cor=0.7)

## ----message=F----------------------------------------------------------------
bioDistFeaturePlot(data=IDH1.F)

## ----echo=F, message=F--------------------------------------------------------
# clear the environment before starting the omicsNPC example
rm(list=ls())

## -----------------------------------------------------------------------------
data("TCGA_BRCA_Batch_93")
ls()

## ----results='hide'-----------------------------------------------------------
exprs(TCGA_BRCA_Data$RNAseq) # displays the RNAseq data
exprs(TCGA_BRCA_Data$RNAseqV2) # displays the RNAseqV2 data
exprs(TCGA_BRCA_Data$Microarray) # displays the Exp-Gene data

## ----results='hide'-----------------------------------------------------------
pData(TCGA_BRCA_Data$RNAseq) # class of RNAseq samples
pData(TCGA_BRCA_Data$RNAseqV2) # class of RNAseqV2 samples
pData(TCGA_BRCA_Data$Microarray) # class of Exp-Gene samples

## -----------------------------------------------------------------------------
dataTypes <- c("count", "count", "continuous")

## -----------------------------------------------------------------------------
combMethods <- c("Fisher", "Liptak", "Tippett")

## -----------------------------------------------------------------------------
numPerms <- 1000

## -----------------------------------------------------------------------------
numCores <- 1

## -----------------------------------------------------------------------------
verbose <- TRUE

## -----------------------------------------------------------------------------
results <- omicsNPC(dataInput=TCGA_BRCA_Data, dataTypes=dataTypes,
                    combMethods=combMethods, numPerms=numPerms,
                    numCores=numCores, verbose=verbose)

#' @include STATegRa_omicsCLUST_bioMap.R

##################################
###### PART2: CLASS FOR THE DISTANCES
##################################


setClass("bioDistclass",
         slots=c(name = "character",
                 distance = "matrix",
                 map.name= "character",
                 map.metadata = "list",
                 params= "list") #
)

####### INITIALIZE

setMethod(
    f="initialize",
    signature="bioDistclass",
    definition=function(.Object, name = "",
                        distance = matrix,
                        map.name = "",
                        map.metadata = list(),
                        params = list())
    {
        .Object@name <- name
        .Object@distance <-  distance
        .Object@map.name <- map.name
        .Object@map.metadata <- map.metadata
        .Object@params <- params
        return(.Object)
    }
)

###### ACCESSING THEM

setMethod(
    f= "getName",
    signature= "bioDistclass",
    definition=function(object){
        return(object@name)
    }
)

setGeneric(
    name= "getDist",
    def=function(object){standardGeneric("getDist")}
)

setMethod(
    f= "getDist",
    signature= "bioDistclass",
    definition=function(object){
        return(object@distance)
    }
)

setGeneric(
    name= "getMapName",
    def=function(object){standardGeneric("getMapName")}
)

setMethod(
    f= "getMapName",
    signature= "bioDistclass",
    definition=function(object){
        return(object@map.name)
    }
)


setGeneric(
    name= "getMapInfo",
    def=function(object){standardGeneric("getMapInfo")}
)

setMethod(
    f= "getMapInfo",
    signature= "bioDistclass",
    definition=function(object){
        return(object@map.metadata)
    }
)

setGeneric(
    name= "getDistParam",
    def=function(object){standardGeneric("getDistParam")}
)

setMethod(
    f= "getDistParam",
    signature= "bioDistclass",
    definition=function(object){
        return(object@params)
    }
)

setGeneric(
    "setDist<-",function(object,value)
    {
        standardGeneric("setDist<-")
    }
)

setReplaceMethod(
    f="setDist",
    signature="bioDistclass",
    definition=function(object,value)
    {
        object@distance <-value
        return (object)
    }
)

###### CONSTRUCTOR

#' @export
#' @title bioDistclass
#' @description Class to manage mappings between genomic features.
#' @usage bioDistclass(name, distance, map.name, map.metadata, params)
#' @param name Name assigned to the object
#' @param distance Matrix giving the distance between features
#' @param map.name Charactering giving the name of the bioMap object used to compute the distance
#' @param map.metadata List of parameters used to generate the mapping
#' @param params List of parameters used to generate the distance
bioDistclass <- function(name, distance, map.name, map.metadata, params)
{
    new("bioDistclass", name=name, distance=distance, map.name=map.name, map.metadata=map.metadata, params=params)
}

######  bioAggregate function

setGeneric(
    name= "bioAggregate",
    def=function(referenceFeatures,
                 reference = "genes",
                 mapping,
                 referenceData = NULL,
                 surrogateData,
                 filtering = NULL,
                 aggregation = "sum",
                 maxitems = NULL,
                 selectionRule = "maxFC",
                 expfac = NULL,...){
        standardGeneric("bioAggregate")}
)

setMethod(
    f= "bioAggregate",
    signature(referenceFeatures = "character",
              mapping = "bioMap",
              surrogateData = "ExpressionSet",
              referenceData = "ExpressionSet"),
    definition=function(referenceFeatures,
                        reference = "genes",
                        mapping,
                        referenceData = NULL,
                        surrogateData,
                        filtering = NULL,   #c(a,b,c)
                        aggregation = "sum",
                        maxitems = NULL,
                        selectionRule = "sd",
                        expfac = NULL,...){

        #######################################
        ## STEP 0. Validity of input objects
        #######################################

        #######################################
        ## STEP 1. Filtering mapping
        #######################################
        #### By now we consider that it needs to provide
        ## a first element with the name of the column.
        ## a second element with the selected value

        filtmapping = getMap(mapping)
        # eliminate duplicates
        filtmapping.2<-unique(filtmapping)
        if(nrow(filtmapping.2)!=nrow(filtmapping))
        {
            warning("Duplicates found in mapping. Only 1 representation for each link is conserved")
        }
        filtmapping<-filtmapping.2
        rm(filtmapping.2)

        #######################################
        ## STEP 2. Selecting surrogate data
        #######################################

        # Set the column that acts as a surrogate
        surrogate = setdiff(colnames(filtmapping), reference)
        # Filter the mapping for those features included in the referenceFeatures
        filtmapping = filtmapping[as.character(filtmapping[,reference]) %in% referenceFeatures,]
        # Filter the mapping for those surrogate variables included in the surrogate profiling
        filtmapping = filtmapping[as.character(filtmapping[,surrogate]) %in% rownames(exprs(surrogateData)),]
        # Generate the surrogate profiling to be used.
        surData = exprs(surrogateData)[as.character(unique(filtmapping[,surrogate])),]  ### replaced assayData

        # Define the number of surrogate features associated to each main feature.
        numsurXref = table(filtmapping[,reference])
        # At least 1 surrogate.
        numsurXref = names(which(numsurXref > 0)) # reference features with >maxitems surrogates
        # Feature eliminated: forcing at least a number equal to the max number of items to be used.

        if (length(numsurXref) > 0 & !is.null(maxitems)) {
            ####### The first approach is to map by using data.
            ###############################

            if (selectionRule == "maxcor") {
                ## referenceData must be provided
                if(is.null(referenceData))
                {
                    stop("The maxcor selection rule requires to provide referenceData")
                }
                nover<-colnames(surData) [colnames(surData) %in% colnames(exprs(referenceData))]
                if(length(nover)<3)
                {
                    stop("The maxcor selection rule requires at least 3 samples names shared by referenceData and surrogateData.")
                }else{
                    for(i in 1:length(numsurXref))
                    {
                        whichgo<-which(filtmapping[,reference]==numsurXref[i])
                        if(length(whichgo)>maxitems)
                        {
                            rm(surData.f)
                            names.f<- as.character(filtmapping[whichgo,surrogate])
                            surData.f<-surData[unique(filtmapping[whichgo,surrogate]),nover]
                            refData.f<-as.numeric(exprs(referenceData)[numsurXref[i],nover])
                            corgo<-apply(surData.f,1,function(x){
                                cor.test(as.numeric(x),
                                         refData.f, method="pearson")$estimate})
                            corgo.order<-corgo[order(abs(corgo),decreasing=TRUE)]
                            filtmapping = filtmapping[-which((filtmapping[,reference]==numsurXref[i]) &
                                                                 (as.character(filtmapping[,surrogate]) %in%
                                                                      names(corgo.order)[(maxitems+1):(length(corgo.order))])),]
                        }

                    }

                }
            }

            ######### The second idea is to map by using the standard deviation criteria
            ###############################

            if(selectionRule != "maxcor"){
                for (ff in numsurXref) {
                    # how many elements
                    whichgo<-which(as.character(filtmapping[,reference]) == ff)
                    if(length(whichgo)>maxitems)
                    {
                        # data for >maxitems surrogates features associated to reference feature ff:
                        subconj = surData[as.character(filtmapping[whichgo,surrogate]),]
                        # to select surrogates to reomove for this ff reference:
                        subconj = sur2remove(subconj, maxitems = maxitems,
                                             selectionRule = selectionRule, expfac = expfac)
                        filtmapping = filtmapping[-which((filtmapping[,reference]==ff) &
                                                             (as.character(filtmapping[,surrogate]) %in% subconj)),]
                    }
                }
            }

            ## surrogate Data
            surData = exprs(surrogateData)[as.character(filtmapping[,surrogate]),] #assayData
        }

        #######################################
        ## STEP 3. Aggregating surrogate features
        #######################################
        if (aggregation != "no") {
            surData = aggregate(surData,
                                by = list("reference" = filtmapping[,reference]),
                                as.name(aggregation))
            rownames(surData) = surData[,"reference"]
            surData = surData[,-1]
        }

        #######################################
        ## STEP 4. Return surrogate data
        #######################################

        return(list(data = surData, mapping = filtmapping))
    }
)


#' @export
#' @title bioDist
#' @aliases bioDist,character,character,bioMap,ExpressionSet,ExpressionSet-method
#' @description 
#' Function to compute a bioDistclass object from profile data and a mapping. For details of the process see the user's guide, but briefly the process involves using the mapping to identify reference features appropriate to each surrogate feature (if any), aggregating the surrogate data into pseudo-data for each reference feature, and then calculating the correlation distance between the reference features according to the surrogate data.
#' @usage bioDist(referenceFeatures=NULL, reference=NULL, mapping=NULL, 
#'                referenceData=NULL, surrogateData=NULL, filtering=NULL, 
#'                noMappingDist=NA, distance="spearman", aggregation="sum", 
#'                maxitems=NULL, selectionRule="maxFC", expfac=NULL, 
#'                name=NULL, ...)
#' @param referenceFeatures subset of features to be considered for the computation of the distances. If NULL then the features are first gathered from the features in referenceData. If referenceData is not provided then the list of features are gathered from mapping (bioMap class) and using the reference.
#' @param reference A character indicating the variable that is being used as features to compute distance between
#' @param mapping The mapping between feature types
#' @param referenceData ExpressionSet object with the data from the reference features.
#' @param surrogateData ExpressionSet object with the data from the surrogate features.
#' @param filtering A filtering for the bioMap class. To be implemented.
#' @param noMappingDist Distance value to be used when a reference feature do not map to any surrogate feature.  If "max", maximum indirect distance among the rest of reference features is taken. If NA, distance weights are re-scaled so this surrogate association is not considered. If a number then the missing values are replaces with that value.
#' @param distance Distance between features to be computed. Possible values are "pearson", "kendall", "spearman", "euclidean", "maximum", "manhattan", "canberra", "binary" and "minkowski". Default is "spearman".
#' @param aggregation Action to perform when a reference feature maps to more than one surrogate feature. Options are "max", "sum", "mean" or "median"  and the the values are aggregated according to the chosen statistic.
#' @param maxitems The maximum number of surrogate features per reference feature to be used, selected according to "selectionRule" parameter. Default is 2.
#' @param selectionRule Rule to select the surrogate features to be used (the number is determined by "maxitems"). It can be one of the following: (1)  "maxcor" those presenting maximum correlation with corresponding main feature; in this case "referenceData" must be provided and the columns must overlap in at least 3 samples; (2) "maxmean": average across samples is computed and those features with higher mean are selected;  case (3) is simmilar to (2) but considering other statistics: "maxmedian", "maxdiff", "maxFC", "sd" , "ee".
#' @param expfac Not in use yet.
#' @param name Character that describes the nature of the bioDist class computed
#' @param ... extra arguments passed to \code{\link{dist}}, eg "p=value" for the power used if calculating minkowski distance
#' @return An object of class \code{bioDistclass} containing distances between the features in \code{surrogateData}.
#' @author David Gomez-Cabrero
#' @template omicsCLUST_examples_common
setGeneric(
    name= "bioDist",
    def=function(referenceFeatures = NULL,
                 reference = NULL,
                 mapping = NULL,
                 referenceData = NULL,
                 surrogateData = NULL,
                 filtering = NULL,
                 noMappingDist = NA,
                 distance = "spearman",
                 aggregation = "sum",
                 maxitems = NULL,
                 selectionRule = "maxFC",
                 expfac = NULL,
                 name=NULL,...){
        standardGeneric("bioDist")}
)


setMethod(
    f= "bioDist",
    signature(referenceFeatures = "character",
              reference = "character",
              mapping = "bioMap",
              surrogateData = "ExpressionSet",
              referenceData = "ExpressionSet"),
    definition=function(referenceFeatures=NULL,
                        reference=NULL,
                        mapping=NULL,
                        referenceData = NULL,
                        surrogateData = NULL,
                        filtering = NULL,
                        noMappingDist = NA,
                        distance = "spearman",
                        aggregation = "sum",
                        maxitems = NULL,
                        selectionRule = "maxFC",
                        expfac = NULL,
                        name = NULL,...){

        ## validity of input objects

        if(is.null(referenceFeatures))
        {
            warning("referenceFeatures set is not provided.")
            if(!is.null(referenceData))
            {
                referenceFeatures<-rownames(exprs(referenceData))
                warning("referenceFeatures is generated from referenceData features")
            }else{
                if(!is.null(mapping) & !is.null(reference))
                {
                    referenceFeatures<-unique(getMap(mapping)[,reference])
                    warning("referenceFeatures is generated from the bioMap object")
                }else{
                    stop("It is not possible to generate referenceFeatures.
               When referenceFeatures is not provided it is required either (1) referenceData or (2) a bioMap object (mapping) and the reference provided.")
                }
            }
        }


        ## reference = surrogate
        ### In this case the distance is compute throug the profiles of the main features.

        if (is.null(mapping)) {
            warning("When the bioMap object is not provided, the mapping makes use of the referenceData provided.")
            if(is.null(referenceData))
            {
                stop("There is no bioMap object (mapping) neither referenceData provided. \nIn this case it is not possible to compute the distance.")
            } else{
                surData = exprs(referenceData)[referenceFeatures,] #assayData
                if (!is.null(distance)) {
                    mydist = dist(t(surData), method = distance,...)
                }
            }
            ## reference != surrogate -> mapping has to be provided
        } else {

            myaggre = bioAggregate(referenceFeatures = referenceFeatures,
                                   reference = reference,
                                   mapping = mapping,
                                   referenceData = referenceData,
                                   surrogateData = surrogateData,
                                   filtering = filtering,
                                   aggregation = aggregation,
                                   maxitems = maxitems,
                                   selectionRule = selectionRule,
                                   expfac = expfac)
            surData = myaggre$data
            if (is.null(distance)) {  # no distance is computed (e.g. for k-means algorithm)
                mydist = NULL
            } else {  # distance is to be computed

                if (aggregation == "no") {
                    # all pairwise distances must be computed and aggregated afterwards:
                    # To be considered for development.
                    # By now we consider all the surrogates are computed first.

                } else {
                    # Compute distance
                    if(distance %in% c("euclidean", "maximum", "manhattan", "canberra", "binary","minkowski"))
                    {
                        surDist = as.matrix(dist(surData, method = distance,...))
                    } else { #then it is correlation "pearson", "kendall", "spearman"
                        surDist = as.matrix(cor(t(surData), method = distance))
                    }

                    # Creating EMPTY distance matrix for reference features
                    mydist = matrix(noMappingDist,
                                    nrow = length(referenceFeatures),
                                    ncol = length(referenceFeatures))
                    rownames(mydist) = colnames(mydist) = referenceFeatures

                    # Complete empty distance matrix with references without surrogates
                    mydist[colnames(surDist),colnames(surDist)]<-surDist
                    if(noMappingDist=="max")
                    {
                        mydist[mydist=="max"]<-max(surDist)
                    }
                }
            }


        }

        return(new("bioDistclass",
                   name = name,
                   distance = mydist,
                   map.name = getName(mapping),
                   map.metadata = getMetadata(mapping),
                   params = list(filtering=filtering,distance=distance,aggregation=aggregation,
                                 maxitems=maxitems,selectionRule=selectionRule,expfac=expfac)))
    }
)


#############################################################################
# Auxiliary functions -----------------------------------------------------
############################################################################


## Function to select maxitems surrogates from a given reference feature
## according to selectionRule

sur2remove = function (data, maxitems = 3, selectionRule = "maxFC", expfac = NULL) {

    # Considering group information
    if (!is.null(expfac)) {
        # Averaging replicates within each experimental condition
        data = aggregate.con(data, groupby = expfac, aggregation = "rowMeans")
    }

    # Maximum fold-change
    if (selectionRule == "maxFC") {
        data = M.max.min(data)
        data = sort(data, decreasing = TRUE)  ## No specific actions when draws.
        data = names(data)[(maxitems+1):length(data)]
    }

    # Maximum difference
    if (selectionRule == "maxdiff") {
        data = rango(data)
        data = sort(data, decreasing = TRUE)  ## No specific actions when draws.
        data = names(data)[(maxitems+1):length(data)]
    }

    # Maximum standard deviation
    if (selectionRule == "sd") {
        data = apply(data,1,sd)
        data = sort(data, decreasing = TRUE)  ## No specific actions when draws.
        data = names(data)[(maxitems+1):length(data)]
    }

    # Maximum standard error
    if (selectionRule == "ee") {
        data1 = apply(data,1,sd)
        data2 = apply(data,1,mean)
        data = data1/data2
        data = sort(data, decreasing = TRUE)  ## No specific actions when draws.
        data = names(data)[(maxitems+1):length(data)]
    }

    return(data)  # names of selected surrogate features (maxitems)
}



## Function to aggregate replicates within a experimental conditions

# groupby is a vector containing the experimental group for each column of data
# aggregation: function to apply on a matrix and returning a vector

aggregate.con = function (data, groupby, aggregation = "rowMeans"){

    grupos = unique(groupby)

    agregados = lapply(grupos, function (gg) as.matrix(data[,grep(gg, groupby)]))

    agregados = sapply(agregados, as.name(aggregation))

    colnames(agregados) = grupos

    return (agregados)
}


## Function to compute maximum fold-change across experimental conditions
M.max.min = function (data){

    data = sinceros(data, k = NULL)

    M = log2(apply(as.matrix(data), 1, max, na.rm = TRUE) / apply(as.matrix(data), 1, min, na.rm = TRUE))
    names(M) = rownames(data)
    return(M)
}


## Functions to change 0s to a constant k
noceros = function (x, num = TRUE, k = 0) {

    nn = sum(x > k)

    if (num) {
        nn

    } else {
        if(nn > 0) { which(x > k) } else { NULL }
    }
}



sinceros = function (datos, k) {
    datos0 = datos

    if (is.null(k)) {

        mini0 = min(datos[noceros(datos, num = FALSE, k = 0)])

        kc = mini0/2

        datos0[datos0 == 0] = kc

    } else {

        datos0[datos0 == 0] = k

    }

    datos0
}


## Function to compute maximum difference across experimental conditions
rango = function (data){
    mirango = apply(as.matrix(data), 1, function (y) diff(range(y, na.rm = TRUE)))
    names(mirango) = rownames(data)
    return(mirango)
}

#' @include STATegRa_omicsCLUST_bioMap.R

################################################################################
##### bioDistw CLASS
######## this one stores the weighted distance through surrogates features.
################################################################################

setClass(
    "bioDistWclass",
    slots=c(name = "character",
            distance = "matrix",
            map.name= "character",
            map.metadata = "list",
            params= "list",
            weights = "vector"))

####### INITIALIZE

setMethod(
    f="initialize",
    signature="bioDistWclass",
    definition=function(.Object, name = "",
                        distance = matrix,
                        map.name = "",
                        map.metadata = list(),
                        params = list(),
                        weights = vector())
    {
        .Object@name <- name
        .Object@distance <-  distance
        .Object@map.name <- map.name
        .Object@map.metadata <- map.metadata
        .Object@params <- params
        .Object@weights <- weights
        return(.Object)
    }
)

####### INITIALIZE

setGeneric(
    name= "getWeight",
    def=function(object){standardGeneric("getWeight")}
)

setMethod(
    f= "getWeight",
    signature= "bioDistWclass",
    definition=function(object){
        return(object@weights)
    }
)

setMethod(
    f= "getName",
    signature= "bioDistWclass",
    definition=function(object){
        return(object@name)
    }
)

setMethod(
    f= "getDist",
    signature= "bioDistWclass",
    definition=function(object){
        return(object@distance)
    }
)

# bioDistW CLASS --------------------------------------------------------

#' @export
#' @import stats
#' @title bioDistW
#' @aliases bioDistW,character,list,matrix-method
#' @description 
#' Function that computes weighted distances between a list of bioDistclass objects.
#' @usage bioDistW(referenceFeatures, bioDistList, weights)
#' @param referenceFeatures The set of features that weighted distance is computed between.
#' @param bioDistList A list of bioDistclass objects. All the objects must contain the set of features selected.
#' @param weights A matrix where the number of columns equals the number of elements included in the bioDistList list.
#' @return Returns a list of bioDistWclass objects. Each element in the list returns the weighted distance associated to each row in the "weights" matrix.
#' @author David Gomez-Cabrero
#' @template omicsCLUST_examples_common
setGeneric(
    name= "bioDistW",
    def=function(referenceFeatures,
                 bioDistList,
                 weights){
        standardGeneric("bioDistW")}  ### update when finished!!!!
)


setMethod(
    f= "bioDistW",
    signature(referenceFeatures = "character",
              bioDistList = "list",
              weights="matrix"),
    definition=function(referenceFeatures,
                        bioDistList,
                        weights=1.){

        #### STEP 1:
        ## Validity of input objects

        # Check weights
        if(is.null(dim(weights)))
        {
            if(weights==1)
            {
                weigths<-matrix(1/length(bioDistList),1,length(bioDistList))
            }else
            {
                stop("weight needs to be defined")
            }
        }else{
            if(ncol(weights)!=length(bioDistList))
            {
                stop("The number of columns different from the number of list")
            }
            sumr<-apply(weights,1,sum)
            if(sum(sumr!=1)>0)
            {
                warning("For some row the total sum of weights is different than 1")
            }
        }

        # Number of features
        if(length(referenceFeatures)!=unique(length(referenceFeatures)))
        {
            stop("There are features names repeated")
        }

        # Check all features in all distances
        for(i in 1:length(bioDistList))
        {
            if(length(referenceFeatures)!=sum(unique(rownames(getDist(bioDistList[[i]]))) %in% referenceFeatures))
            {
                stop("There are features not represented in all distance matrices")
            }
        }
        # Set colnames
        colnames(weights)<-paste("V",1:ncol(weights),sep="-")
        for(i in 1:ncol(weights))
        {
            if(!is.na(getName(bioDistList[[i]])))
            {
                colnames(weights)[i]<-getName(bioDistList[[i]])
            }
        }

        #### STEP 2: COMPUTE ALL WEIGTHED DISTANCES
        ##
        listDistW<-vector("list",nrow(weights))
        for(i in 1:length(listDistW))
        {
            m1<-getDist(bioDistList[[1]])[referenceFeatures,referenceFeatures]*weights[i,1]
            for(j in 2:length(bioDistList))
            {
                m1 <- m1+ getDist(bioDistList[[j]])[referenceFeatures,referenceFeatures]*weights[i,j]
            }
            listDistW[[i]]<-new("bioDistWclass",
                                name = paste(colnames(weights),collapse="-"),
                                distance = m1,
                                weights = weights[i,])
        }

        listDistW
    })


#' @export
#' @title bioDistFeature
#' @aliases bioDistFeature,character,list,numeric-method
#' @description 
#' Function that computes for a given selected feature the closest features given a selected set of weighted distances.
#' @usage bioDistFeature(Feature, listDistW, threshold.cor)
#' @param Feature Feature A selected as a reference.
#' @param listDistW A list of bioDistWclass objects. All the objects must contain the Feature A selected and all of them must contain the same set of features.
#' @param threshold.cor A threshold to select the features associated to Feature A
#' @return Matrix with the associated features given the different weighted distances considered
#' @author David Gomez-Cabrero
#' @template omicsCLUST_examples_common
setGeneric(
    name= "bioDistFeature",
    def=function(Feature,
                 listDistW,
                 threshold.cor){
        standardGeneric("bioDistFeature")}
)


setMethod(
    f= "bioDistFeature",
    signature(Feature = "character",
              listDistW = "list",
              threshold.cor="numeric"),
    definition=function(Feature = "character",
                        listDistW = "list",
                        threshold.cor="numeric"){

        ##### STEP 1: SELECT OTHER FEATURES WITH HIGHER CORRELATION
        list.fea<-c()
        for(i in 1:length(listDistW))
        {#i<-1
            list.fea<-c(list.fea,colnames(getDist(listDistW[[i]]))[abs(getDist(listDistW[[i]])[Feature,])>threshold.cor])
        }
        list.fea<-unique(list.fea)
        list.fea<-list.fea[list.fea!=Feature]

        #### STEP 2:
        if(length(list.fea)>0)
        {
            RESULT<-matrix(NA,length(list.fea),length(listDistW))
            rownames(RESULT)<-list.fea
            colnames(RESULT)<-paste("Names_",1:length(listDistW),sep="")
            for(i in 1:length(listDistW) )
            {
                colnames(RESULT)[i]<-paste(getWeight(listDistW[[i]]),collapse="-")
                RESULT[list.fea,i]<-getDist(listDistW[[i]])[Feature,list.fea]
            }
        }else{
            warning("There is no Feature associated to selected feature given the threshold selection for any weighted distance")
        }

        RESULT
    }
)


#' @export
#' @import calibrate
#' @importFrom grDevices rgb
#' @importFrom graphics plot par
#' @title bioDistWPlot
#' @aliases bioDistWPlot,character,list,character-method
#' @description 
#' Function that plots the "distance relation" between features computed through different surrogate features.
#' @usage bioDistWPlot(referenceFeatures, listDistW, method.cor)
#' @param referenceFeatures The set of features to be used.
#' @param listDistW A list of bioDistWclass objects.
#' @param method.cor Method to compute distances between the elements in the listDistW. The default is spearman correlation.
#' @return Makes a plot with the projected distance between the listDistW objects.
#' @author David Gomez-Cabrero
#' @template omicsCLUST_examples_common
setGeneric(
    name= "bioDistWPlot",
    def=function(referenceFeatures,
                 listDistW,
                 method.cor){
        standardGeneric("bioDistWPlot")}  ### update when finished!!!!
)


setMethod(
    f= "bioDistWPlot",
    signature(referenceFeatures = "character",
              listDistW = "list",
              method.cor="character"),
    definition=function(referenceFeatures,
                        listDistW,
                        method.cor="spearman"){

        # Compute Distances.
        dist.M<-matrix(1,length(listDistW),length(listDistW))
        for(i in 2:(nrow(dist.M)-1))
        {
            for(j in (i+1):nrow(dist.M))
            {
                dist.M[i,j]<-cor.test(getDist(listDistW[[i]])[referenceFeatures,referenceFeatures],
                                      getDist(listDistW[[j]])[referenceFeatures,referenceFeatures],
                                      method=method.cor)$estimate
                dist.M[j,i]<-dist.M[i,j]
            }
        }

        # Compute weights
        WEIGHT.ALL<-matrix(NA,length(listDistW),length(getWeight(listDistW[[i]])))
        colnames(WEIGHT.ALL)<-names(getWeight(listDistW[[i]]))
        rownames(WEIGHT.ALL)<-paste("Name",1:length(listDistW),sep="")

        for(i in 1:length(listDistW))
        {
            WEIGHT.ALL[i,]<-as.numeric(getWeight(listDistW[[i]]))
            rownames(WEIGHT.ALL)[i]<-paste(as.numeric(getWeight(listDistW[[i]])),collapse="-")
        }

        # Plot Distances.
        fit <- cmdscale(dist.M,eig=TRUE, k=2) # k is the number of dim
        fit # view results
        x <- fit$points[,1]
        y <- fit$points[,2]

        oldmfrow <- par("mfrow")
        par(mfrow = c(2, 2*(round(ncol(WEIGHT.ALL))-1)))
        plot(x, y, xlab="Coordinate 1", ylab="Coordinate 2",
             main="MDS", pch=19)
        for(i in 1:ncol(WEIGHT.ALL))
        {
            plot(x, y, xlab="Coordinate 1", ylab="Coordinate 2",
                 main=colnames(WEIGHT.ALL)[i],
                 pch=19,col=rgb(0,0,0,WEIGHT.ALL[,i]))
        }
        plot(x, y, xlab="Coordinate 1", ylab="Coordinate 2",
             main="MDS", pch=19)

        textxy(x, y, rownames(WEIGHT.ALL))

        par(mfrow=oldmfrow)
    }

)

#' @export
#' @importFrom gplots heatmap.2
#' @importFrom grDevices colorRampPalette
#' @title bioDistFeaturePlot
#' @description 
#' Function that pltos the results from a bioDistFeature analysis
#' @usage bioDistFeaturePlot(data)
#' @param data Matrix produced by \code{bioDistFeature}
#' @return Generates a heatmap plot
#' @author David Gomez-Cabrero
#' @template omicsCLUST_examples_common
bioDistFeaturePlot<-function(data)
{
    colors = seq(-1, 1, length=200)
    my_palette <- colorRampPalette(c("red", "white", "blue"))(n = 199)
    #par(mar=c(12,2,2,12))#,mai=c(12,2,2,12))
    heatmap.2(t(data),
              Rowv = FALSE,
              Colv=TRUE,
              distfun = function(x){dist(x,method="manhattan")},
              hclustfun = hclust,
              dendrogram = c("col"),
              symm = FALSE,
              cexRow=1,cexCol=1,margins=c(12,8),
              breaks=colors,
              col=my_palette,
              scale = c("none"),
              na.rm=TRUE,
              trace="none")
}

#' @export
#' @import affy
#' @import edgeR
#' @import limma
#' @import foreach
#' @title omicsNPC, applying the Non-Parametric Combination (NPC) on omics datasets
#' @aliases omicsNPC,list,data.frame-method omicsNPC,list,missing-method
#' @description
#' This function applies the NonParametric Combination methodology on the integrative analysis 
#' of different omics data modalities.
#' It retrieves genes associated to a given outcome, taking into account all omics data.
#' First, each datatype is analyzed independently using the appropriate method.
#' omicsNPC analyses continuous data (microarray) using limma, while count data (e.g., RNAseq) 
#' are first preprocessed with using the "voom" function. The user can also specify their own 
#' function for computing deregulation / association 
#' The p-values from the single dataset analysis are then combined employing Fisher, 
#' Liptak and Tippett combining functions.
#' The Tippett function returns findings which are supported by at least one omics modality.
#' The Liptak function returns findings which are supportd by most modalities.
#' The Fisher function has an intermediate behavior between those of Tippett and Liptak.
#' @usage omicsNPC(dataInput, dataMapping, dataTypes = rep('continuous', length(dataInput)), 
#'                combMethods = c("Fisher", "Liptak", "Tippett"), numPerms = 1000, 
#'                numCores = 1, verbose = FALSE, functionGeneratingIndex = NULL, 
#'                outcomeName = NULL, allCombinations = FALSE, 
#'                dataWeights = rep(1, length(dataInput))/length(dataInput), 
#'                returnPermPvalues = FALSE, ...)
#'
#' @param dataInput List of ExpressionSet objects, one for each data modality. 
#' @param dataMapping A data frame describing how to map measurements across datasets. See details for more information.
#' @param dataTypes Character vector with possible values: 'continuous', 'count'. Alternatively, a list of functions for assessing deregulation / association with an outcome
#' @param combMethods Character vector with possible values: 'Fisher', 'Liptak', 'Tippett'. If more than one is specified, all will be used.
#' @param numPerms Number of permutations
#' @param numCores Number of CPU cores to use
#' @param verbose Logical, if set to TRUE omicsNPC prints out the step that it performs
#' @param functionGeneratingIndex Function generating the indices for randomly permuting the samples
#' @param outcomeName Name of the outcome of interest / experimental factor, as reported in the design matrices. If NULL, the last column of the design matrices is assumed to be the outcome of interest.
#' @param allCombinations Logical, if TRUE all combinations of omics datasets are considered
#' @param dataWeights A vector specifying the weigth to give to each dataset. Note that sum(dataWeights) should be 1.
#' @param returnPermPvalues Logical, should the p-values computed at each permutation being returned?
#' @param ... Additional arguments to be passed to the user-defined functions
#'
#' @return A list containing:
#' stats0 Partial deregulation / association statistics 
#' pvalues0 The partial p-values computed on each dataset
#' pvaluesNPC The p-values computed through NPC.
#' permPvalues The p-values computed at each permutation
#'
#' @author Nestoras Karathanasis, Vincenzo Lagani
#'
#' @references
#' Pesarin, Fortunato, and Luigi Salmaso. Permutation tests for complex data: theory, applications and software.
#' John Wiley & Sons, 2010.
#' Nestoras Karathanasis, Ioannis Tsamardinos and Vincenzo Lagani. omicsNPC: applying the Non-Parametric Combination 
#' methodology to the integrative analysis of heterogeneous omics data. PlosONE 11(11): e0165545. doi:10.1371/journal.pone.0165545
#'
#' @examples
#' # Load the data
#' data("TCGA_BRCA_Batch_93")
#' # Setting dataTypes, the first two ExpressionSets include RNAseq data,
#' # the third ExpressionSet includes Microarray data.
#' dataTypes <- c("count", "count", "continuous")
#' # Setting methods to combine pvalues
#' combMethods = c("Fisher", "Liptak", "Tippett")
#' # Setting number of permutations
#' numPerms = 1000
#' # Setting number of cores
#' numCores = 1
#' # Setting omicsNPC to print out the steps that it performs.
#' verbose = TRUE
#' # Run omicsNPC analysis.
#' # The output contains a data.frame of p-values, where each row corresponds to a gene, 
#' # and each column corresponds to a method used in the analysis.
#' 
#' \dontrun{out <- omicsNPC(dataInput = TCGA_BRCA_Data, dataTypes = dataTypes,
#'                             combMethods = combMethods, numPerms = numPerms,
#'                             numCores = numCores, verbose = verbose)}

setGeneric(name="omicsNPC",
           def=function(dataInput,
                        dataMapping,
                        dataTypes = rep('continuous', length(dataInput)),
                        combMethods = c("Fisher", "Liptak", "Tippett"),
                        numPerms = 1000,
                        numCores = 1,
                        verbose = FALSE,
                        functionGeneratingIndex = NULL,
                        outcomeName = NULL,
                        allCombinations = FALSE,
                        dataWeights = rep(1, length(dataInput))/length(dataInput),
                        returnPermPvalues = FALSE,
                        ...)
               {standardGeneric("omicsNPC")}
)

setMethod(
    f="omicsNPC",
    signature=signature(dataInput = "list", dataMapping = 'data.frame'),
    definition=function(dataInput, dataMapping, dataTypes, combMethods, numPerms, 
                        numCores, verbose, functionGeneratingIndex, outcomeName, 
                        allCombinations, dataWeights, returnPermPvalues, ...){
        
      # Input check 

      # checking the data in input
      classNames <- sapply(dataInput, class)
      testClass <- sapply(X = classNames, FUN = match.arg, choices = c('ExpressionSet'))
      
      #if no names for the datasets, create fake ones
      if(is.null(names(dataInput))){
        names(dataInput) <- paste('dataset', 1:length(dataInput), sep = "_")
      }

      # data types
      if(class(dataTypes) == 'character'){
        testDataTypes <- sapply(X = dataTypes, FUN = match.arg, choices = c('count', 'continuous')) 
      }
      
      #weigths
      if(sum(dataWeights) != 1){
        stop('dataWeights must be a numeric vector such that sum(dataWeights) == 1')
      }
      
      # Create input for internal omicsNPC 
      
      # extract matrices from ExpressionSet
      dataMatrices <- lapply(dataInput, FUN = exprs)
      if(is.null(names(dataInput))){
        names(dataMatrices) <- paste('Dataset', 1:length(dataInput), sep = '_');
      }else{
        names(dataMatrices) <- names(dataInput);
      }

      # retrieving the whole design for each dataset
      designs <- lapply(X = dataInput, FUN = pData)
      if(is.null(names(dataInput))){
        names(designs) <- paste('Dataset', 1:length(dataInput), sep = '_');
      }else{
        names(designs) <- names(dataInput);
      }

      # functions to analyze data
      if(class(dataTypes) == 'character'){
        functionsAnalyzingData <- vector('list', length(dataTypes));
        for(i in 1:length(dataTypes)){
          if(dataTypes[i] == 'continuous'){
            functionsAnalyzingData[[i]] <- computeAssocContinuousData;
          }else{
            functionsAnalyzingData[[i]] <- computeAssocCountData;
          }
        }
      }else{
        functionsAnalyzingData <- dataTypes;
      }
      
      # function to permute data
      if(is.null(functionGeneratingIndex)){
        functionGeneratingIndex <- generate_iid_data_index 
      }
      
      # run omicsNPC 
      output <- omicsNPC_internal(dataMatrices = dataMatrices, 
                                  designs = designs,
                                  dataMapping = dataMapping,
                                  combMethods = combMethods,
                                  functionsAnalyzingData = functionsAnalyzingData,
                                  functionGeneratingIndex = functionGeneratingIndex,
                                  outcomeName = outcomeName,
                                  numPerms = numPerms,
                                  numCores = numCores,
                                  verbose = verbose,
                                  allCombinations = allCombinations,
                                  dataWeights = dataWeights,
                                  returnPermPvalues = returnPermPvalues,
                                  ...)

      #returning the results
      return(output)

    }
)

setMethod(
  f="omicsNPC",
  signature=signature(dataInput = "list", dataMapping = 'missing'),
  definition=function(dataInput, dataMapping, dataTypes, combMethods, numPerms, numCores, verbose, functionGeneratingIndex, outcomeName, returnPermPvalues, ...){
    
    # Input check 
    
    # checking the data in input
    if(class(dataInput) == 'list'){
      classNames <- sapply(dataInput, class)
      testClass <- sapply(X = classNames, FUN = match.arg, choices = c('ExpressionSet'))
    }
    
    #if no names for the datasets, create fake ones
    if(is.null(names(dataInput))){
      names(dataInput) <- paste('dataset', 1:length(dataInput), sep = "_")
    }
    
    # data types
    if(class(dataTypes) == 'character'){
      testDataTypes <- sapply(X = dataTypes, FUN = match.arg, choices = c('count', 'continuous')) 
    }
    
    #weigths
    if(sum(dataWeights) != 1){
      stop('dataWeights must be a numeric vector such that sum(dataWeights) == 1')
    }
    
    #creating the data mapping based on the rownames 
    #(we assume the all datasets have the same rownames encoding, e.g., probeset ids of the same platform)
    mappings <- vector('list', length(dataInput));
    for(i in 1:length(dataInput)){
      mappings[[i]] <- data.frame(id = rownames(dataInput[[i]]),
                                  reference = rownames(dataInput[[i]]));
    }
    dataMapping <- combiningMappings(mappings = mappings, reference = 'reference', retainAll = TRUE);
    
    # Create input for internal omicsNPC 
    
    # extract matrices from ExpressionSet
    dataMatrices <- lapply(dataInput, FUN = exprs)
    if(is.null(names(dataInput))){
      names(dataMatrices) <- paste('Dataset', 1:length(dataInput), sep = '_');
    }else{
      names(dataMatrices) <- names(dataInput);
    }
    
    # retrieving the whole design for each dataset
    designs <- lapply(X = dataInput, FUN = pData)
    if(is.null(names(dataInput))){
      names(designs) <- paste('Dataset', 1:length(dataInput), sep = '_');
    }else{
      names(designs) <- names(dataInput);
    }
    
    # functions to analyze data
    if(class(dataTypes) == 'character'){
      functionsAnalyzingData <- vector('list', length(dataTypes));
      for(i in 1:length(dataTypes)){
        if(dataTypes[i] == 'continuous'){
          functionsAnalyzingData[[i]] <- computeAssocContinuousData;
        }else{
          functionsAnalyzingData[[i]] <- computeAssocCountData;
        }
      }
    }else{
      functionsAnalyzingData <- dataTypes;
    }
    
    # function to permute data
    if(is.null(functionGeneratingIndex)){
      functionGeneratingIndex <- generate_iid_data_index 
    }
    
    # run omicsNPC 
    output <- omicsNPC_internal(dataMatrices = dataMatrices, 
                                designs = designs,
                                dataMapping = dataMapping,
                                combMethods = combMethods,
                                functionsAnalyzingData = functionsAnalyzingData,
                                functionGeneratingIndex = functionGeneratingIndex,
                                outcomeName = outcomeName,
                                numPerms = numPerms,
                                numCores = numCores,
                                verbose = verbose,
                                allCombinations = allCombinations,
                                dataWeights = dataWeights,
                                returnPermPvalues = returnPermPvalues,
                                ...)
    
    #returning the results
    return(output)
    
  }
)

# This file contains no code, it just serves to hold roxygen documentation comments
# for the package and data files so that we can do away with all Rd files

#' @title STATegRa
#' @name STATegRa
#' @aliases STATegRa-package
#' @docType package
#' @description
#' STATegRa is a package for the integrative analysis of multi-omic data-sets.
#'
#' For full information, see the user's guide.
#' @seealso \code{\link{STATegRaUsersGuide}}
NULL

#' @title STATegRa data
#' @name STATegRa_data
#' @aliases Block1 Block2 ed mapdata Block1.PCA Block2.PCA ed.PCA
#' @docType data
#' @format Two matrices with mRNA and miRNA expression data, a design matrix that describes both and a mapping between miRNA and genes.
#' @description
#' mRNA data (\code{Block1}), miRNA data (\code{Block2}) and the design matrix (\code{ed}), from \code{STATegRa_S1}, provides selected data downloaded from \url{https://tcga-data.nci.nih.gov/docs/publications/gbm_exp/}. The mapping between miRNA and mRNA (\code{mapdata}, available in \code{STATegRa_S2}) contains, as a processed matrix, selected information available from TargetScan; we selected the set of miRNA target predictions for humans for those miRNA-mRNA pairs where both miRNA and mRNA were in \code{Block1} and \code{Block2} respectively. 
#'
#' The PCA version of the data (\code{Block1.PCA}, \code{Block2.PCA}, \code{ed.PCA}; available in \code{STATegRa_S3}), provides a similar data-set to \code{Block1}, \code{Block2} and \code{ed} data; however in this case the data has been processed in order to provide a pedagogic example of OmicsPCA. Results obtained from OmicsPCA (\code{\link{omicsCompAnalysis}}) with the existing data should not be taken as clinically valid.
#'
#' @source
#' (a)  See \url{https://tcga-data.nci.nih.gov/docs/publications/gbm_exp/}.
#' (b)  Gabor Csardi, \code{targetscan.Hs.eg.db}: TargetScan miRNA target predictions for human. R package version 0.6.1
#'
#' @author David Gomez-Cabrero, Patricia Sebastian-Leon, Gordon Ball
#' @examples
#' data(STATegRa_S1)
#' data(STATegRa_S2)
#' data(STATegRa_S3)
NULL

#' @title STATegRa data
#' @name STATegRa_data_TCGA_BRCA
#' @aliases TCGA_BRCA_Data
#' @docType data
#' @format One list, which contains three ExpressionSet objects.
#' @description
#'
#' Data were downloaded from TCGA data portal, \url{https://tcga-data.nci.nih.gov/tcga/}.
#' We downloaded sixteen tumour samples and the sixteen matching normal, for Breast invasive carcinoma, BRCA, batch 93.
#' Herein, three types of data modalities are included, RNAseq (\code{TCGA_BRCA_Data$RNAseq}), RNAseqV2 (\code{TCGA_BRCA_Data$RNAseqV2})
#' and Expression-Genes (\code{TCGA_BRCA_Data$Microarray}). The Data Level was set to Level 3.
#' For each data type, we pooled all data to one matrix, where rows corresponded to genes and columns to samples.
#' Only the first 100 genes are included.
#'
#' @source
#' See \url{https://tcga-data.nci.nih.gov/tcga/}.
#'
#' @author Nestoras Karathanasis, Vincenzo Lagani
#' @examples
#' # load data
#' data(TCGA_BRCA_Batch_93)
NULL

#' @name STATegRa-defunct
#' @title Defunct functions in STATegRa
#' @description
#' These functions have are defunct and no longer available
#' @details
#' \itemize{
#' \item{holistOmics: replaced by \code{\link{omicsNPC}}}
#' }
NULL

# holistOmics -------------------------------------------------------
## INPUT:
##    ######...: Set of expression sets one for each omic dataset
##    dataInput: (list) List of expression sets one for each omic dataset
##    dataTypes: (character) string vector with possible values: 'RNA-seq', 'microarray'
##    design: (numeric) the outcome in numeric form
##    comb.method = c("Fisher", "Liptak", "Tippett"): (character) Method(s) for combining p-values
##    numPerm = 1000: (numeric) number of permutations to perform
##    numCores = 1: (numeric) number of CPU cores to use
## OUTPUT:
##    An object of class 'holistOmics'

#' @export
#' @import affy
#' @import edgeR
#' @import limma
#' @import foreach
#' @title HolistOmics an application of NPC on omics datasets
#' @aliases holistOmics,list,character-method
#' @description
#' This function is defunct. Use omicsNPC instead.
#'
#' @usage holistOmics(dataInput, dataTypes, comb.method = c("Fisher", "Liptak", "Tippett"),
#'                numPerm = 1000, numCores = 1, verbose = FALSE)
#'
#' @param dataInput List of ExpressionSet objects, one for each data modality.
#' @param dataTypes Character vector with possible values: 'RNA-seq', 'microarray'
#' @param comb.method Character vector with possible values: 'Fisher', 'Liptak',
#' 'Tippett', if more than one is specified, all will be used.
#' @param numPerm Number of permutations
#' @param numCores Number of CPU cores to use
#' @param verbose Logical, if set to TRUE holistOmics prints out the step that it performs
#'
#' @return A data.frame
#'
#' @author Nestoras Karathanasis
#'
#' @references
#' Pesarin, Fortunato, and Luigi Salmaso. Permutation tests for complex data: theory, applications and software.
#' John Wiley & Sons, 2010.
#'
#' @examples
#' # Load the data
#' data("TCGA_BRCA_Batch_93")
#' # Setting dataTypes, the first two ExpressionSets include RNAseq data,
#' # the third ExpressionSet includes Microarray data.
#' dataTypes <- c("RNAseq", "RNAseq", "Microarray")
#' # Setting methods to combine pvalues
#' comb.method = c("Fisher", "Liptak", "Tippett")
#' # Setting number of permutations
#' numPerm = 1000
#' # Setting number of cores
#' numCores = 1
#' # Setting holistOmics to print out the steps that it performs.
#' verbose = TRUE
#' # Run holistOmics analysis.
#' # The output is a data.frame of p-values.
#' # Each row corresponds to a gene name. Each column corresponds to a method
#' # used in the analysis.
#' \dontrun{out <- holistOmics(dataInput = TCGA_BRCA_Data, dataTypes = dataTypes,
#'                             comb.method = comb.method, numPerm = numPerm,
#'                             numCores = numCores, verbose = verbose)}

setGeneric(name="holistOmics",
           def=function(dataInput, dataTypes,
                        comb.method = c("Fisher", "Liptak", "Tippett"),
                        numPerm = 1000, numCores = 1, verbose = FALSE)
               {standardGeneric("holistOmics")}
           )

setMethod(
    f="holistOmics",
    signature=signature(
        dataInput = "list",
        dataTypes = "character"),
    definition=function(dataInput, dataTypes, comb.method, numPerm, numCores, verbose){
      
        #This function is defunct.
        .Defunct("omicsNPC");
    }
)

# omicsNPC_internal function definition
# This function is not meant to be invoked directly by the user.
# See the omicsNPC function instead.

#' @importFrom utils combn
omicsNPC_internal <- function(dataMatrices, 
                              designs, 
                              dataMapping,
                              combMethods, 
                              functionsAnalyzingData, 
                              functionGeneratingIndex, 
                              outcomeName = NULL,
                              numPerms = 1000, numCores = 1,
                              allCombinations = FALSE,
                              dataWeights = rep(1, length(dataMatrices))/length(dataMatrices),
                              verbose = FALSE,
                              returnPermPvalues = FALSE,
                              ...){
  
  #### STEP 1 Compute initial statistics ####
  
  #message
  if(verbose){
      message("Compute initial statistics on data")
  }
  
  #information
  datasetsNames <- names(dataMatrices);
  numDataMatrices <- length(dataMatrices)
  numCombMethods <- length(combMethods);
  
  # computing the statistics on the original data
  stats0 <- computeAssociation(dataMatrices = dataMatrices, designs = designs, dataMapping = dataMapping, functionsAnalyzingData = functionsAnalyzingData, outcomeName = outcomeName, ...)
  
  #information
  measurements <- dimnames(stats0)[[1]];
  numMeasurements <- length(measurements);
  
  #### STEP 2 Building NULL distributions by permuting data ####

  # message
  if(verbose){
      message("Building NULL distributions by permuting data")
  }

  # set function for permutation
  executePermutation <- function(...){
      
    # permute designs
    permDesigns <- permutingData(designs = designs, functionGeneratingIndex = functionGeneratingIndex, outcomeName = outcomeName, ...)


    # recompute pvalues
    tempRes <- computeAssociation(dataMatrices, designs = permDesigns, dataMapping = dataMapping, functionsAnalyzingData = functionsAnalyzingData, outcomeName = outcomeName, ...)
    
    #return
    return(tempRes)
    
  }

  # try to run in parallel
  if (numCores != 1){
   
    # check if required packages are available
    if(requireNamespace("doSNOW", quietly = TRUE)){
    
        #creating the cluster
        cl <- parallel::makeCluster(numCores)
    
        #registering the cluster
        doSNOW::registerDoSNOW(cl)
    
        # compute DE expression
        statsPerm <- foreach(i = 1:numPerms, .packages = 'limma') %dopar% {executePermutation(...)}

        #stopping the cluster
        parallel::stopCluster(cl)
        
    }else{
      
      #not possible to run in parallel
      message("Install doSNOW to run omicsNPC in parallel...")
      message("omicsNPC will run using ONE core")
      statsPerm <- foreach(i = 1:numPerms) %do% executePermutation(...)

    }
    
  }else{
    
    #running serially
    statsPerm <- foreach(i = 1:numPerms) %do% executePermutation(...)

  }
   
  # combining original and permuted statistics in a single list
  statsPerm <- c(list(stats0), statsPerm)

  # transforming the list in a multi-dimensional array
  statsPerm <- array(unlist(statsPerm), 
                     dim = c(nrow(statsPerm[[1]]), ncol(statsPerm[[1]]), length(statsPerm)),
                     dimnames = list(rownames(statsPerm[[1]]),
                                     colnames(statsPerm[[1]]),
                                     1:length(statsPerm)))
  
  #### STEP 3 Compute p-values based on NULL distributions ####
  
  #message
  if(verbose){
      message("Compute pseudo p-values based on NULL distributions...")
  }
  
  # compute permutation pvalues based on stats
  pvaluesPerm <- statisticsToPvalues(statsPerm)
  
  #rearraging so that the order of dimension is measurements, datasets, permutations
  pvaluesPerm <- aperm(pvaluesPerm, c(2, 3, 1)) # magic numbers!
  
  #taking the partial p-values
  #keeping only the relevant pvalues
  pvalues0 <- matrix(pvaluesPerm[ , , 1],
                       nrow = numMeasurements, 
                       ncol = numDataMatrices, 
                       dimnames = dimnames(pvaluesPerm)[1:2]);
  
  #### STEP 4 Compute NPC p-values ####
  
  #message
  if(verbose){
      message("NPC p-values calculation...")
  }
  
  #all combination of datasets?
  if(allCombinations){
    
    #which are the combinations of all data matrices?
    combinations <- list();
    for(i in 2:numDataMatrices){
      combinations <- c(combinations, combn(1:numDataMatrices, i, simplify = FALSE));
    }
    numCombinations <- length(combinations);
    
    #initializing 
    pvaluesNPC <- vector('list', numCombinations);
    
    #for each combination, let's compute the NPC stats and p-values
    for(j in 1:numCombinations){
      
      #initializing
      statsNPC <- array(dim = c(numMeasurements, numCombMethods, numPerms + 1), 
                        dimnames = list(measurements, combMethods, dimnames(pvaluesPerm)[[3]]));
      
      #combining the pvalues. Here we choose which data matrice to combine
      for(i in 1:numCombMethods){
        statsNPC[ , i, ] <-  apply(pvaluesPerm[ , combinations[[j]], ], 3, combiningPvalues, method = combMethods[i], dataWeights = dataWeights);
      }
      
      #computing the NPC p-values
      pvaluesNPCTemp <- statisticsToPvalues(statsNPC);
      pvaluesNPCTemp <- aperm(pvaluesNPCTemp, c(2, 3, 1)) # magic numbers!
      
      #keeping only the relevant pvalues, if not specified otherwise
      if(!returnPermPvalues){
        pvaluesNPC[[j]] <- matrix(pvaluesNPCTemp[ , , 1], 
                             nrow = numMeasurements, 
                             ncol = numCombMethods, 
                             dimnames = dimnames(pvaluesNPCTemp)[1:2])
      }
      
      #naming the list component
      names(pvaluesNPC)[j] <- paste(datasetsNames[combinations[[j]]], collapse = '_');
      
    }
      
  }else{
    
    #initializing
    statsNPC <- array(dim = c(numMeasurements, numCombMethods, numPerms + 1), 
                      dimnames = list(measurements, combMethods, dimnames(pvaluesPerm)[[3]]));
    
    #combining the pvalues
    for(i in 1:numCombMethods){
      statsNPC[ , i, ] <-  apply(pvaluesPerm, 3, combiningPvalues, 
                                 method = combMethods[i], dataWeights = dataWeights)
    }
    
    #computing the NPC p-values
    pvaluesNPC <- statisticsToPvalues(statsNPC);
    pvaluesNPC <- aperm(pvaluesNPC, c(2, 3, 1)) # magic numbers!
    
    #keeping only the relevant pvalues, if not specified otherwise
    if(!returnPermPvalues){
      pvaluesNPC <- matrix(pvaluesNPC[ , , 1], 
                            nrow = numMeasurements, 
                            ncol = numCombMethods, 
                            dimnames = dimnames(pvaluesNPC)[1:2])
    }

  }
  
  #creating the object to return
  #Note: for the moment is only a list. It will be a proper object in a next release
  #pvaluesNPC: either a matrix (allCombinations = FALSE) or a list (allCombinations = TRUE)
  if(returnPermPvalues){
    toReturn <- list(stats0 = stats0, pvalues0 = pvalues0, pvaluesNPC = pvaluesNPC, pvaluesPerm = pvaluesPerm);
  }else{
    toReturn <- list(stats0 = stats0, pvalues0 = pvalues0, pvaluesNPC = pvaluesNPC);
  }
  
  return(toReturn)

}

#### Ancillary functions. The user may provide different ones ####

#this fucntion computes association for continuous data
computeAssocContinuousData <- function(dataMatrix, design, outcomeName, ...){

  #ensuring the outcome is the last column of the design
  if(!is.null(outcomeName)){
    
    #check
    if(!any(colnames(design) == outcomeName)){
      stop(paste('Ensure', outcomeName, 'is present in all design matrices'));
    }
    
    #moving the outcome to last position
    outcomeTemp <- design[[outcomeName]];
    design[[outcomeName]] <- NULL;
    design <- cbind(design, outcomeTemp);
    names(design)[ncol(design)] <- outcomeName;
    
  }
  
  #we assume that the outcome is the last column
  outcomeId <- ncol(design);

  #what type of outcome?
  multiGroups <- FALSE;
  if((is.factor(design[[outcomeId]]) & length(levels(design[[outcomeId]])) >= 3) ||
     (is.character(design[[outcomeId]]) & length(unique(design[[outcomeId]])) >= 3)){
    multiGroups <- TRUE;
  }
  
  #creating the model matrix 
  numGroups <- length(unique(design[[outcomeId]]));
  modelFormula <- as.formula(paste('~', paste(colnames(design), collapse = '+')))
  design <- model.matrix(modelFormula, design)
  numCols <- ncol(design)
  
  #if there are n groups, the last n-1 columns represent them
  numColGroups <- (ncol(design) - (numGroups - 1) + 1):ncol(design)
  
  #fitting the models
  fit <- lmFit(dataMatrix, design = design)
  fit2 <- eBayes(fit)
  
  #if not multiple groups
  if(!multiGroups){
    results <- topTable(fit2, numCols, number = Inf, sort.by = 'none')
  }else{
    results <- topTable(fit2, numColGroups, number = Inf, sort.by = 'none')
  }
  
  #returning statistics (log transformed p-values)
  logPvalues <- (-1) * log10(results$P.Value);
  names(logPvalues) <- rownames(results);
  return(logPvalues)

}

#this fucntion computes association for count data
computeAssocCountData <- function(dataMatrix, design, outcomeName, ...){

  
  #ensuring the outcome is the last column of the design
  if(!is.null(outcomeName)){
    
    #check
    if(!any(colnames(design) == outcomeName)){
      stop(paste('Ensure', outcomeName, 'is present in all design matrices'));
    }
    
    #moving the outcome to last position
    outcomeTemp <- design[[outcomeName]];
    design[[outcomeName]] <- NULL;
    design <- cbind(design, outcomeTemp);
    names(design)[ncol(design)] <- outcomeName;
    
  }
  
  #we assume that the outcome is the last column
  outcomeId <- ncol(design);
  
  #what type of outcome?
  multiGroups <- FALSE;
  if((is.factor(design[[outcomeId]]) & length(levels(design[[outcomeId]])) >= 3) ||
     (is.character(design[[outcomeId]]) & length(unique(design[[outcomeId]])) >= 3)){
    multiGroups <- TRUE;
  }
  
  #creating the model matrix 
  numGroups <- length(unique(design[[outcomeId]]));
  modelFormula <- as.formula(paste('~', paste(colnames(design), collapse = '+')))
  design <- model.matrix(modelFormula, design)
  numCols <- ncol(design)
  
  #if there are n groups, the last n-1 columns represent them
  numColGroups <- (ncol(design) - (numGroups - 1) + 1):ncol(design)
  
  #applying voom
  nf = calcNormFactors(dataMatrix, method = "TMM")
  voom.data = voom(dataMatrix, design = design,
                   lib.size = colSums(dataMatrix) * nf)
  voom.data$genes = rownames(dataMatrix)  
  
  #fitting the models
  fit <- lmFit(voom.data, design = design)
  fit2 <- eBayes(fit)
  
  #if not multiple groups
  if(!multiGroups){
    results <- topTable(fit2, numCols, number = Inf, sort.by = 'none')
  }else{
    results <- topTable(fit2, numColGroups, number = Inf, sort.by = 'none')
  }
  
  #returning statistics (log transformed p-values)
  logPvalues <- (-1) * log10(results$P.Value);
  names(logPvalues) <- rownames(results);
  return(logPvalues)
  
}

#function for generating random, iid permutation indices
generate_iid_data_index <- function(design){
  numSamples <- dim(design)[1];
  index <- sample(x = 1:numSamples, size = numSamples, replace = FALSE)
  return(index)
}

#### Functions to run omicsNPC. These should not be changed. ####


# This method applies the functions for computing the association between measurements and outcome
computeAssociation <- function(dataMatrices, designs, dataMapping, functionsAnalyzingData, outcomeName, ...){
  
  #applying to each data matrix the corresponding function
  results <- vector('list', length(dataMatrices));
  for(j in 1:length(dataMatrices)){
    results[[j]] <- functionsAnalyzingData[[j]](dataMatrices[[j]], designs[[j]], outcomeName, ...);
  }
  
  #Return the results as a matrix: we do now assume the same number of results for each dataset; only a coherent naming
  
  #matrix to return
  toReturn <- matrix(NA, nrow = dim(dataMapping)[1], ncol = length(dataMatrices));
  colnames(toReturn) <- names(dataMatrices);
  
  #filling the matrix
  for(j in 1:length(results)){
    toReturn[ , j] <- results[[j]][ as.character(dataMapping[[j]]) ];
  }
  rownames(toReturn) <- rownames(dataMapping);
  
  #return
  return(toReturn)
  
}

# This method permutes the samples likewise across datasets
permutingData <- function(designs, functionGeneratingIndex, outcomeName, ...){
  
  #if the outcomeName is null, we assume it to be the last column of the design matrices
  if(is.null(outcomeName)){
    outcomeName <- names(designs[[1]])[ncol(designs[[1]])]; #this is a bit of a hack...
  }
  
  #Which columns are common in all designs?
  commonElements <- colnames(designs[[1]]);
  for(j in 2:length(designs)){
    commonElements <- intersect(commonElements, colnames(designs[[j]]));
  }
  
  #Extracting the common elements. 
  commonDesign <- designs[[1]][commonElements];
  rowNamesCommonDesign <- rownames(designs[[1]])
  for(j in 2:length(designs)){
    commonDesign <- rbind(commonDesign, designs[[j]][commonElements], make.row.names = FALSE);
    rowNamesCommonDesign <- c(rowNamesCommonDesign, rownames(designs[[j]]));
  }
  toEliminate <- which(duplicated(rowNamesCommonDesign));
  if(length(toEliminate) > 0){
    commonDesign <- as.data.frame(commonDesign[-toEliminate, ]); 
    colnames(commonDesign) <- commonElements;
    rowNamesCommonDesign <- rowNamesCommonDesign[-toEliminate];
  }
  rownames(commonDesign) <- rowNamesCommonDesign;
  
  # computing the permutation index
  index <- functionGeneratingIndex(commonDesign)
  permSampleNames <- rownames(commonDesign)[index];
  
  #getting the indexes for each matrix. Those indexes are actually sample names
  indexes <- vector('list', length(designs));
  for(j in 1:length(designs)){
    currentSamples <- rownames(designs[[j]]);
    toEliminate <- which(! permSampleNames %in% currentSamples);
    if(length(toEliminate)>0){
      tempIndex <- permSampleNames[-toEliminate]; 
    }else{
      tempIndex <- permSampleNames
    }
    indexes[[j]] <- tempIndex;
  }
  
  #permuting the outcome / experimental factor of each design matrix
  permDesigns <- designs;
  for(j in 1:length(designs)){
    tempDesign <- designs[[j]];
    outcomeId <- which(colnames(tempDesign) == outcomeName);
    tempDesign[ , outcomeId] <- tempDesign[indexes[[j]], outcomeId];
    permDesigns[[j]] <- tempDesign;
  }
  
  #returning the permuted designs
  return(permDesigns)
  
}

#function for computing the p-value for each element of a vector of statistics
computePvaluesVect <- function(statsVect){        
  
  #how many values are present in the vector of statistics?
  numStatistics <- sum(!is.na(statsVect))
  
  #the rank function with ties.method = 'min' indicates how many statistics are 
  #larger or equal than each value in the vector
  #Note: we assume that the greater the statistics, the more significant the finding
  #This is the case with, for example, chi-square statistics
  #This is not the case for on-tailed t-test where more negative statistics are actually more extreme
  #The functions computing the statistics should be programmed accordingly; 
  #for example, by changing the sign of negative statistics and putting to zero positive once, 
  #or by returning the -log(desiredOneTailedPvalue)
  numLargerValues <- numStatistics - rank(statsVect, na.last = "keep", ties.method = "min");
  
  #correction for avoiding zero p-values
  pvaluesVect <- (numLargerValues + 1)/(numStatistics + 1);
  
  #returning the p-values
  return(pvaluesVect)
  
}  

# function for transforming an multi-dimensional array of statistics to pvalues
statisticsToPvalues <- function(stats){
  
  #stats is supposed to be an array where the permutations are stored in the last dimension
  
  #in case no dimension are defined
  if (is.null(dim(stats))) {
    stats <- array(stats, dim = c(1, length(stats)))
  }
  
  #how many dimensions?
  numDims <- length(dim(stats));
  
  #computing the p-values
  pvalues <- apply(stats, 1:(numDims-1), computePvaluesVect)
  
  #returning the values
  return(pvalues)
}

# function for combining p-values
combiningPvalues <- function(pvalues, method, dataWeights){
  
  #if no valid p-values, then return NA
  
  #depending by the method, a different combination function is applied
  if(method == "Fisher"){
    stats <- apply(pvalues,1,function(x){
                                idx <- which(!is.na(x));
                                if(length(idx) == 0){ #in case all p-values are NA
                                  return(NA);
                                }
                                -2*sum( dataWeights[idx] * log(x[idx]) ) })
  }else if(method == "Liptak"){
    stats <- apply(pvalues,1,function(x){
                                idx <- which(!is.na(x));                          
                                if(length(idx) == 0){ #in case all p-values are NA
                                  return(NA);
                                }
                                sum( dataWeights[idx] * qnorm(1 - x[idx]) ) })
  }else if(method == "Tippett"){
    stats <- apply(pvalues,1,function(x){
                                idx <- which(!is.na(x));
                                if(length(idx) == 0){ #in case all p-values are NA
                                  return(NA);
                                }
                                max( dataWeights[idx] * (1 - x[idx]) ) })
  }
  
  #returning the values
  return(stats)
  
}

#' @export
#' @title combiningMappings, combining several mappings for use in the omicsNPC function
#' @description
#' This function combines several annotation so that measurements across different datasets 
#' are mapped to the same reference elements (e.g., genes).
#' The annotations should all be either data frame / matrices, named vectors/lists, or bioMap objects.
#' See the examples for further details
#' @usage combiningMappings(mappings, reference = NULL, retainAll = FALSE)
#'
#' @param mappings List of annotations.
#' @param reference If the annotations are data frame, matrices or bioMap objects, 
#' the name of the column containing the reference elements
#' @param retainAll Logical, if set to TRUE measurements that have no counterparts in other datasets are retained
#'
#' @return A data frame encoding the mapping across several dataset
#'
#' @author Vincenzo Lagani
#'
#' @references
#' Nestoras Karathanasis, Ioannis Tsamardinos and Vincenzo Lagani. omicsNPC: applying the Non-Parametric Combination 
#' methodology to the integrative analysis of heterogeneous omics data. Submitted to PlosONE. 
#'
#' @examples
#' #Example 1
#' #Mapping with data frames
#' mRNA <- data.frame(gene = rep(c('G1', 'G2', 'G3'), each = 2), probeset = paste('p', 1:6, sep = ''));
#' methylation <- data.frame(gene = c(rep('G1', 3), rep('G2', 4)),
#'                                  methy = paste('methy', 1:7, sep = ''));
#' miRNA <- data.frame(gene = c(rep('G1', 2), rep('G2', 1), rep('G3', 2)),
#'                                miR = c('miR1', 'miR2', 'miR1', 'miR1', 'miR2'));
#' mappings <- list(mRNA = mRNA, methylation = methylation, miRNA = miRNA);
#' combiningMappings(mappings = mappings, retainAll = TRUE)
#' 
#' #Example 2
#' #Mapping with character vectors
#' mRNA <- rep(c('G1', 'G2', 'G3'), each = 2);
#' names(mRNA) = paste('p', 1:6, sep = '');
#' methylation <- c(rep('G1', 3), rep('G2', 4));
#' names(methylation) = paste('methy', 1:7, sep = '');
#' miRNA <- c(rep('G1', 2), rep('G2', 1), rep('G3', 2));
#' names(miRNA) = c('miR1', 'miR2', 'miR1', 'miR1', 'miR2');
#' mappings <- list(mRNA = mRNA, methylation = methylation, miRNA = miRNA);
#' combiningMappings(mappings = mappings, retainAll = TRUE)
#' 

combiningMappings <- function(mappings, reference = NULL, retainAll = FALSE){
  
  #validity checking
  if(!(is.list(mappings) && is.logical(retainAll))){
    stop('Mappings must be a list, retainAll must be a logical')
  }
  
  #let's check that the list mappings contains either 
  # - data frame / matrices or 
  # - lists / character vectors or
  # - bioMaps objects
  classes <- sapply(mappings, class);
  if(!all(classes %in% c('data.frame', 'matrix'))){
    if(!all(classes %in% c('list', 'character'))){
      if(!all(classes == 'bioMap') )
      stop('Individual mappings must all be either (a) data frames / matrices or (b) named lists / character vectors or (c) bioMap objects') 
    }
  }
  
  #if no names for the mappings, create fake ones
  if(is.null(names(mappings))){
    names(mappings) <- paste('dataset', 1:length(mappings), sep = "_")
  }
  
  #if the mappings are lists, then let's have them as data frames
  if(all(classes %in% c('list', 'character'))){
    
    #converting each individual mapping
    for(i in 1:length(mappings)){
      mappings[[i]] <- data.frame(names(mappings[[i]]), as.character(mappings[[i]]));
      names(mappings[[i]]) <- c(paste('Measurements_dataset_', i, sep = ''), 'Reference_elements');
    }
    
  }
  
  #if the mappings are bioMap objects, then let's have them as data frames
  if(all(classes == 'bioMap')){
    
    #converting each individual mapping
    for(i in 1:length(mappings)){
      map <- getMap(mappings[[i]])[, c(1,2)];
      names(map)[1] <- getMetadata(mappings[[i]])$type_v1;
      names(map)[2] <- getMetadata(mappings[[i]])$type_v2;
      mappings[[i]] <- map;
    }
    
  }
  
  #let's check that each mapping has two columns
  numColumns <- sapply(mappings, function(x){dim(x)[2]});
  if(any(numColumns != 2)){
    stop('Individual mappings must have two columns')
  }
  
  #checking on reference
  if (is.null(reference)){
    
    #if no reference is provided, mappings must have exactly one column in common
    reference <- colnames(mappings[[1]]);
    for(i in 2:length(mappings)){
      reference <- intersect(reference, colnames(mappings[[i]]));
    }
    if(length(reference) != 1){
      stop('If no reference column is indicated, individual mappings must have their columns named and exactly one column must be in common across them')
    } 
    
  }else{
    
    #only one reference allowed
    if(length(reference) != 1){
      stop('Please specify only one reference column')
    } 
    
    #all mappings must have this column
    for(i in 1:length(mappings)){
      if(!any(colnames(mappings[[i]]) == reference)){
        stop(paste('All mappings must contain the reference column', reference));
      }
    }
  }
  
  #creating the mapping!
  mapping <- as.data.frame(mappings[[1]]);
  for(i in 2:length(mappings)){
    currentMapping <- as.data.frame(mappings[[i]]);
    mapping <- merge(mapping, currentMapping, by = reference, all = retainAll);
  }
  
  #removing the reference from the mapping and making it the row names
  referenceElements <- mapping[[reference]];
  mapping[[reference]] <- NULL;
  mapping[[reference]] <- referenceElements; #this will put the reference as last column
  newRownames <- apply(mapping, 1, function(x){paste(x, collapse = ':')});
  toKeep <- !duplicated(newRownames);
  mapping <- mapping[toKeep, ];
  newRownames <- newRownames[toKeep];
  rownames(mapping) <- newRownames;
  
  #naming the columns of mapping
  colnames(mapping) <- c(names(mappings), reference);
  
  #let's have all columns of mappings as characters
  for(i in 1:(dim(mapping)[2])){
    mapping[[i]] <- as.character(mapping[[i]]);
  }
  
  #return
  return(mapping);
  
}

data(STATegRa_S1)
data(STATegRa_S3)

test_createOmicsExpressionSet <- function() {
    
    
    createOmicsExpressionSet(Data = Block1)
    #.PCA has no rownames, so doesn't work without pData
    checkException(createOmicsExpressionSet(Data = Block1.PCA))
    
    # pDataDescr should be auto-guessed
    createOmicsExpressionSet(Data = Block1.PCA, pData = ed.PCA, pDataDescr = c("classname"))
    checkEquals(createOmicsExpressionSet(Data=Block1.PCA, pData=ed.PCA),
                createOmicsExpressionSet(Data=Block1.PCA, pData=ed.PCA, pDataDescr=c("classname")))
    
    # unmatching or incomplete pData to be rejected
    checkException(createOmicsExpressionSet(Data=Block1, pData=ed[-1,,drop=F]))
    
    # lacking test data for feaData
}

data(STATegRa_S3)

B1 <- createOmicsExpressionSet(Data=Block1.PCA, pData=ed.PCA, pDataDescr=c("classname"))
B2 <- createOmicsExpressionSet(Data=Block2.PCA, pData=ed.PCA, pDataDescr=c("classname"))

test_modelSelection_single <- function() {
    res <- modelSelection(Input=list(B1, B2), Rmax=4, fac.sel="single%", varthreshold=0.03, center=TRUE, scale=FALSE, weight=TRUE, plot_common=FALSE, plot_dist=FALSE)
    checkEquals(res$common$commonComps, 2)
    checkEquals(res$dist[[1]]$numComps, 2)
    checkEquals(res$dist[[2]]$numComps, 2)
}


test_modelSelection_accum <- function() {
    res <- modelSelection(Input=list(B1, B2), Rmax=4, fac.sel="%accum", varthreshold=0.9, center=TRUE, scale=FALSE, weight=TRUE, plot_common=FALSE, plot_dist=FALSE)
    checkEquals(res$common$commonComps, 2)
    checkEquals(res$dist[[1]]$numComps, 0)
    checkEquals(res$dist[[2]]$numComps, 0)
}

#test_modelSelection_relabs <- function() {
    # doesn't work
    #res <- modelSelection(Input=list(B1, B2), Rmax=4, fac.sel="rel.abs", nvar=0.5)
#}

test_modelSelection_fixednum <- function() {
    res <- modelSelection(Input=list(B1, B2), Rmax=4, fac.sel="fixed.num", PCnum=3, center=TRUE, scale=FALSE, weight=TRUE, plot_common=FALSE, plot_dist=FALSE)
    checkEquals(res$common$commonComps, 2)
    checkEquals(res$dist[[1]]$numComps, 1)
    checkEquals(res$dist[[2]]$numComps, 1)
}

---
title: STATegRa User's Guide
author: The STATegra Consortium
date: "2018-04-04"
bibliography: bibliography.bib
output:
    BiocStyle::html_document:
        toc: true
        fig_retina: false
vignette: >
    %% \VignetteEngine{knitr::rmarkdown}
    %% \VignetteIndexEntry{STATegRa User's Guide}
---

```{r, echo=F, message=F, results="asis"}
# this block is invisible
BiocStyle::markdown()
require(STATegRa)
require(Biobase)
require(gridExtra)
require(ggplot2)
g_legend<-function(a.gplot){
    tmp <- ggplot_gtable(ggplot_build(a.gplot))
    leg <- which(sapply(tmp$grobs, function(x) x$name) == "guide-box")
    legend <- tmp$grobs[[leg]]
    return(legend)}
```

# Introduction

Recent developments in high-throughput technologies for studying biological systems enables the researcher to simultaneously obtain several different types of data ("omics") over the course of an experiment. There exist many techniques for analysing the behaviour of these omics individually, but combining multiple classes of omics data can be used to give a better understanding of the biological system in question; the whole is greater than the sum of its parts. Integration of different types of omics data is an increasingly important technique for studying biological systems. 

The first step in this kind of integration analysis is to identify patterns in data shared by all the omics classes, and use these patterns to identify outliers. The most common techniques for this sort of analysis are clustering and principal components analysis.

The `STATegRa` package provides several different techniques for the evaluation of reproducibility among samples and across experimental conditions by combining the information contained in multiple omics datasets. This is intended as a starting point for further integration analysis of any multi-omics dataset.

The `STATegRa` package implements two main utilities for this purpose: component analysis and clustering. 

[Component Analysis](#omics-component-analysis)
 ~  Three different techniques for analysing the common and distinctive variability between two different, multi-omics datasets are provided, along with various utility functions and plotting tools to evaluate the results.

[Clustering](#omics-clustering)
 ~  Methods are provided to cluster together features across different omics types, with a view to finding interesting similarities between features (rather than similarities between samples).

Furthermore, the next important step is the identification of genes, which are differential expressed between the experimental conditions under study, according to the different data types considered as a whole. The `STATegRa` package provides the possibility to identify genes which are differential expressed in one or more data types. One main utility is implemented for this purpose: omicsNPC. 

[omicsNPC](#omicsNPC)
 ~  omicsNPC is specifically devised for identifying differentially expressed genes by ‘holistically’ combining different omics data. It applies the NonParametric Combination (NPC) methodology [@Pesarin2010] in order to combine all available information by taking into account possible between-datasets correlations. 
 
This guide provides an overview of the different techniques included in the package, some worked examples of using the tools and some guidance on interpretation of the results obtained.

# Getting Started

The `r Biocpkg("STATegRa")` package can be obtained from the [Bioconductor repository](http://www.bioconductor.org/).

Load the `STATegRa` package into an `R` session by typing:

```{r, eval=F}
library(STATegRa) # Load STATegRa package 
```

General information about usage of the package and the algorithms used can be found in the package vignette. In addition, every public function in the package is documented and help can be found in the normal R fashion:

```{r, eval=F}
help(package="STATegRa") ## Package help
?omicsCompAnalysis ## Specific function help
```

# Omics Component Analysis

## Overview

The joint analysis of multiple omic datasets, both containing different classes of data and from different experimental conditions, could provide a "global" view on the biological system of interest. The major challenge in this type of analysis is to distinguish between the underlying mechanisms affecting all datasets, and the particular mechanisms which affect each omic dataset separately. Three different methods are provided to this end: *DISCO-SCA* [@van2012disco; @schouteden2013sca; @schouteden2014performing], *JIVE* [@lock2013joint] and *O2PLS* [@trygg2003o2]. Each method provides the user with a decomposition of the variability of the composite data into common and distinctive variability. All of them are based on singular value decomposition (SVD) of the data matrix, however they use different models to accomplish this. 

The *DISCO-SCA* [@van2012disco] approach consists of two steps. First a Simultaneous Components Analysis (SCA) is performed, then the scores obtained are rotated into a *DIS*tinctive and *CO*mmon structure (hence, *DISCO*). Therefore, by applying SCA approach, each block of data $X_k$ of size $I\times J_k$ becomes 

$$X_k=TP_k^T+E_k$$

with $T$ the $I\times R$ matrix of components scores that is shared between all blocks and $P_k$ the $J_k\times R$ matrix of components loadings for block $k$. Then, a rotation criterion is used where the target is the rotation which specifies distinctive components as components having zero scores in the positions that correspond to the data blocks the component does not underlie, and the remaining entries are arbitrary. The rotation matrix $B$ is found by minimizing $min(B)||W \circ (P_{target}-[P_1^TP_2^T]B)||^2 \mbox{ such that } B^TB=I=BB^T$, where $W$ is a binary matrix having ones in the positions of the entries in the target and zero elsewhere.

The *JIVE* approach [@lock2013joint] model is as following: Let $X_1,X_2$ be two blocks of data and $X=[X_1,X_2]$ represent the joint data, then the JIVE decomposition is defined as: 

$$X_i=J_i+A_i+\epsilon_i \mbox{, }i=1,2$$

where $J=[J_1,J_2]$ is the $p\times n$ matrix of rank $r<rank(X)$ representing the joint structure, $A_i$ is the $p_i\times n$ matrix of rank $r_i<rank(X_i)$ representing the individual structure of $X_i$ and $\epsilon_i$ are $p_i\times n$ error matrices of independent entries.

Finally, the *O2PLS* [@trygg2003o2] approach uses multiple linear regression to estimate the pure constituent profiles and divides the systematic part into two, one common to both blocks and one not. The *O2PLS* model can be written as a factor analysis where some factors are common between both blocks.

$$\mbox{X model: } X=TW^T+T_{Y-ortho}P^T_{Y-ortho}+E \\ \mbox{Y model: } Y=UC^T+U_{X-ortho}P^T_{X-ortho}+F \\ \mbox{Inner relation: } U=T+H$$

In this section, the different techniques for the analysis of the variability among different samples and conditions are explained. In addition, a worked example with an explanation of the interpretation of the graphical outputs is provided. 

## Usage

The typical workflow for component analysis is shown below.

![Main steps in components analysis](img/omicsPCA.png)

Firstly, the number of common and distinctive components must be determined. The `modelSelection()` function (see [Model Selection](#model-selection)) provides a heuristic for this if the numbers are not known.

The main analysis is done by running the `omicsCompAnalysis()` function (see [Component Analysis](#component-analysis)). The input data is a list of `ExpressionSet` objects, one for each block of data. These `ExpressionSet` objects can be created from a typical data matrix by using the `createOmicsExpressionSet()` function. An object describing the experiment design can also be added, which is used to appropriately format plots of the results. The `omicsCompAnalysis()` function allows the user to preprocess the input data by scaling and centering each block and/or weighting blocks together (to avoid the effects of blocks having different sizes). After the selected preprocessing is done, the analysis with the selected method is applied. The results are provided in a `caClass` object. This class contains the common and distinctive scores/loadings, as well as the initial data and the selected configuration for the analysis.

Finally, results can be plotted by using several plot functions on a `caClass` object (see [Plot results](#plot-results)).

## Worked example

### Load data

The dataset used for this section is based on the one used in OmicsClustering (`STATegRa_S1`), but is modified in a second step to obtain a dataset with a fixed number of common components by using the process described in [@van2012disco]. The initial dataset comprises $23,293$ genes and 534 miRNAs, but for the example presented here, 600 genes and 300 miRNAs are selecting according their significance in an ANOVA analysis comparing tumor subtypes^[Analysis done using the `limma` [@limma] R-package from Bioconductor]. 

Data can be loaded by typing:

```{r}
data("STATegRa_S3")
ls()
```

The loaded data consists of two matrices (`Block1.PCA`, `Block2.PCA`) corresponding to gene and microRNA expression data respectively. Also, another matrix (`ed.PCA`) indicating the experimental design of the data is provided. This experimental design matrix is a one-column matrix indicating which subtype of tumour corresponds to each sample. For the main analysis, the input consists of a list of expression sets. These matrices could be easily converted in `ExpressionSet` objects by using `createOmicsExpressionSet()` function as follows:

```{r}
# Block1 - gene expression data
B1 <- createOmicsExpressionSet(Data=Block1.PCA, pData=ed.PCA,
                               pDataDescr=c("classname"))

# Block2 - miRNA expression data
B2 <- createOmicsExpressionSet(Data=Block2.PCA, pData=ed.PCA, 
                               pDataDescr=c("classname"))
```

### Model Selection

To perform component analysis, it is required to find the number of common and distinctive components that the dataset is expected to contain. This step is optional; if you know how many common and distinctive components are expected, this can be used as input to the next step.

Model selection is done by using the `modelSelection()` function. This function first calculates the optimal number of common components. Then, the optimal number of individual components is found by subtracting the optimal number of individual components and the optimal number of common components calculated before. This individual components selection could be done by a cross-validation of the individual PCA results^[This option is not avaliable yet, but can be done using other R packages such as `r Biocpkg("pcaMethods")` or `r CRANpkg("missMDA")`], or by some other criteria.

For common components estimation, the Simultaneous Component Analysis (SCA) is applied. The idea is that the scores for both blocks should have a similar behavior if the components are in a common mode. That is, the estimation of the original data by using $\hat{X}=T_XP'_X$ and $\hat{X}_Y=T_YP'_X$ should give similar results. If not, the scores were calculated using uncommon factors and are not common components. To evaluate if a component is common or not, the ratios between the explained variances (SSQ) of each block and its estimation ($SSQ_X/SSQ_{X_Y}$ and $SSQ_Y/SSQ_{Y_X}$) are used. The highest component having its ratios between $0.8$ and $1.5$ is selected as the optimal number of common components. The SSQ can be shown as plots. 

For distinctive components, function allows the user to select the optimal number of distinctive components depending on the percentage of accumulated variance explained, the individual explained variance of each component, the absolute value of its variability or just a fixed number of components. 

Preprocessing of data can be done using this function, and should be specified by using the parameters `center`, `scale` and `weight`. If these parameters are not provided, preprocessing is not applied by default. Centering and scaling is applied independently to each block of data, while weight is applied to both blocks together. Weighting between blocks should be applied when the size of datasets is different.

```{r}
ms <- modelSelection(Input=list(B1, B2), Rmax=3, fac.sel="single%",
                     varthreshold=0.03, center=TRUE, scale=TRUE, 
                     weight=TRUE, plot_common=FALSE, plot_dist=FALSE)

grid.arrange(ms$common$pssq, ms$common$pratios, ncol=2) #switching plot_common=TRUE gives automaticaly these plots
```

This function automatically calculates the optimal number of common (allowing the visualization of SSQs) and individual components depending on the maximal number of common components and the individual components selection criteria provided by the user. The result is a list with the common and distinctive component analysis. 

### Component Analysis

Component Analysis is done using `omicsCompAnalysis()` function, where the method (DISCO, JIVE or O2PLS) to be applied is indicated via the `method` parameter. Preprocessing of data can be done using this function, and should be specified by using the parameters `center`, `scale` and `weight`, in the same way as `modelSelection()` function. If these parameters are not provided, preprocessing is not applied by default. Centering and scaling is applied independently to each block of data, while weight is applied to both blocks together. Weighting between blocks should be applied when the size of datasets is different. To use this function you have to specify the number of common and distinctive components (see [Model Selection](#model-selection)). Finally, the `convThres` and `maxIter` parameters are stop criteria for the DISCO-SCA and JIVE approaches. 

```{r}
discoRes <- omicsCompAnalysis(Input=list(B1, B2), Names=c("expr", "mirna"),
                              method="DISCOSCA", Rcommon=2, Rspecific=c(2, 2),
                              center=TRUE, scale=TRUE, weight=TRUE)
jiveRes <- omicsCompAnalysis(Input=list(B1, B2), Names=c("expr", "mirna"),
                             method="JIVE", Rcommon=2, Rspecific=c(2, 2),
                             center=TRUE, scale=TRUE, weight=TRUE)
o2plsRes <- omicsCompAnalysis(Input=list(B1, B2),Names=c("expr", "mirna"),
                              method="O2PLS", Rcommon=2, Rspecific=c(2, 2),
                              center=TRUE, scale=TRUE, weight=TRUE)
```

The results obtained are in a `caClass` object. 

```{r}
slotNames(discoRes)
```

Most of the slots in this class provide information about the input parameters/data of the function. The `InitialData` slot stores the input list of `ExpressionSet` objects and `Names` the specified names of the omics data sets. The `preprocessing` slot is a vector indicating the preprocessing applied to the data and `preproData` contains the so-processed data. The `caMethod` slot is a character indicating which components analysis method was applied to the data. The slots named `commonComps` and `distComps` indicate the number of common and distinctive components provided. Finally, the slots associated with the results of the analysis are `scores`, `loadings` and `VAF`. Finally, the `others` slot stores extra information specific to each different method.

These slots are accessible via accessor functions. All these functions allow the user to choose which part of the information in the slot is to be retrieved (e.g. the block of data whose information is retrieved can be specified in almost all accession functions). To access the initial data the `getInitialData()` and `getMethodInfo()` functions should be used. The first of these retrieves the initial data used for the component analysis and second one retrieves the method employed for the analysis as well as the number of common and distinctive components. The `getPreprocessing()` function allows the access to preprocessing information and preprocessed data. The results of the analysis can be displayed by using `getScores()`, `getLoadings()` and `getVAF()` functions. These functions allow the user to choose between common or individual results, as well as the block of data whose results are to be displayed.

The structure of scores and loadings data from DISCO-SCA and JIVE analyses are the same. Scores associated to common components are represented in a matrix with samples in the rows and as many columns as common components are selected. For O2PLS, these scores are instead divided into two matrices with the same structure, one associated to the contribution of the common components to one block and one associated to the other block. Scores associated to distinctive components are also represented by two matrices, one associated to each block, where rows represent samples and the number of columns depends of the number of distinctive components associated to each block. The loadings structure is the same for all methods. Two loadings matrices for the common part and two for the distinctive part, one associated to each block, are also provided. 

```{r, results="hide"}
# Exploring DISCO-SCA (or JIVE) score structure
getScores(discoRes, part="common")
getScores(discoRes, part="distinctive", block="1")
getScores(discoRes, part="distinctive", block="2")

# Exploring O2PLS score structure
getScores(o2plsRes, part="common", block="expr")
getScores(o2plsRes, part="common", block="mirna")
getScores(o2plsRes, part="distinctive", block="1")
getScores(o2plsRes, part="distinctive", block="2")
```

The variance explained for (VAF) each component is given in the `VAF` slot, as a list containing the VAF for common and distinctive components. In the case of O2PLS, VAF cannot be calculated, because the components are not orthogonal. VAF can be plotted by using the `plotVAF()` function. The structure of plots produced for a DISCO-SCA and JIVE result are different. In the case of DISCO-SCA, components of individual blocks have an associated error due to errors in the rotation. This is because the DISCO-SCA distinctive components have VAF in the other block. This VAF not associated to the corresponding block could be interpreted as the error for not having a perfect rotation^[See [@van2012disco] for more details.].

Example code and output for both approaches is shown below.

```{r}
# DISCO-SCA plotVAF
getVAF(discoRes)
plotVAF(discoRes)

# JIVE plotVAF
getVAF(jiveRes)
plotVAF(jiveRes)
```

### Plot results

Plotting the results obtained from `omicsCompAnalysis()` can be done by using `plotRes()` function. `plotRes()` allows plotting of scores, loadings or both, for common and distinctive parts, as well as combined plots of both parts together.

The most important parameters for `plotRes()` are:

`object`
 ~  `caClass` object, usually a result from `omicsCompAnalysis()` function.

 ~  `comps`, components to plot. If `combined=FALSE`, it indicates the x and y components of the `type` and `block` chosen. If `combined=TRUE`, it indicates the component to plot for the first block of information and the component for the second block of information to plot together. By default the components are set to `c(1,2)` if `combined=FALSE` and to `c(1,1)` if `combined=TRUE`.

 ~  `what=c("scores", "loadings","both")`, Are scores, loadings or both had to be represented?

 ~  `type=c("common", "individual", "both")`. Are common or individual components had to be represented? If both a common and individual componanent are represented. 

 ~  `combined`. Logical indicating if the plot is a simple plot representing two components from the same block of information, or a combined representation. The effect of the variable depends also on the values given for `comps`, `block` and `type`.

 ~  `block` indicates which block has to be represented. It can be specified by a numeric value (1 or 2) or a character (name of the block in the input data provided to the `omicsCompAnalysis()` analysis)

The DISCO-SCA and JIVE approaches calculate the common components in the joined matrix, so samples can be represented using a scatterplot of the score variables associated to the common components.

```{r}
# Scatterplot of scores variables associated to common components

# DISCO-SCA
plotRes(object=discoRes, comps=c(1, 2), what="scores", type="common",
        combined=FALSE, block=NULL, color="classname", shape=NULL, labels=NULL,
        background=TRUE, palette=NULL, pointSize=4, labelSize=NULL,
        axisSize=NULL, titleSize=NULL) 

# JIVE
plotRes(object=jiveRes, comps=c(1, 2), what="scores", type="common",
        combined=FALSE, block=NULL, color="classname", shape=NULL, labels=NULL,
        background=TRUE, palette=NULL, pointSize=4, labelSize=NULL,
        axisSize=NULL, titleSize=NULL) 
```
  
In the case of the O2PLS approach, scores associated to the common components are calculated separately for each block of data. So a scatter plot of common components can be plotted independently for each block of data or together in a combined plot using the scores associated to a selected component in both blocks of data^[The function `g_legend()` used in these examples the commonly-used utility for sharing a \texttt{ggplot2} legend between multiple plots. The source can be found [here](https://github.com/hadley/ggplot2/wiki/Share-a-legend-between-two-ggplot2-graphs).].
 
```{r}
# O2PLS 
# Scatterplot of scores variables associated to common components

# Associated to first block
p1 <- plotRes(object=o2plsRes, comps=c(1, 2), what="scores", type="common",
              combined=FALSE, block="expr", color="classname", shape=NULL,
              labels=NULL, background=TRUE, palette=NULL, pointSize=4,
              labelSize=NULL, axisSize=NULL, titleSize=NULL)
# Associated to second block
p2 <- plotRes(object=o2plsRes, comps=c(1, 2), what="scores", type="common",
              combined=FALSE, block="mirna", color="classname", shape=NULL,
              labels=NULL, background=TRUE, palette=NULL, pointSize=4,
              labelSize=NULL, axisSize=NULL, titleSize=NULL)
# Combine both plots
# g_legend function from
# https://github.com/hadley/ggplot2/wiki/Share-a-legend-between-two-ggplot2-graphs
legend <- g_legend(p1)
grid.arrange(arrangeGrob(p1+theme(legend.position="none"),
                         p2+theme(legend.position="none"), nrow=1),
             legend, heights=c(6/7, 1/7))

# Combined plot of scores variables assocaited to common components
plotRes(object=o2plsRes, comps=c(1, 1), what="scores", type="common",
        combined=TRUE, block=NULL, color="classname", shape=NULL,
        labels=NULL, background=TRUE, palette=NULL, pointSize=4,
        labelSize=NULL, axisSize=NULL, titleSize=NULL) 
```

The scores plot associated to individual components can be plotted using an scatterplot for each block of data in the same way that common components scores are for the O2PLS approach. A combined plot representing the components of each block of data together can be plotted, too. 
 
```{r}
# DISCO-SCA scores scatterplot associated to individual components

# Associated to first block
p1 <- plotRes(object=discoRes, comps=c(1, 2), what="scores", type="individual",
              combined=FALSE, block="expr", color="classname", shape=NULL,
              labels=NULL, background=TRUE, palette=NULL, pointSize=4,
              labelSize=NULL, axisSize=NULL, titleSize=NULL)
# Associated to second block
p2 <- plotRes(object=discoRes, comps=c(1, 2), what="scores", type="individual",
              combined=FALSE, block="mirna", color="classname", shape=NULL,
              labels=NULL, background=TRUE, palette=NULL, pointSize=4,
              labelSize=NULL, axisSize=NULL, titleSize=NULL)
# Combine plots
legend <- g_legend(p1)
grid.arrange(arrangeGrob(p1+theme(legend.position="none"),
                         p2+theme(legend.position="none"), nrow=1),
             legend, heights=c(6/7, 1/7))

# DISCO-SCA scores combined plot for individual components
plotRes(object=discoRes, comps=c(1, 1), what="scores", type="individual",
        combined=TRUE, block=NULL, color="classname", shape=NULL,
        labels=NULL, background=TRUE, palette=NULL, pointSize=4,
        labelSize=NULL, axisSize=NULL, titleSize=NULL)
```

Combined plots of scores for common and individual components together can be plotted with the results of all methods. In the case of the DISCO-SCA and JIVE approaches the components associated to the common part is the same in both plots but in the case of the O2PLS approach the common component represented is the one associated to each block of data.

```{r}
# DISCO-SCA plot of scores for common and individual components
p1 <- plotRes(object=discoRes, comps=c(1, 1), what="scores", type="both",
              combined=FALSE, block="expr", color="classname", shape=NULL,
              labels=NULL, background=TRUE, palette=NULL, pointSize=4,
              labelSize=NULL, axisSize=NULL, titleSize=NULL)
p2 <- plotRes(object=discoRes, comps=c(1, 1), what="scores", type="both",
              combined=FALSE, block="mirna", color="classname", shape=NULL,
              labels=NULL, background=TRUE, palette=NULL, pointSize=4,
              labelSize=NULL, axisSize=NULL, titleSize=NULL)
legend <- g_legend(p1)
grid.arrange(arrangeGrob(p1+theme(legend.position="none"),
                         p2+theme(legend.position="none"), nrow=1),
             legend, heights=c(6/7, 1/7))

# O2PLS plot of scores for common and individual components
p1 <- plotRes(object=o2plsRes, comps=c(1, 1), what="scores", type="both",
              combined=FALSE, block="expr", color="classname", shape=NULL,
              labels=NULL, background=TRUE, palette=NULL, pointSize=4,
              labelSize=NULL, axisSize=NULL, titleSize=NULL)
p2 <- plotRes(object=o2plsRes, comps=c(1, 1), what="scores", type="both",
              combined=FALSE, block="mirna", color="classname", shape=NULL,
              labels=NULL, background=TRUE, palette=NULL, pointSize=4,
              labelSize=NULL, axisSize=NULL, titleSize=NULL)
legend <- g_legend(p1)
grid.arrange(arrangeGrob(p1+theme(legend.position="none"),
                         p2+theme(legend.position="none"), nrow=1),
             legend, heights=c(6/7, 1/7))
```

For the loadings representation, the plots provided by `plotRes()` function are the same than scores representation. In the case of loadings the plots associated to all methods are the same, so only plots associated to DISCO-SCA approach are shown.

The scatterplot of loadings are represented separated for each block. No joint representation is allowed.

```{r}
# Loadings plot for common components

# Separately for each block
p1 <- plotRes(object=discoRes, comps=c(1, 2), what="loadings", type="common",
              combined=FALSE, block="expr", color="classname", shape=NULL,
              labels=NULL, background=TRUE, palette=NULL, pointSize=4,
              labelSize=NULL, axisSize=NULL, titleSize=NULL)
p2 <- plotRes(object=discoRes, comps=c(1, 2), what="loadings", type="common",
              combined=FALSE, block="mirna", color="classname", shape=NULL,
              labels=NULL, background=TRUE, palette=NULL, pointSize=4,
              labelSize=NULL, axisSize=NULL, titleSize=NULL)
grid.arrange(arrangeGrob(p1+theme(legend.position="none"),
                         p2+theme(legend.position="none"), nrow=1), 
             heights=c(6/7, 1/7))
```

In the case of individual components the plots can be represented, too.

```{r}
# Loadings plot for individual components

# Separately for each block
p1 <- plotRes(object=discoRes, comps=c(1, 2), what="loadings", type="individual",
              combined=FALSE, block="expr", color="classname", shape=NULL,
              labels=NULL, background=TRUE, palette=NULL, pointSize=4,
              labelSize=NULL, axisSize=NULL, titleSize=NULL)
p2 <- plotRes(object=discoRes, comps=c(1, 2), what="loadings", type="individual",
              combined=FALSE, block="mirna", color="classname", shape=NULL,
              labels=NULL, background=TRUE, palette=NULL, pointSize=4,
              labelSize=NULL, axisSize=NULL, titleSize=NULL)
grid.arrange(arrangeGrob(p1+theme(legend.position="none"),
                         p2+theme(legend.position="none"), nrow=1), 
             heights=c(6/7, 1/7))
```

Moreover, the loadings associated to common and individual components can be plotted together using a combined plot for each block.

```{r}
p1 <- plotRes(object=discoRes, comps=c(1, 1), what="loadings", type="both",
              combined=FALSE, block="expr", color="classname", shape=NULL,
              labels=NULL, background=TRUE, palette=NULL, pointSize=4,
              labelSize=NULL, axisSize=NULL, titleSize=NULL)
p2 <- plotRes(object=discoRes, comps=c(1, 1), what="loadings", type="both",
              combined=FALSE, block="mirna", color="classname", shape=NULL,
              labels=NULL, background=TRUE, palette=NULL, pointSize=4,
              labelSize=NULL, axisSize=NULL, titleSize=NULL)
grid.arrange(arrangeGrob(p1+theme(legend.position="none"),
                         p2+theme(legend.position="none"), nrow=1), 
             heights=c(6/7, 1/7)) 
```

Finally, a joint plot with scores and loading for each block can be represented setting `what="both"`.

```{r, warning=FALSE}
# Scores and loading plot for common part. DISCO-SCA
p1 <- plotRes(object=discoRes, comps=c(1, 2), what="both", type="common", 
          combined=FALSE, block="expr", color="classname", shape=NULL,
          labels=NULL, background=TRUE, palette=NULL, pointSize=4,
          labelSize=NULL, axisSize=NULL, titleSize=NULL,
          sizeValues=c(2, 2), shapeValues=c(17, 0))
p2 <- plotRes(object=discoRes, comps=c(1, 2), what="both", type="common", 
          combined=FALSE, block="mirna", color="classname", shape=NULL,
          labels=NULL, background=TRUE, palette=NULL, pointSize=4,
          labelSize=NULL, axisSize=NULL, titleSize=NULL,
          sizeValues=c(2, 2), shapeValues=c(17, 0))
legend <- g_legend(p1)
grid.arrange(arrangeGrob(p1+theme(legend.position="none"),
                         p2+theme(legend.position="none"), nrow=1),
             legend, heights=c(6/7, 1/7))

# Scores and loadings plot for common part. O2PLS 
p1 <- plotRes(object=o2plsRes, comps=c(1, 2), what="both", type="common", 
          combined=FALSE, block="expr", color="classname", shape=NULL,
          labels=NULL, background=TRUE, palette=NULL, pointSize=4,
          labelSize=NULL, axisSize=NULL, titleSize=NULL,
          sizeValues=c(2, 2), shapeValues=c(17, 0))
p2 <- plotRes(object=o2plsRes, comps=c(1, 2), what="both", type="common", 
          combined=FALSE, block="mirna", color="classname", shape=NULL,
          labels=NULL, background=TRUE, palette=NULL, pointSize=4,
          labelSize=NULL, axisSize=NULL, titleSize=NULL,
          sizeValues=c(2, 2), shapeValues=c(17, 0))
legend <- g_legend(p1)
grid.arrange(arrangeGrob(p1+theme(legend.position="none"),
                         p2+theme(legend.position="none"), nrow=1),
             legend, heights=c(6/7, 1/7))

# Scores and loadings plot for distinctive part. O2PLS 
p1 <- plotRes(object=o2plsRes, comps=c(1, 2), what="both", type="individual", 
          combined=FALSE, block="expr", color="classname", shape=NULL,
          labels=NULL, background=TRUE, palette=NULL, pointSize=4,
          labelSize=NULL, axisSize=NULL, titleSize=NULL,
          sizeValues=c(2, 2), shapeValues=c(17, 0))
p2 <- plotRes(object=o2plsRes, comps=c(1, 2), what="both", type="individual", 
          combined=FALSE, block="mirna", color="classname", shape=NULL,
          labels=NULL, background=TRUE, palette=NULL, pointSize=4,
          labelSize=NULL, axisSize=NULL, titleSize=NULL,
          sizeValues=c(2, 2), shapeValues=c(17, 0))
legend <- g_legend(p1)
grid.arrange(arrangeGrob(p1+theme(legend.position="none"),
                         p2+theme(legend.position="none"), nrow=1),
             legend, heights=c(6/7, 1/7))
```

# Omics Clustering

```{r, echo=F, message=F}
# clear the environment before starting the omicsClustering example
rm(list=ls())
```

## Overview

### The Problem

Clustering can be briefly described as the task of grouping features (such as genes) based on a measure of similarity or closeness.  
Probably the most commonly used clustering methodologies are hierarchical clustering and k-means, however distribution models and density models are starting to gain traction in the bioinformatic community. A common characteristic is that all those methodologies were conceived for the grouping of variables given a single type of underlying data.

If we consider the problem of clustering based on the mRNA expression and proteomic expression of 100 individuals we may consider two clustering situations. The first is the clustering of samples which has been studied in the existing literature; see [@Pandey2010] as an example . We will not address this problem in the present guide, however the methodologies proposed here can be adapted to solve this problem instead (ie cluster samples instead of features). The second is the clustering of features, that is the clustering of genes and/or proteins (or any other omic features), both with other features of the same type and features of different types. Network-based methodologies do exist that aim to the identification of modules (clusters) in multi-omic networks; an example is [@Rivera2010]. However in the case of feature-based multi-omic clustering we consider necessary to discuss in detail the following aspects:

Normalization
:    the levels of protein and mRNA may not be measured over the same ranges. For centroid-based models such as k-means this would affect the distance measurements. In connectivity-based models such as hierarchical clustering the effect would be different, but large differences of normalisation in different data types will still be problematic.
Mapping
:    we may also consider using genes and proteins as a single feature type by mapping each protein to the associated gene. In this case we may opt to map proteins to corresponding genes; the mapping and the subsequent analytical steps will need to handle the cases where (1) a protein does not map to any profiled gene or (2) a gene maps to more than one protein among others. Once the mapping is clear, how the original and mapped profiles are to be used needs to be defined.


The challenge of mapping and the use of the mapping becomes more complex when we consider the combination of omics such as:

 + miRNA and mRNA: no direct mapping exists, however a miRNA to gene regulation mappings is available. We may consider the use of existing data-bases such as those described in RNACentral [@Bateman2011; @Pritchard2012]. 
 + DNA Methylation and mRNA: no direct mapping exists, however a mapping can be computed by considering the *cpg-to-the-closest-gene*, or any other distance-based assumptions [@Jones2012]. 

Following those ideas and challenges we have defined a flexible integrative framework to cluster several omics being the mapping between the mapping the unique requirement. The methodology developed is flexible enough to answer many different questions such as (1) the integrative clustering, (2) comparative clustering, (3) the quantitative comparison of the effect of the different omics in the feature regulation and (4) omic-weighted distance between features of interest among others.

### The OmicsClustering Approach

![The OmicsClustering approach](img/omicsClustering.jpg)

For cluster analysis of multiple omics datasets the typical workflow is shown above. This example has only two data types; mRNA and miRNA, but the methodology can handle more types of data, providing some mapping can be defined between them.

For this example, genes are considered the **reference feature**, and in **Part A** distances between genes are computed by using mRNA data. In **Part B** distances between genes are computed by using miRNA data and a mapping between miRNA and genes. Finally, combinations of those distances are used in the analysis of single features (for which functions are included in `STATegRa`) or for clustering (using existing R functions such as `hclust` or `kmeans`).

A worked example for these data types with code and figures is given below.

## Usage

### Loading the data

For this example we made used of an existing TCGA^[The Cancer Genome Atlas, <http://cancergenome.nih.gov>] data-set. The dataset used for this section was obtained from the dataset described in [@van2012disco] and is available from TCGA processed data.

We extracted the [classification](https://tcga-data.nci.nih.gov/docs/publications/gbm_exp/TCGA_unified_CORE_ClaNC840.txt) and the [unified gene expression](https://tcga-data.nci.nih.gov/docs/publications/gbm_exp/unifiedScaledFiltered.txt) from TCGA. The miRNA was downloaded from TCGA directly. The full dataset can be loaded by typing:

```{r}
data("STATegRa_S1")
ls()
```

`Block1` includes mRNA data and `Block2` includes miRNA data.

### Computing the distance between genes by using mRNA data: the bioDistclass class

Firstly, we generate an `ExpressionSet` object for both the miRNA and mRNA data.

```{r}
# Block1 - Expression data
mRNA.ds <- createOmicsExpressionSet(Data=Block1, pData=ed, pDataDescr=c("classname"))
# Block2 - miRNA expression data
miRNA.ds <- createOmicsExpressionSet(Data=Block2, pData=ed, pDataDescr=c("classname"))
```

Secondly, we compute the distance between all genes in `Block1` (mRNA data) using Spearman correlation.

```{r}
# Create Gene-gene distance computed through mRNA data
bioDistmRNA <- bioDistclass(name="mRNAbymRNA",
                            distance=cor(t(exprs(mRNA.ds)),
                                         method="spearman"),
                            map.name="id",
                            map.metadata=list(),
                            params=list())
```

The `bioDistmRNA` object, generated with the `bioDistclass` function, is a `bioDistclass` object that contains both the original data and the computed distance between features.

### Loading the map between miRNA and genes: the bioMap class

In this section we load and store the map between miRNA and mRNA. Data file (`STATegRa_S2`) contains, as a processed matrix, the information available from TargetScan [@targetscan], which provided a set of miRNA target predictions for humans.

```{r}
data(STATegRa_S2)
ls()
```

This data is stored in a `bioMap` class object generated through the `bioMap` function as follows:

```{r}
MAP.SYMBOL <- bioMap(name = "Symbol-miRNA",
                     metadata = list(type_v1="Gene", type_v2="miRNA",
                                     source_database="targetscan.Hs.eg.db",
                                     data_extraction="July2014"),
                     map=mapdata)
```

### miRNA-Surrogate gene Distances: the bioDist function

The `bioDist` function returns a `bioDistclass` object. The input is a reference feature list (genes in this example), surrogate data (miRNA, in `Block2`) and the bioMap object between reference and surrogate features.

```{r}
bioDistmiRNA <- bioDist(referenceFeatures=rownames(Block1),     
                        reference="Var1",
                        mapping=MAP.SYMBOL,
                        surrogateData=miRNA.ds, 
                        referenceData=mRNA.ds, 
                        maxitems=2,
                        selectionRule="sd",
                        expfac=NULL,
                        aggregation="sum",
                        distance="spearman",
                        noMappingDist=0,
                        filtering=NULL,
                        name="mRNAbymiRNA")
```

### Computing weighted distances: the bioDistW function

Having `bioDistmiRNA` and `bioDistmRNA` `bioDistclass` objects containing distances between genes, we aim to use weighted combinations of them to compute an single distance matrix.

First we make a list of `bioDistclass` objects:

```{r}
bioDistList <- list(bioDistmRNA, bioDistmiRNA)
```

Secondly we make a matrix listing containing the weighted combinations to be generated. Each row is interpreted as a combination to generate, with the elements of the row interpreted as the weight for each of the input omics.

```{r}
sample.weights <- matrix(0, 4, 2)
sample.weights[, 1] <- c(0, 0.33, 0.67, 1)
sample.weights[, 2] <- c(1, 0.67, 0.33, 0)
sample.weights
```

This matrix corresponds to generating four combinations, with the first consisting of $0\times mRNA + 1\times miRNA$ and so on.

Finally, the `bioDistW` function computes the weighted combinations in the weights matrix and stores it into a `bioDistWclass` list. 

```{r}
bioDistWList <- bioDistW(referenceFeatures=rownames(Block1),
                         bioDistList=bioDistList,
                         weights=sample.weights)
length(bioDistWList)
```

## Plots

### Plotting the feature distance of each weighted combination

Each `bioDistWclass` object contains a distance matrix computed through a weighted combination of distances derived from different omics. By considering the distances between these distance matrices we can project in two dimensions using Multi-Dimensional Scaling. By this approach we can visualize the effect of the different weights on the feature-to-feature distance structure.

To generate such a plot:

```{r, warning=F}
bioDistWPlot(referenceFeatures=rownames(Block1),
             listDistW=bioDistWList,
             method.cor="spearman")
```

### Plotting associated features

The purpose of this analysis is to generate an overall distance measure between features, so it follows that given a feature of interest we will want to find other features that are near it. For this example we use the gene IDH1, which was shown to be of relevance in the original data analysis. 

In order to find all other genes for which at least one weighted combination has a correlation greater than $0.7$, we do:

```{r}
IDH1.F <- bioDistFeature(Feature="IDH1",
                         listDistW=bioDistWList,
                         threshold.cor=0.7)
```

The `bioDistFeature` function generates a matrix of associated genes (columns) depending on weighted combinations (rows); rows are named by the `bioDistWclass`'s name slot. 

The `IDH1.F` matrix can be plotted with the `bioDistFeaturePlot` function, as shown below. (This function is a wrapper around `heatmap.2` from `r CRANpkg("gplots")` with appropriate options, but `IDH1.F` is a normal R matrix and can be used with most other matrix-plotting tools).

```{r, message=F}
bioDistFeaturePlot(data=IDH1.F)
```

### OmicsClustering Requirements
The requirements for running OmicsClustering are minimal. The data considered has to be compatible with the distance measure selected. The relevant aspect is that the mapping between features needs to be `informative enough`. We do not consider the use of OmicsClustering when the mapping between features involves less than 15-25% of the reference set of features; this number was obtained from preliminary analysis over few data sets however further investigation is being conducted.

# omicsNPC

```{r, echo=F, message=F}
# clear the environment before starting the omicsNPC example
rm(list=ls())
```

## Overview

### The Problem
Recent advancements in omics technologies allow to measure several data modalities, e.g., RNA-sequencing, protein levels, etc., on the same biological samples. In such settings an interesting task is the identification of genes that, according to all modalities considered as a whole, are either deregulated or associated to an outcome of interest.

### The NPC Approach
*omicsNPC* implements the Non Parametric Combination (NPC) methodology [@Pesarin2010] in a way that is specifically tailored for the idiosyncrasies of omics data. First, each data type is analyzed independently. Currently, *omicsNPC* uses the package `r Biocpkg("limma")` for computing deregulation / association statistics and p-values; count data, e.g., RNAseq, are first transformed using the voom function. The user can also specify custom functions for computing relevant statistics in each dataset. The resulting p-values are combined by employing appropriate combining functions. The Tippett combining function returns findings which are supported by at least one omics modality. The Liptak function returns findings which are supportd by most modalities. The Fisher function has an intermediate behavior between those of Tippett and Liptak.

Several important features make the use of omicsNPC appealing.

 + *omicsNPC* makes **minimal assumptions**: as permutation is employed throughout the process, no parametric form is assumed for the null distribution of the statistical tests, and the main requirement is samples to be freely exchangeable under the null-hypothesis.
 + It provides **global p-values** for assessing the overall contribution of all data modalities.
 + It is characterized by **great flexibility**: it can address study designs with multiple factors, as well as partially overlapping measurements / samples.
 + It frees the researcher from the need of defining and **modeling between-datasets dependencies** [@Pesarin2010].

A worked example with code is given below.

## Usage

### Loading the data

For this example we use an existing TCGA^[The Cancer Genome Atlas, <http://cancergenome.nih.gov>] data-set. We downloaded sixteen tumour samples and the sixteen matching normal, for Breast invasive carcinoma, BRCA, batch 93. We used three types of data modalities, “RNAseq”, “RNAseqV2” and “Expression-Gene”. `RNAseq` corresponds to RNA sequensing data, *IlluminaHiSeq-RNASeq* platform, `RNAseqV2` corresponds to RNA sequencing data, *IlluminaHiSeq-RNASeqV2* platform and `Expression-Gene` corresponds to array based expression data, *AgilentG4502A-07-3* platform. For `RNAseq` and `RNAseqV2` data we keep the "raw counts". For each data type, we pooled all data to one matrix, where rows corresponded to genes and columns to samples. We selected 100 genes to be used in this example. Finally, each matrix was converted to an `ExpressionSet` object and the resulting objects were saved in a `list`.

The datasets can be loaded by typing:

```{r}
data("TCGA_BRCA_Batch_93")
ls()
```

`TCGA_BRCA_Data` is a list, which includes three objects of the `ExpressionSet` class. The matrices containing the expression values can be visualized by typing:

```{r, results='hide'}
exprs(TCGA_BRCA_Data$RNAseq) # displays the RNAseq data
exprs(TCGA_BRCA_Data$RNAseqV2) # displays the RNAseqV2 data
exprs(TCGA_BRCA_Data$Microarray) # displays the Exp-Gene data
```

Each row corresponds to a gene and each column to a sample. Samples are subdivided between "tumour" and "normal".

The class of each sample can be visualized by typing

```{r, results='hide'}
pData(TCGA_BRCA_Data$RNAseq) # class of RNAseq samples
pData(TCGA_BRCA_Data$RNAseqV2) # class of RNAseqV2 samples
pData(TCGA_BRCA_Data$Microarray) # class of Exp-Gene samples
```

Please note that each dataset could have different design matrices; *omicsNPC* only assumes that the last column of each design matrix contains the factor whose association with each gene should be assessed. This factor can be either continuous (e.g., IG50 values), or categorical (tumour / normal) as in the present example.

### Setting the dataTypes variable

The `dataTypes` vector specifies the type of data in input and consequently the method for computing the association between each measurement and the factor of interest. If given as a character vector, possible values for `dataTypes` are `'count'` and `'continuous'`. The first value requires the data to be transormed with the voom function (from `limma`) before being analyzed, while the latter directly apply limma moderated t-statistics. Alternatively, the user can specify a list of custom functions.

```{r}
dataTypes <- c("count", "count", "continuous")
```

### Setting the combMethods variable

The `combMethods` variable is a character vector with possible values: `'Fisher', 'Liptak', 'Tippett'`. All combining functions can be used simultaneously.

```{r}
combMethods <- c("Fisher", "Liptak", "Tippett")
```

### Setting the numPerms, numCores and verbose variables

`numPerms` is the number of permutations to perform. The number of permutations can be adjusted depending on the number of available samples. In general 1000 permutation is usually a good point to start.

```{r}
numPerms <- 1000
```

*omicsNPC* can perform the desired permutations in parallel, and `numCores` specifies the number of cores to be used. By default, one single core is used.

```{r}
numCores <- 1
```

`verbose` is a logical. If it is set to `TRUE`, *omicsNPC* prints out the steps that it performs.

```{r}
verbose <- TRUE
```

### Run omicsNPC analysis.

One main function is available for running *omicsNPC* analysis:

```{r}
results <- omicsNPC(dataInput=TCGA_BRCA_Data, dataTypes=dataTypes,
                    combMethods=combMethods, numPerms=numPerms,
                    numCores=numCores, verbose=verbose)
```

`results` is a list containing `pvalues0` and `pvaluesNPC`.
+ `pvalues0` is a matrix having one column for each data modality. Each column contains the p-values assessing the association of each measurement with the factor of interest corrected for the other factors present in the study design (pheno data).
+ `pvaluesNPC` is a matrix having one column for each combination function. Each column provides the global p-values obtained by combining single-datasets p-values with the corresponding combination function.

# References

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/STATegRa_combiningMappings.R
\name{combiningMappings}
\alias{combiningMappings}
\title{combiningMappings, combining several mappings for use in the omicsNPC function}
\usage{
combiningMappings(mappings, reference = NULL, retainAll = FALSE)
}
\arguments{
\item{mappings}{List of annotations.}

\item{reference}{If the annotations are data frame, matrices or bioMap objects, 
the name of the column containing the reference elements}

\item{retainAll}{Logical, if set to TRUE measurements that have no counterparts in other datasets are retained}
}
\value{
A data frame encoding the mapping across several dataset
}
\description{
This function combines several annotation so that measurements across different datasets 
are mapped to the same reference elements (e.g., genes).
The annotations should all be either data frame / matrices, named vectors/lists, or bioMap objects.
See the examples for further details
}
\examples{
#Example 1
#Mapping with data frames
mRNA <- data.frame(gene = rep(c('G1', 'G2', 'G3'), each = 2), probeset = paste('p', 1:6, sep = ''));
methylation <- data.frame(gene = c(rep('G1', 3), rep('G2', 4)),
                                 methy = paste('methy', 1:7, sep = ''));
miRNA <- data.frame(gene = c(rep('G1', 2), rep('G2', 1), rep('G3', 2)),
                               miR = c('miR1', 'miR2', 'miR1', 'miR1', 'miR2'));
mappings <- list(mRNA = mRNA, methylation = methylation, miRNA = miRNA);
combiningMappings(mappings = mappings, retainAll = TRUE)

#Example 2
#Mapping with character vectors
mRNA <- rep(c('G1', 'G2', 'G3'), each = 2);
names(mRNA) = paste('p', 1:6, sep = '');
methylation <- c(rep('G1', 3), rep('G2', 4));
names(methylation) = paste('methy', 1:7, sep = '');
miRNA <- c(rep('G1', 2), rep('G2', 1), rep('G3', 2));
names(miRNA) = c('miR1', 'miR2', 'miR1', 'miR1', 'miR2');
mappings <- list(mRNA = mRNA, methylation = methylation, miRNA = miRNA);
combiningMappings(mappings = mappings, retainAll = TRUE)

}
\references{
Nestoras Karathanasis, Ioannis Tsamardinos and Vincenzo Lagani. omicsNPC: applying the Non-Parametric Combination 
methodology to the integrative analysis of heterogeneous omics data. Submitted to PlosONE.
}
\author{
Vincenzo Lagani
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/STATegRa_omicsPCA_caClass.R
\name{getVAF}
\alias{getVAF}
\alias{getVAF,caClass-method}
\title{Retrieve information abotut VAF}
\usage{
getVAF(x, part=NULL, block=NULL)
}
\arguments{
\item{x}{\code{\link{caClass-class}} object.}

\item{part}{Character indicating whether "common" or "distinctive" VAF should be displayed}

\item{block}{Character indicating the block of data for which the VAF will be given. It can be specified by the position of the block ("1" or "2") or the name assigned in the \code{\link{caClass-class}} object. If it is NULL both blocks are displayed.}
}
\value{
A list containing the requested information.
}
\description{
Generic function to retrieve VAF found by \code{\link{omicsCompAnalysis}} on a \code{\link{caClass-class}} object.
}
\examples{
data("STATegRa_S3")
B1 <- createOmicsExpressionSet(Data=Block1.PCA, pData=ed.PCA,
                               pDataDescr=c("classname"))
B2 <- createOmicsExpressionSet(Data=Block2.PCA,
                               pData=ed.PCA, pDataDescr=c("classname"))
# Omics components analysis
res <- omicsCompAnalysis(Input=list(B1, B2), Names=c("expr", "mirna"),
                         method="DISCOSCA", Rcommon=2, Rspecific=c(2, 2),
                         center=TRUE, scale=TRUE, weight=TRUE)
getVAF(res)
getVAF(res, part="common")
getVAF(res, part="distinctive", block="expr")
}
\seealso{
\code{\link{omicsCompAnalysis}}, \code{\link{caClass-class}}
}
\author{
Patricia Sebastian-Leon
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/STATegRa_omicsPCA_methods.R
\name{modelSelection}
\alias{modelSelection}
\alias{modelSelection,list,numeric,character-method}
\title{Find optimal common and distinctive components}
\usage{
modelSelection(Input,Rmax,fac.sel,varthreshold=NULL,nvar=NULL,PCnum=NULL,center=FALSE,scale=FALSE,weight=FALSE, plot_common=FALSE, plot_dist=FALSE)
}
\arguments{
\item{Input}{List of \code{ExpressionSet} objects, one for each block of data}

\item{Rmax}{Maximum common components}

\item{fac.sel}{PCA criteria for selection ("\%accum", "single\%", "rel.abs", "fixed.num")}

\item{varthreshold}{Cumulative variance criteria for PCA selection. Threshold for "\%accum" or "single\%" criteria.}

\item{nvar}{Relative variance criteria. Threshold for "rel.abs".}

\item{PCnum}{Fixed number of components for "fixed.num".}

\item{center}{Character (or FALSE) specifying which (if any) centering will be applied before analysis. Choices are "PERBLOCKS" (each block separately) or "ALLBLOCKS" (all data together).}

\item{scale}{Character (or FALSE) specifying which (if any) scaling will be applied before analysis. Choices are "PERBLOCKS" (each block separately) or "ALLBLOCKS" (all data together).}

\item{weight}{Logical indicating whether weighting is to be done. Choices are "BETWEEN-BLOCKS"}

\item{plot_common}{Logical indicating whether to plot the explained variances (SSQ) of each block and its estimation and the ratios}

\item{plot_dist}{Logical indicating whether to plot the explained variances (SSQ) and the accumulated variance for each block}
}
\value{
List containing:
\describe{
     \item{common}{List with common components results}
     \item{commonComps}{Optimal number of common components}
     \item{ssqs}{Matrix of SSQ for each block and estimator}
     \item{pssq}{\code{\link{ggplot}} object showing SSQ for each block and estimator}
     \item{pratios}{\code{\link{ggplot}} object showing SSQ ratios between each block and estimator}
     \item{dist}{List containg the results of distinct PCA for each input block; for each block PCAres and numComps is returned within a list}
     \item{PCAres}{List containing results of PCA, with fields "eigen", "var.exp", "scores" and "loadings"}
     \item{nomComps}{Number of components selected}
}
}
\description{
Estimate the optimal number of common and distinctive components according to given selection criteria.
}
\examples{
data(STATegRa_S3)
B1 <- createOmicsExpressionSet(Data=Block1.PCA,pData=ed.PCA,pDataDescr=c("classname"))
B2 <- createOmicsExpressionSet(Data=Block2.PCA,pData=ed.PCA,pDataDescr=c("classname"))
ms <- modelSelection(Input=list(B1, B2), Rmax=3, fac.sel="single\\\%", varthreshold=0.03, center=TRUE, scale=FALSE, weight=TRUE, plot_common=FALSE, plot_dist=FALSE)
ms
}
\seealso{
\code{\link{omicsCompAnalysis}}
}
\author{
Patricia Sebastian-Leon
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/STATegRa_omicsPCA_caClass.R
\docType{class}
\name{caClass-class}
\alias{caClass-class}
\title{caClass}
\description{
Stores the results of any of the omicsPCA analyses.
}
\section{Slots}{

\describe{
\item{\code{InitialData}}{List of ExpressionSets, one for each set of omics data}

\item{\code{Names}}{Character vector giving names for the input data}

\item{\code{preprocessing}}{Character vector describing the preprocessing applied to the data}

\item{\code{preproData}}{List of matrices containing data after preprocessing}

\item{\code{caMethod}}{Character giving the component analysis method name}

\item{\code{commonComps}}{Numeric giving the number of common components}

\item{\code{distComps}}{Numeric vector giving the number of distinctive components for each block}

\item{\code{scores}}{List of matrices of common and distinctive scores}

\item{\code{loadings}}{List of matrices of common and distinctive loadings}

\item{\code{VAF}}{List of matrices indicating VAF (Variability Explained For) for each component in each block of data}

\item{\code{others}}{List containing other miscellaneous information specific to different SCA methods}
}}

\author{
Patricia Sebastian Leon
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/STATegRa_omicsNPC.R
\name{omicsNPC}
\alias{omicsNPC}
\alias{omicsNPC,list,data.frame-method}
\alias{omicsNPC,list,missing-method}
\title{omicsNPC, applying the Non-Parametric Combination (NPC) on omics datasets}
\usage{
omicsNPC(dataInput, dataMapping, dataTypes = rep('continuous', length(dataInput)), 
               combMethods = c("Fisher", "Liptak", "Tippett"), numPerms = 1000, 
               numCores = 1, verbose = FALSE, functionGeneratingIndex = NULL, 
               outcomeName = NULL, allCombinations = FALSE, 
               dataWeights = rep(1, length(dataInput))/length(dataInput), 
               returnPermPvalues = FALSE, ...)
}
\arguments{
\item{dataInput}{List of ExpressionSet objects, one for each data modality.}

\item{dataMapping}{A data frame describing how to map measurements across datasets. See details for more information.}

\item{dataTypes}{Character vector with possible values: 'continuous', 'count'. Alternatively, a list of functions for assessing deregulation / association with an outcome}

\item{combMethods}{Character vector with possible values: 'Fisher', 'Liptak', 'Tippett'. If more than one is specified, all will be used.}

\item{numPerms}{Number of permutations}

\item{numCores}{Number of CPU cores to use}

\item{verbose}{Logical, if set to TRUE omicsNPC prints out the step that it performs}

\item{functionGeneratingIndex}{Function generating the indices for randomly permuting the samples}

\item{outcomeName}{Name of the outcome of interest / experimental factor, as reported in the design matrices. If NULL, the last column of the design matrices is assumed to be the outcome of interest.}

\item{allCombinations}{Logical, if TRUE all combinations of omics datasets are considered}

\item{dataWeights}{A vector specifying the weigth to give to each dataset. Note that sum(dataWeights) should be 1.}

\item{returnPermPvalues}{Logical, should the p-values computed at each permutation being returned?}

\item{...}{Additional arguments to be passed to the user-defined functions}
}
\value{
A list containing:
stats0 Partial deregulation / association statistics 
pvalues0 The partial p-values computed on each dataset
pvaluesNPC The p-values computed through NPC.
permPvalues The p-values computed at each permutation
}
\description{
This function applies the NonParametric Combination methodology on the integrative analysis 
of different omics data modalities.
It retrieves genes associated to a given outcome, taking into account all omics data.
First, each datatype is analyzed independently using the appropriate method.
omicsNPC analyses continuous data (microarray) using limma, while count data (e.g., RNAseq) 
are first preprocessed with using the "voom" function. The user can also specify their own 
function for computing deregulation / association 
The p-values from the single dataset analysis are then combined employing Fisher, 
Liptak and Tippett combining functions.
The Tippett function returns findings which are supported by at least one omics modality.
The Liptak function returns findings which are supportd by most modalities.
The Fisher function has an intermediate behavior between those of Tippett and Liptak.
}
\examples{
# Load the data
data("TCGA_BRCA_Batch_93")
# Setting dataTypes, the first two ExpressionSets include RNAseq data,
# the third ExpressionSet includes Microarray data.
dataTypes <- c("count", "count", "continuous")
# Setting methods to combine pvalues
combMethods = c("Fisher", "Liptak", "Tippett")
# Setting number of permutations
numPerms = 1000
# Setting number of cores
numCores = 1
# Setting omicsNPC to print out the steps that it performs.
verbose = TRUE
# Run omicsNPC analysis.
# The output contains a data.frame of p-values, where each row corresponds to a gene, 
# and each column corresponds to a method used in the analysis.

\dontrun{out <- omicsNPC(dataInput = TCGA_BRCA_Data, dataTypes = dataTypes,
                            combMethods = combMethods, numPerms = numPerms,
                            numCores = numCores, verbose = verbose)}
}
\references{
Pesarin, Fortunato, and Luigi Salmaso. Permutation tests for complex data: theory, applications and software.
John Wiley & Sons, 2010.
Nestoras Karathanasis, Ioannis Tsamardinos and Vincenzo Lagani. omicsNPC: applying the Non-Parametric Combination 
methodology to the integrative analysis of heterogeneous omics data. PlosONE 11(11): e0165545. doi:10.1371/journal.pone.0165545
}
\author{
Nestoras Karathanasis, Vincenzo Lagani
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/STATegRa_package.R
\docType{data}
\name{STATegRa_data}
\alias{STATegRa_data}
\alias{Block1}
\alias{Block2}
\alias{ed}
\alias{mapdata}
\alias{Block1.PCA}
\alias{Block2.PCA}
\alias{ed.PCA}
\title{STATegRa data}
\format{Two matrices with mRNA and miRNA expression data, a design matrix that describes both and a mapping between miRNA and genes.}
\source{
(a)  See \url{https://tcga-data.nci.nih.gov/docs/publications/gbm_exp/}.
(b)  Gabor Csardi, \code{targetscan.Hs.eg.db}: TargetScan miRNA target predictions for human. R package version 0.6.1
}
\description{
mRNA data (\code{Block1}), miRNA data (\code{Block2}) and the design matrix (\code{ed}), from \code{STATegRa_S1}, provides selected data downloaded from \url{https://tcga-data.nci.nih.gov/docs/publications/gbm_exp/}. The mapping between miRNA and mRNA (\code{mapdata}, available in \code{STATegRa_S2}) contains, as a processed matrix, selected information available from TargetScan; we selected the set of miRNA target predictions for humans for those miRNA-mRNA pairs where both miRNA and mRNA were in \code{Block1} and \code{Block2} respectively. 

The PCA version of the data (\code{Block1.PCA}, \code{Block2.PCA}, \code{ed.PCA}; available in \code{STATegRa_S3}), provides a similar data-set to \code{Block1}, \code{Block2} and \code{ed} data; however in this case the data has been processed in order to provide a pedagogic example of OmicsPCA. Results obtained from OmicsPCA (\code{\link{omicsCompAnalysis}}) with the existing data should not be taken as clinically valid.
}
\examples{
data(STATegRa_S1)
data(STATegRa_S2)
data(STATegRa_S3)
}
\author{
David Gomez-Cabrero, Patricia Sebastian-Leon, Gordon Ball
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/STATegRa_omicsPCA_methods.R
\name{omicsCompAnalysis}
\alias{omicsCompAnalysis}
\alias{omicsCompAnalysis,list,character,character,numeric,numeric-method}
\title{Components analysis for multiple objects}
\usage{
omicsCompAnalysis(Input, Names, method, Rcommon, Rspecific, 
                         convThres=1e-10, maxIter=600, center=FALSE, 
                         scale=FALSE, weight=FALSE)
}
\arguments{
\item{Input}{List of \code{ExpressionSet} objects, one for each block of data.}

\item{Names}{Character vector giving names for each Input object.}

\item{method}{Method to use for analysis (either "DISCOSCA", "JIVE", or "O2PLS").}

\item{Rcommon}{Number of common components between all blocks}

\item{Rspecific}{Vector giving number of unique components for each input block}

\item{convThres}{Stop criteria for convergence}

\item{maxIter}{Maximum number of iterations}

\item{center}{Character (or FALSE) specifying which (if any) centering will be applied before analysis. Choices are "PERBLOCKS" (each block separately) or "ALLBLOCKS" (all data together).}

\item{scale}{Character (or FALSE) specifying which (if any) scaling will be applied before analysis. Choices are "PERBLOCKS" (each block separately) or "ALLBLOCKS" (all data together).}

\item{weight}{Logical indicating whether weighting is to be done.}
}
\value{
An object of class \code{\link{caClass-class}}.
}
\description{
This function performs a components analysis of object wise omics data to understand the mechanisms that underlay all the data blocks under study (common mechanisms) and the mechanisms underlying each of the data block independently (distinctive mechanisms). This analysis include both, the preprocessing of data and the components analysis by using three different methodologies.
}
\examples{
data("STATegRa_S3")
B1 <- createOmicsExpressionSet(Data=Block1.PCA,pData=ed.PCA,
pDataDescr=c("classname"))
B2 <- createOmicsExpressionSet(Data=Block2.PCA,
                               pData=ed.PCA,pDataDescr=c("classname"))
# Omics components analysis
discoRes <- omicsCompAnalysis(Input=list(B1,B2),Names=c("expr","mirna"),
                              method="DISCOSCA",Rcommon=2,Rspecific=c(2,2),
                              center=TRUE,scale=TRUE,weight=TRUE)
jiveRes <- omicsCompAnalysis(Input=list(B1,B2),Names=c("expr","mirna"),
                             method="JIVE",Rcommon=2,Rspecific=c(2,2),
                             center=TRUE,scale=TRUE,weight=TRUE)
o2plsRes <- omicsCompAnalysis(Input=list(B1,B2),Names=c("expr","mirna"),
                              method="O2PLS",Rcommon=2,Rspecific=c(2,2),
                              center=TRUE,scale=TRUE,weight=TRUE)
}
\author{
Patricia Sebastian Leon
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/STATegRa_fused.R
\name{createOmicsExpressionSet}
\alias{createOmicsExpressionSet}
\alias{createOmicsExpressionSet,matrix-method}
\title{createOmicsExpressionSet}
\usage{
createOmicsExpressionSet(Data, pData = NULL, pDataDescr = NULL,
  feaData = NULL, feaDataDescr = NULL)
}
\arguments{
\item{Data}{Omics data}

\item{pData}{Data associated with the samples/phenotype}

\item{pDataDescr}{Description of the phenotypic data}

\item{feaData}{Data associated with the variables/features annotation}

\item{feaDataDescr}{Description of the feature annotation}
}
\value{
ExpressionSet with the data provided
}
\description{
This function allow to the user to create a ExpressionSet object from a matrix representing an omics dataset. It allows to include the experimental design and annotation in the ExpressionSet object.
}
\details{
In Data matrix, samples has to be in columns and variables has to be in rows
}
\examples{
data(STATegRa_S3)
B1 <- createOmicsExpressionSet(Data=Block1.PCA,pData=ed.PCA,
                               pDataDescr=c("classname"))
B2 <- createOmicsExpressionSet(Data=Block2.PCA,pData=ed.PCA,
                               pDataDescr=c("classname"))
}
\author{
Patricia Sebastian-Leon
}
\keyword{datagen}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/STATegRa_omicsPCA_plotting.R
\name{plotRes}
\alias{plotRes}
\alias{plotRes,caClass,numeric,character,character,logical-method}
\title{Plot component analysis results}
\usage{
plotRes(object, comps=c(1, 2), what, type, combined, block=NULL, 
               color=NULL, shape=NULL, labels=NULL, title=NULL, xlabel=NULL, ylabel=NULL, background=TRUE, 
               palette=NULL, pointSize=4, labelSize=NULL, 
               axisSize=NULL, titleSize=NULL, sizeValues = c(2,4), shapeValues = c(17, 0))
}
\arguments{
\item{object}{\code{\link{caClass-class}} containing component analysis results}

\item{comps}{If combined=FALSE, it indicates the x and y components of the type and block chosen. If \code{combined=TRUE}, it indicates the component to plot for the first block of information and the component for the second block of information to plot together. By default the components are set to c(1,2) if \code{combined=FALSE} and to c(1,1) if \code{combined=TRUE}.}

\item{what}{Either "scores", "loadings" or "both"}

\item{type}{Either "common", "individual" or "both"}

\item{combined}{Logical indicating whether to make a simple plot of two components from one block, or components from different blocks}

\item{block}{Which block to plot, either "1" or "2" or the name of the block.}

\item{color}{Character specifying a pData column from the original data to use to color points}

\item{shape}{Character specifying a pData column to select point shape}

\item{labels}{Character specifying a pData column from which to take point labels}

\item{title}{Main title}

\item{xlabel}{x-axis name}

\item{ylabel}{y-axis name}

\item{background}{Logical specifying whether to make a grey background}

\item{palette}{Vector giving the color palette for the plot}

\item{pointSize}{Size of plot points}

\item{labelSize}{Size of point labels if not NULL}

\item{axisSize}{Size of axis text}

\item{titleSize}{Size of title text}

\item{sizeValues}{Vector containing sizes for scores and loadings}

\item{shapeValues}{Vector indicating the shapes for scores and loadings}
}
\value{
\code{ggplot} object
}
\description{
Plot scatterplots of scores or loadings, for common and distinctive parts as well as combined plots.
}
\examples{
data("STATegRa_S3")
B1 <- createOmicsExpressionSet(Data=Block1.PCA,pData=ed.PCA,
                               pDataDescr=c("classname"))
B2 <- createOmicsExpressionSet(Data=Block2.PCA,
                               pData=ed.PCA,pDataDescr=c("classname"))
# Omics components analysis
discoRes <- omicsCompAnalysis(Input=list(B1,B2),Names=c("expr","mirna"),
                              method="DISCOSCA",Rcommon=2,Rspecific=c(2,2),
                              center=TRUE,scale=TRUE,weight=TRUE)
jiveRes <- omicsCompAnalysis(Input=list(B1,B2),Names=c("expr","mirna"),
                             method="JIVE",Rcommon=2,Rspecific=c(2,2),
                             center=TRUE,scale=TRUE,weight=TRUE)

o2plsRes <- omicsCompAnalysis(Input=list(B1,B2),Names=c("expr","mirna"),
                              method="O2PLS",Rcommon=2,Rspecific=c(2,2),
                              center=TRUE,scale=TRUE,weight=TRUE)

# Scatterplot of scores variables associated to common components

# DISCO-SCA
plotRes(object=discoRes,comps=c(1,2),what="scores",type="common",
        combined=FALSE,block=NULL,color="classname",shape=NULL,labels=NULL,
        background=TRUE,palette=NULL,pointSize=4,labelSize=NULL,
        axisSize=NULL,titleSize=NULL)
# JIVE
plotRes(object=jiveRes,comps=c(1,2),what="scores",type="common",
       combined=FALSE,block=NULL,color="classname",shape=NULL,labels=NULL,
        background=TRUE,palette=NULL,pointSize=4,labelSize=NULL,
        axisSize=NULL,titleSize=NULL)

# O2PLS
# Scatterplot of scores variables associated to common components
# Associated to first block
p1 <- plotRes(object=o2plsRes,comps=c(1,2),what="scores",type="common",
              combined=FALSE,block="expr",color="classname",shape=NULL,
              labels=NULL,background=TRUE,palette=NULL,pointSize=4,
              labelSize=NULL,axisSize=NULL,titleSize=NULL)
# Associated to second block
p2 <- plotRes(object=o2plsRes,comps=c(1,2),what="scores",type="common",
              combined=FALSE,block="mirna",color="classname",shape=NULL,
              labels=NULL,background=TRUE,palette=NULL,pointSize=4,
              labelSize=NULL,axisSize=NULL,titleSize=NULL)

# Combined plot of scores variables assocaited to common components
plotRes(object=o2plsRes,comps=c(1,1),what="scores",type="common",
        combined=TRUE,block=NULL,color="classname",shape=NULL,
        labels=NULL,background=TRUE,palette=NULL,pointSize=4,
        labelSize=NULL,axisSize=NULL,titleSize=NULL)

# Loadings plot for individual components
# Separately for each block
p1 <- plotRes(object=discoRes,comps=c(1,2),what="loadings",type="individual",
              combined=FALSE,block="expr",color="classname",shape=NULL,
              labels=NULL,background=TRUE,palette=NULL,pointSize=4,
              labelSize=NULL,axisSize=NULL,titleSize=NULL)
p2 <- plotRes(object=discoRes,comps=c(1,2),what="loadings",type="individual",
              combined=FALSE,block="mirna",color="classname",shape=NULL,
              labels=NULL,background=TRUE,palette=NULL,pointSize=4,
              labelSize=NULL,axisSize=NULL,titleSize=NULL)

# Biplot: scores + loadings
plotRes(object=discoRes,comps=c(1,2),what="both",type="common",
        combined=FALSE,block="expr",color="classname",shape=NULL,
        labels=NULL,background=TRUE,palette=NULL,pointSize=4,
        labelSize=NULL,axisSize=NULL,titleSize=NULL)
}
\author{
Patricia Sebastian-Leon
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/STATegRa_omicsCLUST_bioMap.R
\name{bioMap}
\alias{bioMap}
\title{bioMap}
\usage{
bioMap(name, metadata, map)
}
\arguments{
\item{name}{Name to assign the object}

\item{metadata}{A list with information of the mapping. Elements expected in the list are: (1) "type_v1" and "type_v2", refer to the nature of the features mapped; a vocabulary we recommend is "gene", "mRNA", "miRNA", "proteins", etc. (2) "source_database", provides information on the source of the mapping; from a specific data-base e.g. "targetscan.Hs.eg.db" to a genomic location mapping. (3) "data_extraction" stores information on the data the mapping was generated or downloaded.}

\item{map}{A data.frame object storing the mapping. The data.frame may inclue an unlimited number of columns, however the first column must be named "Var1" and refer to the elements of "type_v1" and simmilarly for the second column ("Var2", "type_v2").}
}
\value{
An object of class \code{bioMap}
}
\description{
Function to generate a bioMap object.
}
\examples{
data(STATegRa_S2)
map.gene.miRNA<-bioMap(name = "Symbol-miRNA",
                       metadata = list(type_v1="Gene",type_v2="miRNA",
                                       source_database="targetscan.Hs.eg.db",
                                       data_extraction="July2014"),
                       map=mapdata)
}
\author{
David Gomez-Cabrero
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/STATegRa_fused.R
\name{STATegRaUsersGuide}
\alias{STATegRaUsersGuide}
\title{STATegRaUsersGuide}
\usage{
STATegRaUsersGuide(view = TRUE)
}
\arguments{
\item{view}{Whether to open a browser}
}
\value{
The path to the documentation
}
\description{
Finds the location of the STATegRa User's Guide and optionally opens it.
}
\examples{
STATegRaUsersGuide(view=FALSE)
}
\author{
David Gomez-Cabrero
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/STATegRa_package.R
\name{STATegRa-defunct}
\alias{STATegRa-defunct}
\title{Defunct functions in STATegRa}
\description{
These functions have are defunct and no longer available
}
\details{
\itemize{
\item{holistOmics: replaced by \code{\link{omicsNPC}}}
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/STATegRa_omicsPCA_caClass.R
\name{getLoadings}
\alias{getLoadings}
\alias{getLoadings,caClass-method}
\title{Retrieve component analysis loadings}
\usage{
getLoadings(x, part=NULL, block=NULL)
}
\arguments{
\item{x}{\code{\link{caClass-class}} object.}

\item{part}{Character indicating whether "common" or "distinctive" loadings should be displayed}

\item{block}{Character indicating the block of data for which the loadings will be given. It can be specified by the position of the block ("1" or "2") or the name assigned in the \code{\link{caClass-class}} object. If it is NULL both blocks are displayed.}
}
\value{
A list containing the requested information.
}
\description{
Generic function to retrieve loadings (common and distinctive) found by \code{\link{omicsCompAnalysis}} on a \code{\link{caClass-class}} object.
}
\examples{
data("STATegRa_S3")
B1 <- createOmicsExpressionSet(Data=Block1.PCA, pData=ed.PCA,
                               pDataDescr=c("classname"))
B2 <- createOmicsExpressionSet(Data=Block2.PCA,
                               pData=ed.PCA, pDataDescr=c("classname"))
# Omics components analysis
res <- omicsCompAnalysis(Input=list(B1, B2), Names=c("expr", "mirna"),
                         method="DISCOSCA", Rcommon=2, Rspecific=c(2, 2),
                         center=TRUE, scale=TRUE, weight=TRUE)
getLoadings(res)
getLoadings(res, part="common", block="expr")
getLoadings(res, part="distinctive", block="expr")
}
\seealso{
\code{\link{omicsCompAnalysis}}, \code{\link{caClass-class}}
}
\author{
Patricia Sebastian-Leon
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/STATegRa_omicsPCA_plotting.R
\name{plotVAF}
\alias{plotVAF}
\alias{plotVAF,caClass-method}
\title{Plot VAF (Variance Explained For) from Component Analysis}
\usage{
plotVAF(object, mainTitle="")
}
\arguments{
\item{object}{\code{\link{caClass-class}} object containing component analysis results}

\item{mainTitle}{Plot title}
}
\value{
\code{ggplot} object
}
\description{
This function visualises the VAF results from component analysis. The input is a \code{\link{caClass-class}} object from \code{\link{omicsCompAnalysis}}. VAF cannot be calculated if mode "O2PLS" was used. The plots for modes "DISCOSCA" and "JIVE" are different since DISCO-SCA distinctive components have some VAF in the other block. This VAF can be interpreted as an error in the rotation.
}
\examples{
data("STATegRa_S3")
require(ggplot2)
B1 <- createOmicsExpressionSet(Data=Block1.PCA,pData=ed.PCA,
                               pDataDescr=c("classname"))
B2 <- createOmicsExpressionSet(Data=Block2.PCA,
                               pData=ed.PCA,pDataDescr=c("classname"))
# Omics components analysis
discoRes <- omicsCompAnalysis(Input=list(B1,B2),Names=c("expr","mirna"),
                              method="DISCOSCA",Rcommon=2,Rspecific=c(2,2),
                              center=TRUE,scale=TRUE,weight=TRUE)
jiveRes <- omicsCompAnalysis(Input=list(B1,B2),Names=c("expr","mirna"),
                             method="JIVE",Rcommon=2,Rspecific=c(2,2),
                             center=TRUE,scale=TRUE,weight=TRUE)

# DISCO-SCA plotVAF
plotVAF(discoRes)

# JIVE plotVAF
plotVAF(jiveRes)
}
\author{
Patricia Sebastian-Leon
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/STATegRa_omicsPCA_caClass.R
\name{getMethodInfo}
\alias{getMethodInfo}
\alias{getMethodInfo,caClass-method}
\title{Retrieve information about component analysis method}
\usage{
getMethodInfo(x, method=FALSE, comps=NULL, block=NULL)
}
\arguments{
\item{x}{\code{\link{caClass-class}} object.}

\item{method}{Logical indicating whether to return the method name.}

\item{comps}{Character indicating which component number to return ("common", "distinctive" or "all")}

\item{block}{Character indicating the block of data for which the component count will be given. It can be specified by the position of the block ("1" or "2") or the name assigned in the \code{\link{caClass-class}} object. If it is NULL both blocks are displayed.}
}
\value{
A list containing the requested information.
}
\description{
Generic function to retrieve information about the method used by \code{\link{omicsCompAnalysis}} on a \code{\link{caClass-class}} object.
}
\examples{
data("STATegRa_S3")
B1 <- createOmicsExpressionSet(Data=Block1.PCA, pData=ed.PCA,
                               pDataDescr=c("classname"))
B2 <- createOmicsExpressionSet(Data=Block2.PCA,
                               pData=ed.PCA, pDataDescr=c("classname"))
# Omics components analysis
res <- omicsCompAnalysis(Input=list(B1, B2), Names=c("expr", "mirna"),
                         method="DISCOSCA", Rcommon=2, Rspecific=c(2, 2),
                         center=TRUE, scale=TRUE, weight=TRUE)
getMethodInfo(res)
getMethodInfo(res, method=TRUE)
getMethodInfo(res, comps="all", block="expr")
}
\seealso{
\code{\link{omicsCompAnalysis}}, \code{\link{caClass-class}}
}
\author{
Patricia Sebastian-Leon
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/STATegRa_holistOmics.R
\name{holistOmics}
\alias{holistOmics}
\alias{holistOmics,list,character-method}
\title{HolistOmics an application of NPC on omics datasets}
\usage{
holistOmics(dataInput, dataTypes, comb.method = c("Fisher", "Liptak", "Tippett"),
               numPerm = 1000, numCores = 1, verbose = FALSE)
}
\arguments{
\item{dataInput}{List of ExpressionSet objects, one for each data modality.}

\item{dataTypes}{Character vector with possible values: 'RNA-seq', 'microarray'}

\item{comb.method}{Character vector with possible values: 'Fisher', 'Liptak',
'Tippett', if more than one is specified, all will be used.}

\item{numPerm}{Number of permutations}

\item{numCores}{Number of CPU cores to use}

\item{verbose}{Logical, if set to TRUE holistOmics prints out the step that it performs}
}
\value{
A data.frame
}
\description{
This function is defunct. Use omicsNPC instead.
}
\examples{
# Load the data
data("TCGA_BRCA_Batch_93")
# Setting dataTypes, the first two ExpressionSets include RNAseq data,
# the third ExpressionSet includes Microarray data.
dataTypes <- c("RNAseq", "RNAseq", "Microarray")
# Setting methods to combine pvalues
comb.method = c("Fisher", "Liptak", "Tippett")
# Setting number of permutations
numPerm = 1000
# Setting number of cores
numCores = 1
# Setting holistOmics to print out the steps that it performs.
verbose = TRUE
# Run holistOmics analysis.
# The output is a data.frame of p-values.
# Each row corresponds to a gene name. Each column corresponds to a method
# used in the analysis.
\dontrun{out <- holistOmics(dataInput = TCGA_BRCA_Data, dataTypes = dataTypes,
                            comb.method = comb.method, numPerm = numPerm,
                            numCores = numCores, verbose = verbose)}
}
\references{
Pesarin, Fortunato, and Luigi Salmaso. Permutation tests for complex data: theory, applications and software.
John Wiley & Sons, 2010.
}
\author{
Nestoras Karathanasis
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/STATegRa_omicsCLUST_bioDistW.R
\name{bioDistFeature}
\alias{bioDistFeature}
\alias{bioDistFeature,character,list,numeric-method}
\title{bioDistFeature}
\usage{
bioDistFeature(Feature, listDistW, threshold.cor)
}
\arguments{
\item{Feature}{Feature A selected as a reference.}

\item{listDistW}{A list of bioDistWclass objects. All the objects must contain the Feature A selected and all of them must contain the same set of features.}

\item{threshold.cor}{A threshold to select the features associated to Feature A}
}
\value{
Matrix with the associated features given the different weighted distances considered
}
\description{
Function that computes for a given selected feature the closest features given a selected set of weighted distances.
}
\examples{
data(STATegRa_S1)
data(STATegRa_S2)
require(Biobase)

# Truncate data for brevity
Block1 <- Block1[1:100,]
Block2 <- Block2[1:100,]

## Create ExpressionSets
mRNA.ds <- createOmicsExpressionSet(Data=Block1,pData=ed,pDataDescr=c("classname"))
miRNA.ds <- createOmicsExpressionSet(Data=Block2,pData=ed,pDataDescr=c("classname"))

## Create the bioMap  
map.gene.miRNA<-bioMap(name = "Symbol-miRNA",
                       metadata =  list(type_v1="Gene",type_v2="miRNA",
                                        source_database="targetscan.Hs.eg.db",
                                        data_extraction="July2014"),
                       map=mapdata)  

# Create Gene-gene distance computed through miRNA data
bioDistmiRNA<-bioDist(referenceFeatures = rownames(Block1),     
                      reference = "Var1",
                      mapping = map.gene.miRNA,
                      surrogateData = miRNA.ds,  ### miRNA data
                      referenceData = mRNA.ds,  ### mRNA data
                      maxitems=2,
                      selectionRule="sd",
                      expfac=NULL,
                      aggregation = "sum",
                      distance = "spearman",
                      noMappingDist = 0,
                      filtering = NULL,
                      name = "mRNAbymiRNA")

# Create Gene-gene distance through mRNA data
bioDistmRNA<-new("bioDistclass",
                 name = "mRNAbymRNA",
                 distance = cor(t(exprs(mRNA.ds)),method="spearman"),
                 map.name = "id",
                 map.metadata = list(),
                 params = list())

###### Generation of the list of Surrogated distances.

bioDistList<-list(bioDistmRNA,bioDistmiRNA)
sample.weights<-matrix(0,4,2)
sample.weights[,1]<-c(0,0.33,0.67,1)
sample.weights[,2]<-c(1,0.67,0.33,0)

###### Generation of the list of bioDistWclass objects.

bioDistWList<-bioDistW(referenceFeatures = rownames(Block1),
                       bioDistList = bioDistList,
                       weights=sample.weights)

###### Plot of distances.
bioDistWPlot(referenceFeatures = rownames(Block1) ,
             listDistW = bioDistWList,
             method.cor="spearman")
             
###### Computing the matrix of features/distances associated.

fm<-bioDistFeature(Feature = rownames(Block1)[1] ,
                   listDistW = bioDistWList,
                   threshold.cor=0.7)
bioDistFeaturePlot(data=fm)

}
\author{
David Gomez-Cabrero
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/STATegRa_omicsPCA_caClass.R
\name{getScores}
\alias{getScores}
\alias{getScores,caClass-method}
\title{Retrieve component analysis scores}
\usage{
getScores(x, part=NULL, block=NULL)
}
\arguments{
\item{x}{\code{\link{caClass-class}} object.}

\item{part}{Character indicating whether "common" or "distinctive" scores should be displayed}

\item{block}{Character indicating the block of data for which the scores will be given. It can be specified by the position of the block ("1" or "2") or the name assigned in the \code{\link{caClass-class}} object. If it is NULL both blocks are displayed.}
}
\value{
A list containing the requested information.
}
\description{
Generic function to retrieve scores (common and distinctive) found by \code{\link{omicsCompAnalysis}} on a \code{\link{caClass-class}} object.
}
\examples{
data("STATegRa_S3")
B1 <- createOmicsExpressionSet(Data=Block1.PCA, pData=ed.PCA,
                               pDataDescr=c("classname"))
B2 <- createOmicsExpressionSet(Data=Block2.PCA,
                               pData=ed.PCA, pDataDescr=c("classname"))
# Omics components analysis
res <- omicsCompAnalysis(Input=list(B1, B2), Names=c("expr", "mirna"),
                         method="DISCOSCA", Rcommon=2, Rspecific=c(2, 2),
                         center=TRUE, scale=TRUE, weight=TRUE)
getScores(res)
getScores(res, part="common")
getScores(res, part="distinctive", block="expr")
}
\seealso{
\code{\link{omicsCompAnalysis}}, \code{\link{caClass-class}}
}
\author{
Patricia Sebastian-Leon
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/STATegRa_omicsCLUST_bioDist.R
\name{bioDist}
\alias{bioDist}
\alias{bioDist,character,character,bioMap,ExpressionSet,ExpressionSet-method}
\title{bioDist}
\usage{
bioDist(referenceFeatures=NULL, reference=NULL, mapping=NULL, 
               referenceData=NULL, surrogateData=NULL, filtering=NULL, 
               noMappingDist=NA, distance="spearman", aggregation="sum", 
               maxitems=NULL, selectionRule="maxFC", expfac=NULL, 
               name=NULL, ...)
}
\arguments{
\item{referenceFeatures}{subset of features to be considered for the computation of the distances. If NULL then the features are first gathered from the features in referenceData. If referenceData is not provided then the list of features are gathered from mapping (bioMap class) and using the reference.}

\item{reference}{A character indicating the variable that is being used as features to compute distance between}

\item{mapping}{The mapping between feature types}

\item{referenceData}{ExpressionSet object with the data from the reference features.}

\item{surrogateData}{ExpressionSet object with the data from the surrogate features.}

\item{filtering}{A filtering for the bioMap class. To be implemented.}

\item{noMappingDist}{Distance value to be used when a reference feature do not map to any surrogate feature.  If "max", maximum indirect distance among the rest of reference features is taken. If NA, distance weights are re-scaled so this surrogate association is not considered. If a number then the missing values are replaces with that value.}

\item{distance}{Distance between features to be computed. Possible values are "pearson", "kendall", "spearman", "euclidean", "maximum", "manhattan", "canberra", "binary" and "minkowski". Default is "spearman".}

\item{aggregation}{Action to perform when a reference feature maps to more than one surrogate feature. Options are "max", "sum", "mean" or "median"  and the the values are aggregated according to the chosen statistic.}

\item{maxitems}{The maximum number of surrogate features per reference feature to be used, selected according to "selectionRule" parameter. Default is 2.}

\item{selectionRule}{Rule to select the surrogate features to be used (the number is determined by "maxitems"). It can be one of the following: (1)  "maxcor" those presenting maximum correlation with corresponding main feature; in this case "referenceData" must be provided and the columns must overlap in at least 3 samples; (2) "maxmean": average across samples is computed and those features with higher mean are selected;  case (3) is simmilar to (2) but considering other statistics: "maxmedian", "maxdiff", "maxFC", "sd" , "ee".}

\item{expfac}{Not in use yet.}

\item{name}{Character that describes the nature of the bioDist class computed}

\item{...}{extra arguments passed to \code{\link{dist}}, eg "p=value" for the power used if calculating minkowski distance}
}
\value{
An object of class \code{bioDistclass} containing distances between the features in \code{surrogateData}.
}
\description{
Function to compute a bioDistclass object from profile data and a mapping. For details of the process see the user's guide, but briefly the process involves using the mapping to identify reference features appropriate to each surrogate feature (if any), aggregating the surrogate data into pseudo-data for each reference feature, and then calculating the correlation distance between the reference features according to the surrogate data.
}
\examples{
data(STATegRa_S1)
data(STATegRa_S2)
require(Biobase)

# Truncate data for brevity
Block1 <- Block1[1:100,]
Block2 <- Block2[1:100,]

## Create ExpressionSets
mRNA.ds <- createOmicsExpressionSet(Data=Block1,pData=ed,pDataDescr=c("classname"))
miRNA.ds <- createOmicsExpressionSet(Data=Block2,pData=ed,pDataDescr=c("classname"))

## Create the bioMap  
map.gene.miRNA<-bioMap(name = "Symbol-miRNA",
                       metadata =  list(type_v1="Gene",type_v2="miRNA",
                                        source_database="targetscan.Hs.eg.db",
                                        data_extraction="July2014"),
                       map=mapdata)  

# Create Gene-gene distance computed through miRNA data
bioDistmiRNA<-bioDist(referenceFeatures = rownames(Block1),     
                      reference = "Var1",
                      mapping = map.gene.miRNA,
                      surrogateData = miRNA.ds,  ### miRNA data
                      referenceData = mRNA.ds,  ### mRNA data
                      maxitems=2,
                      selectionRule="sd",
                      expfac=NULL,
                      aggregation = "sum",
                      distance = "spearman",
                      noMappingDist = 0,
                      filtering = NULL,
                      name = "mRNAbymiRNA")

# Create Gene-gene distance through mRNA data
bioDistmRNA<-new("bioDistclass",
                 name = "mRNAbymRNA",
                 distance = cor(t(exprs(mRNA.ds)),method="spearman"),
                 map.name = "id",
                 map.metadata = list(),
                 params = list())

###### Generation of the list of Surrogated distances.

bioDistList<-list(bioDistmRNA,bioDistmiRNA)
sample.weights<-matrix(0,4,2)
sample.weights[,1]<-c(0,0.33,0.67,1)
sample.weights[,2]<-c(1,0.67,0.33,0)

###### Generation of the list of bioDistWclass objects.

bioDistWList<-bioDistW(referenceFeatures = rownames(Block1),
                       bioDistList = bioDistList,
                       weights=sample.weights)

###### Plot of distances.
bioDistWPlot(referenceFeatures = rownames(Block1) ,
             listDistW = bioDistWList,
             method.cor="spearman")
             
###### Computing the matrix of features/distances associated.

fm<-bioDistFeature(Feature = rownames(Block1)[1] ,
                   listDistW = bioDistWList,
                   threshold.cor=0.7)
bioDistFeaturePlot(data=fm)

}
\author{
David Gomez-Cabrero
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/STATegRa_omicsPCA_caClass.R
\name{getPreprocessing}
\alias{getPreprocessing}
\alias{getPreprocessing,caClass-method}
\title{Retrieve information about preprocessing}
\usage{
getPreprocessing(x, process=FALSE, preproData=FALSE, block=NULL)
}
\arguments{
\item{x}{\code{\link{caClass-class}} object.}

\item{process}{Logical indicating whether to return information about the processing done.}

\item{preproData}{Logical indicating whether to return the pre-processed data matrices.}

\item{block}{Character indicating the block of data to be returned. It can be specified by the position of the block ("1" or "2") or the name assigned in the \code{\link{caClass-class}} object. If it is NULL both blocks are displayed.}
}
\value{
If both \code{process} and \code{preproData} are specified, a list containing (otherwise the individual item):
\describe{
     \item{process}{Character indicating the processing done}
     \item{preproData}{Matrix (or list of matrices, depending on \code{block}) containing pre-processed data}
 }
}
\description{
Generic function to retrieve information about the preprocessing done by \code{\link{omicsCompAnalysis}} on a \code{\link{caClass-class}} object.
}
\examples{
data("STATegRa_S3")
B1 <- createOmicsExpressionSet(Data=Block1.PCA, pData=ed.PCA,
                               pDataDescr=c("classname"))
B2 <- createOmicsExpressionSet(Data=Block2.PCA,
                               pData=ed.PCA, pDataDescr=c("classname"))
# Omics components analysis
res <- omicsCompAnalysis(Input=list(B1, B2), Names=c("expr", "mirna"),
                         method="DISCOSCA", Rcommon=2, Rspecific=c(2, 2),
                         center=TRUE, scale=TRUE, weight=TRUE)
getPreprocessing(res, process=TRUE)
getPreprocessing(res, preproData=TRUE, block="1")
}
\seealso{
\code{\link{omicsCompAnalysis}}, \code{\link{caClass-class}}
}
\author{
Patricia Sebastian-Leon
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/STATegRa_omicsCLUST_bioDist.R
\name{bioDistclass}
\alias{bioDistclass}
\title{bioDistclass}
\usage{
bioDistclass(name, distance, map.name, map.metadata, params)
}
\arguments{
\item{name}{Name assigned to the object}

\item{distance}{Matrix giving the distance between features}

\item{map.name}{Charactering giving the name of the bioMap object used to compute the distance}

\item{map.metadata}{List of parameters used to generate the mapping}

\item{params}{List of parameters used to generate the distance}
}
\description{
Class to manage mappings between genomic features.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/STATegRa_omicsPCA_caClass.R
\name{getInitialData}
\alias{getInitialData}
\alias{getInitialData,caClass-method}
\title{Retrieve initial data from caClass objects}
\usage{
getInitialData(x, block=NULL)
}
\arguments{
\item{x}{\code{\link{caClass-class}} object.}

\item{block}{Character indicating the block of data to be returned. It can be specified by the position of the block ("1" or "2") or the name assigned in the \code{\link{caClass-class}} object. If it is NULL both blocks are displayed.}
}
\value{
The requested data block or blocks
}
\description{
Generic function to retrieve the initial data used for by \code{\link{omicsCompAnalysis}} from a \code{\link{caClass-class}} object
}
\examples{
data("STATegRa_S3")
B1 <- createOmicsExpressionSet(Data=Block1.PCA, pData=ed.PCA,
                               pDataDescr=c("classname"))
B2 <- createOmicsExpressionSet(Data=Block2.PCA,
                               pData=ed.PCA, pDataDescr=c("classname"))
# Omics components analysis
res <- omicsCompAnalysis(Input=list(B1, B2), Names=c("expr", "mirna"),
                         method="DISCOSCA", Rcommon=2, Rspecific=c(2, 2),
                         center=TRUE, scale=TRUE, weight=TRUE)
getInitialData(res)
getInitialData(res, block="expr")
}
\seealso{
\code{\link{omicsCompAnalysis}}, \code{\link{caClass-class}}
}
\author{
Patricia Sebastian-Leon
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/STATegRa_package.R
\docType{package}
\name{STATegRa}
\alias{STATegRa}
\alias{STATegRa-package}
\alias{STATegRa-package}
\title{STATegRa}
\description{
STATegRa is a package for the integrative analysis of multi-omic data-sets.

For full information, see the user's guide.
}
\seealso{
\code{\link{STATegRaUsersGuide}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/STATegRa_package.R
\docType{data}
\name{STATegRa_data_TCGA_BRCA}
\alias{STATegRa_data_TCGA_BRCA}
\alias{TCGA_BRCA_Data}
\title{STATegRa data}
\format{One list, which contains three ExpressionSet objects.}
\source{
See \url{https://tcga-data.nci.nih.gov/tcga/}.
}
\description{
Data were downloaded from TCGA data portal, \url{https://tcga-data.nci.nih.gov/tcga/}.
We downloaded sixteen tumour samples and the sixteen matching normal, for Breast invasive carcinoma, BRCA, batch 93.
Herein, three types of data modalities are included, RNAseq (\code{TCGA_BRCA_Data$RNAseq}), RNAseqV2 (\code{TCGA_BRCA_Data$RNAseqV2})
and Expression-Genes (\code{TCGA_BRCA_Data$Microarray}). The Data Level was set to Level 3.
For each data type, we pooled all data to one matrix, where rows corresponded to genes and columns to samples.
Only the first 100 genes are included.
}
\examples{
# load data
data(TCGA_BRCA_Batch_93)
}
\author{
Nestoras Karathanasis, Vincenzo Lagani
}
